cmh
cmh     FRAV.FOR (French and Ratcliff AVerages)
cmh
cmh     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cmh
cmh        Please, notify any bugs to:
cmh            horoi@theory.nscl.msu.edu
cmh
cmh     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cmh
CMH     THIS CODE CALCULATES THE AVERAGE VALUES OF THE FIRST
CMH     AND SECOND ORDER MOMENTUM OF THE HAMILTONIAN FOR A GIVEN
CMH     PARTITION (CONFIGURATION): 
CMH     E_c=<c|H|c> and sigma_c=SQRT(<c|(H-E_c)^2|c>.
CMH     sigma_c is calculated as an average over all intermediate
cmh     configurations or over a selected set of intermediate
cmh     configurations.
CMH*****************************************************************
CMH
CMH     SEE P.R. C3, PAGE 109-111 FRENCH & RATCLIFF
CMH
CMH**************************************************************
cmh     INPUTS are:
cmh      - the  name a file containing the partitions
cmh     (with the format of the .PAA(PAB) or PAC files created by OXBASH)
cmh     the partial sigma use this partitions as "selected"
cmh     intermediate configurations
cmh      - the code of the partition file (PAA, PAB or PAC)
CMH      - the name of the .SPS file
cmh      - the names of the interaction files which contains the
cmh      matrix elements and single particle energies (SPE).
cmh      - for every interaction file a norm of the SPE and of the
cmh      interaction matrix elements.
cmh     OUTPUT:
cmh      - E_c are in the file EM.OUT
cmh      - total sigma_c are in the file SI.OUT
cmh      - partial sigma_c are in the file SIP.OUT

cmh    MAX_NPART - maximum number of partitions.
       PARAMETER (MAX_NPART=1000)
cmh    MAX_NJL - maximum number of j orbits.
      parameter (max_njl=20)

CMH    MAX_NOSC - MAXIMUM NUMBER OF OSCILLATOR SHELLS
      parameter (max_nosc=6)

CMH    MAX_NSPS - MAXIMUM NUMBER OF S.P. M-STATES
      parameter (max_nsps=200)

cmh    These 4 parameters can be taken from shexe:param.inc
cmh    but are keeped local in this version

       DIMENSION EE(MAX_NJL),M(MAX_NJL,MAX_NPART),
     1    A(MAX_NJL,MAX_NJL,MAX_NJL,MAX_NJL),
     2    B(MAX_NJL,MAX_NJL,MAX_NJL,MAX_NJL)
       DIMENSION J2(MAX_NJL),J2S(MAX_NJL),
     1    AN(MAX_NJL),AM(MAX_NJL,4),MS(MAX_NJL)

        CHARACTER*15 PFN,pfil
       character*5 excod

      DIMENSION INT_VAR(30)
      REAL JZ,TZ,E_CUTOFF,ME_NORM,SPE_NORM 
      LOGICAL ISOSPIN
      COMMON/BAS/ NQU(MAX_NSPS),LQU(MAX_NSPS),JTW(MAX_NSPS), 
     1 MZTW(MAX_NSPS),ITZTW(MAX_NSPS),NSPS,ITZ,IMZ,LQ, 
     1IMZS,ITZS,KPAR,KTPAR,MAXT 


      COMMON/HNORM/NINT,SPE_NORM(9),XME_NORM(9)
 
      CHARACTER*9 intFILE,intfil,char_var(30)
      character*9 spsfil
      CHARACTER*13 NAME,intf,SPSF

      dimension intfil(10),real_var(30),enl(max_njl)

      logical read_err

      INCLUDE 'SHEXE:DATA.INC'

 

        WRITE(*,*)'ENTER PAR_FILENAME '
        READ(*,1)PFil
1       FORMAT(A15)
       write(*,*)'enter extension code (PAA, PAB or PAC)'
       read(*,255)excod
255       format(a5)
       indpf=index(pfil,' ')-1
       pfn=pfil(1:indpf)//'.'//excod
       write(*,*)pfn



1007  WRITE(6,4111)
4111   FORMAT(' Single-particle state file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      SPSFIL=CHAR_VAR(1)
      LONGS=INDEX(SPSFIL,' ')-1
      IF(ILOG)WRITE(6,702)SPSFIL(1:LONGS)
702   FORMAT('+',29X,A9,'.SPS')
      SPS2='.SPS'
      SPSF=SPSFIL(1:LONGS)//'.SPS'
 
      CALL OPENSPS(1,SPSF,0)
C
C  READ NO OF SP STATES ,NO OF J LEVELS, MAX NO OF
C  PARTICLES IN EACH LEVEL.
C
      CALL FREE_INT(1,30,INT_VAR,READ_ERR)
      NSPS=INT_VAR(1)
      NJL=INT_VAR(2)
      NOSC=INT_VAR(NJL+3)
      MIX_PARITY=0
      IF(NSPS.LT.0)THEN
      NSPS=-NSPS
      MIX_PARITY=1
      END IF
21001 FORMAT(I2)
 
      IF (NJL.GT.MAX_NJL) STOP ' ***** FATAL ERROR in MAIN : NJL.GT.MAX_
     1NJL
     1 *****'
      IF (NOSC.GT.MAX_NOSC) STOP ' ***** FATAL ERROR in MAIN :
     1 NOSC.GT.MAX_NOSC *****'
      IF(ILPT.GT.0)THEN
      END IF
1111  FORMAT(' EXTENDED NUMBER OF SINGLE PARTICLE CONFIGURATIONS
     1CALCULATION'/' NUMBER OF LONG WORDS = ',I1)
1003  FORMAT(
     1/' No. of m states     : ',I3,
     1/' No. of j levels     : ',I3,
CEKW     1/' No. of states/level : ',100I3)   ! FOR PBALL
     1/' No. of states/level : ',14I3,/,23X,14I3)
10031 FORMAT(
     1 ' No. of major shells : ',I3,
     1/' No. of levels/shell : ',100I3)
      CALL FREE_REAL_A(1,NJL,CHAR_VAR,0,REAL_VAR,READ_ERR)
cmh      DO 13001 I=1,NJL
cmh13001 SHELL(I)=CHAR_VAR(I)
CWEO      READ (1,5) (SHELL(I),I=1,NJL)
CWEO5     FORMAT(<NJL>A)
1006  FORMAT(/,1X,'Labels of j-levels',/,7(1X,A9))
C  READ IN QUANTUM NOS OF STATES
C  ORDERING: -VE M VALUES FIRST IN DECREASING ORDER OF MAGNITUDE
C  THEN +VE M VALUES  IN DECREASING ORDER OF MAGNITUDE
C  TZ=0.5 MUST IMMEDIATELY FOLLOW TZ=-0.5
CBAB      IF (ILPT.GT.0) WRITE(3,1009)
1009  FORMAT(/'    NUMBER         N         L        2J       2MZ
     1       2TZ',/)

      imax=0
      j2b=-1
       lbs=-1
       nbs=-1
      DO 610 NS=1,NSPS
C  NON IS A DUMMY VARIABLE JUST TO LABEL THE STATES ON THE FILE
C  IT IS NOT USED INTERNALLY
      CALL FREE_INT(1,6,INT_VAR,READ_ERR)
      NQU(NS)=INT_VAR(2)
      LQU(NS)=INT_VAR(3)
      JTW(NS)=INT_VAR(4)
      MZTW(NS)=INT_VAR(5)
      ITZTW(NS)=INT_VAR(6)

cmh
      if(jtw(ns).ne.j2b.or.nqu(ns).ne.nbs.or.lqu(ns).ne.lbs)then
      imax=imax+1
      j2(imax)=jtw(ns)
      j2b=jtw(ns)
       lbs=lqu(ns)
       nbs=nqu(ns)
      endif

1010  FORMAT(6I10)
610    CONTINUE
      CLOSE(UNIT=1)
 
      ISOSPIN=.TRUE.
      IF(ITZTW(1).EQ.ITZTW(2))ISOSPIN=.FALSE.
      NPTYPE='NONE'
      IF(.NOT.ISOSPIN)NPTYPE='ONE'
      IF(NOSC.EQ.2.AND..NOT.ISOSPIN)NPTYPE='BOTH'
 

       do 667 ie=1,njl
       ee(ie)=0.0
667       continue

      write(*,454)
454   format(11x,'N',11x,'j')

      do 666 i=1,imax
      write(*,*)i,j2(i)
666      continue

 
      i11 = 0
 
      IINT = 0
      WRITE(6,131)
131    FORMAT(' List of up to 9 interactions (*.OP files),
     1 <CR> to end list')
9914  CONTINUE
      IINT = IINT + 1
      WRITE(6,121) IINT
121    FORMAT(' Name of 2-body interaction #',I1,' : ')
CWEO      READ(5,9911)OPFILE
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      intfile=CHAR_VAR(1)
      IF(intFILE.EQ.' ') GO TO 9912
      WRITE(6,181)
181    FORMAT(' One and two body Hamiltonians normalisations (2F) : ')
      CALL FREE_REAL(5,2,REAL_VAR,READ_ERR)
      SPE_NORMI=REAL_VAR(1)
      XME_NORMI=REAL_VAR(2)
CWEO      READ(5,*)SPE_NORMI,ME_NORMI
CWEO9911  FORMAT(A,2F)
      IF(NINT.GT.9) WRITE(6,1500)
      IF(NINT.GT.9) STOP
1500  FORMAT(1X,'No more than 9 inputs are allowed')
      intfil(IINT) = intFILE
      SPE_NORM(IINT) = SPE_NORMI
      XME_NORM(IINT) = XME_NORMI
      IF(SPE_NORM(IINT).EQ.0)SPE_NORM(IINT)=1.
      IF(XME_NORM(IINT).EQ.0)XME_NORM(IINT)=1.
      IF(XME_NORM(IINT).EQ.-10.)XME_NORM(IINT)=0.
      IF(ILOG)WRITE(6,935)SPE_NORM(IINT),XME_NORM(IINT)
935   FORMAT('+',2F9.4)
      GO TO 9914
9912  CONTINUE
      NINT = IINT-1
      IF(NINT.EQ.0) WRITE(6,9915)
9915  FORMAT(1X,'ERROR: no interaction read in')
      IF(NINT.EQ.0) STOP






       SQ2=SQRT(2.0E0)




        OPEN(UNIT=1,FILE=PFN,STATUS='OLD')
        OPEN(UNIT=2,FILE='EM.OUT',STATUS='UNKNOWN')
        OPEN(UNIT=4,FILE='SI.OUT',STATUS='UNKNOWN')
        OPEN(UNIT=12,FILE='SIP.OUT',STATUS='UNKNOWN')


        KME=0

CMH       MAKE SURE THEAT A AND B MATRICES ARE PROPERLY INITIALAZED

       DO 222 I=1,IMAX
       DO 222 J=1,IMAX
       DO 222 K=1,IMAX
       DO 222 L=1,IMAX
       A(I,J,K,L)=0.0
       B(I,J,K,L)=0.0
222       CONTINUE


CMH       START LOOP ON THE .INT FILES
CMH       Build A & B interaction matrices - Eq. (97) from
CMH       Frech & Ratcliff o.c.

      do 333 ni=1,nint
      intf=intfil(ni)//'.int'


      CALL OPENINT(20+ni,AREA_SPS,AREA_INT,INTF,0,IERR)
      IF(IERR.EQ.1) WRITE(6,220)INTFIL
      IF(IERR.EQ.1) STOP
220   FORMAT(1X,'INTFIL = ',A9,' NOT FOUND')

CA ****  READ IN THE NO OF MATRIX ELEMENTS
CA ****  ORDER MUST BE AS DEFINED IN .SPS FILE
      

      CALL FREE_REAL(20+NI,NJL+1,REAL_VAR,READ_ERR)
      NMAT=INT(REAL_VAR(1))
      DO 14004 I=1,NJL
      ENL(I)=real_var(i+1)
       ee(i)=ee(i)+REAL_VAR(I+1)*spe_norm(ni)
14004 continue


      write(*,*)'NMAT',nmat
       write(*,*)'SPE :'      
      write(*,*)(enl(i),i=1,njl)

       vnorm=xme_norm(ni)
       vnorm2=vnorm*vnorm




10      READ(20+NI,*,END=11)I,J,K,L,IJ0,IT0,VME

95       format(1x,4i3,2i4,4(2x,e12.6))

        KME=KME+1
       CS1=1.0E0
       CS2=1.0E0
       IF(I.EQ.J)THEN
       CS1=SQ2
       CS12=2.0E0
       ENDIF
       IF(K.EQ.L)THEN
       CS2=SQ2
       CS22=2.       
       ENDIF
       PSP=(2.0E0*IJ0+1.0E0)*(2.0E0*IT0+1.0E0)
       ccpvv=CS1*CS2*PSP*VME*VNORM
       A(I,J,K,L)=A(I,J,K,L)+ccpvv
       B(I,J,K,L)=B(I,J,K,L)+CS12*CS22*PSP*VME**2*VNORM2

       IF(J.NE.I)
     1     A(J,I,K,L)=A(J,I,K,L)+ccpvv*PAR((J2(I)+J2(J))/2-IJ0+1-IT0)
       IF(K.NE.L)
     1     A(I,J,L,K)=A(I,J,L,K)+ccpvv*PAR((J2(K)+J2(L))/2-IJ0+1-IT0)

       IF(I.EQ.K.AND.J.EQ.L)GO TO 5
       IF(L.NE.K)
     1     A(L,K,I,J)=A(L,K,I,J)+ccpvv*PAR((J2(K)+J2(L))/2-IJ0+1-IT0)
       IF(J.NE.I)
     1     A(K,L,J,I)=A(K,L,J,I)+ccpvv*PAR((J2(I)+J2(J))/2-IJ0+1-IT0)

cmh       write(*,95)i,j,k,l,ij,it,vme,psp,a(i,j,k,l),b(i,j,k,l)
CMH       ENDIF
5       CONTINUE

       A(J,I,L,K)=A(I,J,K,L)*PAR((J2(I)+J2(J)-J2(K)-J2(L))/2)
       A(L,K,J,I)=A(I,J,K,L)*PAR((J2(I)+J2(J)-J2(K)-J2(L))/2)


       B(J,I,K,L)=B(I,J,K,L)
       B(I,J,L,K)=B(I,J,K,L)
       B(J,I,L,K)=B(I,J,K,L)

       B(L,K,I,J)=B(I,J,K,L)


       B(L,K,J,I)=B(I,J,K,L)

       A(K,L,I,J)=A(I,J,K,L)


       B(K,L,I,J)=B(I,J,K,L)
       B(K,L,J,I)=B(I,J,K,L)

       GO TO 10
11       CONTINUE
       
       CLOSE(UNIT=20+NI)

333       CONTINUE

CMH       OPEN(UNIT=20,FILE='VA.OUT',STATUS='UNKNOWN')

cmh       do 90 i=1,imax
cmh       do 90 j=1,imax
cmh       do 90 k=1,imax
cmh       do 90 l=1,imax
CMH       write(20,91)i,j,k,l,a(i,j,k,l)
cmh90       continue
91       format(1x,4i4,2(2x,e12.6))

CMH       CLOSE(UNIT=20)

cmh       calculate the maximum occupation for every j-orbit

       DO 6 I=1,IMAX
       AN(I)=2.*(J2(I)+1.0E0)
6       CONTINUE


       NPART=0

       KW=0

8       CONTINUE
       NPART=NPART+1
       IF(NPART.GT.MAX_NPART)THEN
       WRITE(*,*)'INCRASE MAX_NPART - MORE THAN ',MAX_NPART
       GO TO 1000
       ENDIF

cmh       start to read the partition file

       if(excod.eq.'PAC')go to 270


       READ(1,*,END=9)(M(I,NPART),I=1,IMAX)

       go to 271
270       continue

       READ(1,*,END=9)NP,NM,(M(I,NPART),I=1,IMAX)

271       continue

       NLP=NPART

cmh       calculate dispersion polynomials - Eq. (130) from
cmh       French & Ratcliff o.c.

       DO 20 I=1,IMAX
       AM(I,1)=M(I,NLP)/AN(I)
       AM(I,2)=AM(I,1)*(M(I,NLP)-1.0E0)/(AN(I)-1.0E0)
       AM(I,3)=AM(I,2)*(M(I,NLP)-2.0E0)/(AN(I)-2.0E0)
       AM(I,4)=AM(I,3)*(M(I,NLP)-3.0E0)/(AN(I)-3.0E0)
20       CONTINUE

       E1=0.0
       E2=0.0
       E3=0.0       

       S1=0.0
       S2=0.0
       S3=0.0
       S4=0.0
       S5=0.0
       S6=0.0
       S7=0.0
       S8=0.0
       S9=0.0
       S10=0.0
       S11=0.0
       S12=0.0
       S13=0.0
       S14=0.0
       S15=0.0
       S16=0.0
       S17=0.0
       S18=0.0
       S19=0.0

       S20=0.0
       S21=0.0
       S22=0.0
       S23=0.0
       S24=0.0
       S25=0.0
       S26=0.0
       S27=0.0
       S28=0.0

cmh       start to calculate the total sigma for every partition
cmh       Eq. (133) from French & Ratcliff o.c.

       DO 111 I=1,IMAX

       E1=E1+EE(I)*AN(I)*AM(I,1)
       E2=E2+A(I,I,I,I)*AM(I,2)

       ARRRR=A(I,I,I,I)**2/(AN(I)*(AN(I)-1.0E0))
       S1=S1+ARRRR*AM(I,2)
       S5=S5+ARRRR*AM(I,3)
       S12=S12+ARRRR*AM(I,4)

       S11=S11+B(I,I,I,I)*AM(I,4)



       DO 112 J=1,IMAX

       S6=S6+B(I,I,I,J)*AM(I,3)

       DO 113 K=1,IMAX
       S2=S2+B(I,I,J,K)*AM(I,2)
113       CONTINUE

       IF(I.NE.J)THEN

       IF(J2(I).EQ.J2(J))THEN
       SI1=AM(I,3)/AN(I)*A(I,I,I,J)**2
       S20=S20+SI1
       S24=S24+SI1*AM(J,1)
       S25=S25+AM(I,2)*AM(J,2)/AN(I)*A(I,I,I,J)*A(I,J,J,J)
       ENDIF

       E3=E3+A(I,J,I,J)*AM(I,1)*AM(J,1)

       ARSRS=A(I,J,I,J)**2/(AN(I)*AN(J))
       S3=S3+ARSRS*AM(I,1)*AM(J,1)
       S7=S7+ARSRS*AM(I,2)*AM(J,1)
       S16=S16+ARSRS*AM(I,2)*AM(J,2)

       S13=S13+B(I,I,I,J)*AM(I,3)*AM(J,1)
       S14=S14+B(I,I,J,J)*AM(I,2)*AM(J,2)
       S15=S15+B(I,J,I,J)*AM(I,2)*AM(J,2)

       DO 114 K=1,IMAX

       S8=S8+B(I,J,I,K)*AM(I,2)*AM(J,1)
       S9=S9+B(I,I,J,K)*AM(I,2)*AM(J,1)

       DO 120 L=1,IMAX
       S4=S4+B(I,J,K,L)*AM(I,1)*AM(J,1)
120       CONTINUE

       IF(K.NE.I.AND.J2(I).EQ.J2(K))
     1    S21=S21+AM(I,2)*AM(J,1)/AN(I)*A(I,I,I,K)*A(J,I,J,K)
       IF(K.NE.J.AND.J2(J).EQ.J2(K))
     1    S22=S22+AM(I,2)*AM(J,1)/AN(J)*A(I,J,I,K)**2


       IF(K.NE.I.AND.K.NE.J)THEN

       IF(J2(I).EQ.J2(J))THEN
       S26=S26+AM(K,2)*AM(I,1)*AM(J,1)/AN(I)*A(K,I,K,J)**2
       S27=S27+AM(I,2)*AM(J,1)*AM(K,1)/AN(I)*A(I,I,I,J)*A(K,I,K,J)
       ENDIF

       S17=S17+B(I,I,J,K)*AM(I,2)*AM(J,1)*AM(K,1)
       S18=S18+B(I,J,I,K)*AM(I,2)*AM(J,1)*AM(K,1)

       DO 115 L=1,IMAX
       S10=S10+B(I,J,K,L)*AM(I,1)*AM(J,1)*AM(K,1)

       IF(L.NE.K.AND.J2(L).EQ.J2(K))
     1    S23=S23+AM(I,1)*AM(J,1)*AM(K,1)/AN(K)*A(I,K,I,L)*A(J,K,J,L)

       IF(L.NE.I.AND.L.NE.J.AND.L.NE.K)THEN

       IF(J2(K).EQ.J2(L))THEN
       SI2=AM(I,1)*AM(J,1)*AM(K,1)/AN(K)*A(I,K,I,L)*A(J,K,J,L)
       S28=S28+SI2*AM(L,1)
       ENDIF

       S19=S19+B(I,J,K,L)*AM(I,1)*AM(J,1)*AM(K,1)*AM(L,1)
       ENDIF

115       CONTINUE

       ENDIF

114       CONTINUE

       ENDIF

112       CONTINUE
111       CONTINUE

cmh       average energy for every partition - Eq. (129) fromm F & R

       EM=E1+0.5*E2+0.5*E3

cmh       average sigma total for every partition - Eq. (133)

       SIGMA2=0.25*S2-0.5*S1+0.25*S4-0.5*S3+S5-0.5*S6+S7-S8-0.5*S9
     1         -0.5*S10+0.25*S11-0.5*S12+S13+0.25*S14+0.5*S15-0.5*S16
     2         +0.5*S17+S18+0.25*S19

cmh       SIGMHF is the Hartree-Fock contribution - terms proportional
cmh       with \hat{\delta}_{rs}

       SIGHF=S20+2.*S21+S22+S23-2.*S24-2.*S25-S26-4.*S27-S28
       SIGMA2=SIGMA2+SIGHF

       SIGMA=SQRT(SIGMA2)
CMH       WRITE(*,*)'SIGHF',SIGHF

CMH       WRITE(*,51)S20,S21,S22,S23,S24
CMH       WRITE(*,51)S25,S26,S27,S28
51       FORMAT(1X,6E12.5)


cmh        WRITE(*,50)NLP,NP,EM,SIGMA,SIGHF,(M(I,NLP),I=1,IMAX)
50       FORMAT(1X,I4,2X,I4,3(2X,E12.6),1X,15I3)


cmh        DO 44 I=1,NP
        KW=KW+1
       WRITE(4,*)KW,SIGMA
        WRITE(2,*)KW,EM
cmh44       continue



cmh       write(*,*)s1,s2,s3,s4
cmh       write(*,*)s5,s6,s7,s8
cmh       write(*,*)s9,s10,s11,s12
cmh       write(*,*)s13,s14,s15,s16
cmh       write(*,*)s17,s18,s19,s20
cmh       write(*,*)s21,s22,s23,s24
cmh       write(*,*)s25,s26,s27,s28

        GO TO 8

9       CONTINUE


CMH       start calculate partial sigma (sum on available
CMH       interamediate configurations) - Eqs. (135)-(140) F & R

       NPART=NPART-1
       DO 500 NLP=1,NPART

       DO 200 I=1,IMAX
       AM(I,1)=M(I,NLP)/AN(I)
       AM(I,2)=AM(I,1)*(M(I,NLP)-1.0E0)/(AN(I)-1.0E0)
       AM(I,3)=AM(I,2)*(M(I,NLP)-2.0E0)/(AN(I)-2.0E0)
       AM(I,4)=AM(I,3)*(M(I,NLP)-3.0E0)/(AN(I)-3.0E0)
       MS(I)=M(I,NLP)
200       CONTINUE

       T1=0.0
       T2=0.0
       T3=0.0
       T4=0.0
       T5=0.0
       T6=0.0
       T7=0.0
       T8=0.0
       T9=0.0
       T10=0.0
       T11=0.0
       T12=0.0
       T13=0.0
       T14=0.0
       T15=0.0
       T16=0.0

       DO 501 I=1,IMAX
       T1=T1+(AM(I,2)-2.0*AM(I,3)+AM(I,4))*(B(I,I,I,I)-2.0/
     1     (AN(I)*(AN(I)-1.0))*A(I,I,I,I)**2)

       DO 501 J=1,IMAX
       IF(I.EQ.J) GOTO 501
       T2=T2+(AM(I,1)*AM(J,1)-2.0*AM(I,2)*AM(J,1)+AM(I,2)*AM(J,2))
     1     *(B(I,J,I,J)-A(I,J,I,J)**2/(AN(I)*AN(J)))
501       CONTINUE

       DO 502 N1=1,NPART
       IF(N1.EQ.NLP)GO TO 502

       MSP=0
       MSN=0
       IR=0
       IQ=0
       IS=0
       IT=0
       IR1=0
       IQ1=0
       IS1=0
       IT1=0

       DO 300 I=1,IMAX
       MD=MS(I)-M(I,N1)
       IF(MD.EQ.0)GO TO 300
       IF(MD.LT.0)GO TO 310
       MSP=MSP+MD
       IF(MSP.GT.2) GO TO 502
       IF(MSP.EQ.1)THEN
       IR=I
       IR1=1
       ELSE
       IF(IR1.EQ.1)THEN
       IQ=I
       IQ1=1
       ELSE
       IR=I
       IR1=2
       ENDIF
       ENDIF
       GO TO 300

310       CONTINUE

       MSN=MSN-MD
       IF(MSN.GT.2)GOTO 502
       IF(MSN.EQ.1)THEN
       IS=I
       IS1=1
       ELSE
       IF(IS1.EQ.1)THEN
       IT=I
       IT1=1
       ELSE
       IS=I
       IS1=2
       ENDIF
       ENDIF

300       CONTINUE

       IF(MSP-MSN.NE.0)GO TO 502

cmh       WRITE(*,700)MSP,IR,IQ,IS,IT,IR1,IQ1,IS1,IT1
700       FORMAT(1X,I3,4X,2(4I3,2X))

       IF(IR1.EQ.1.AND.IS1.EQ.1.AND.IQ1.EQ.0.AND.IT1.EQ.0)THEN
       T3=T3+(AM(IR,2)-AM(IR,3))*(1.0-AM(IS,1))*B(IR,IR,IR,IS)
       T4=T4+AM(IR,1)*(AM(IS,1)-2.0*AM(IS,2)+AM(IS,3))*B(IR,IS,IS,IS)

       DO 301 ITT=1,IMAX
       IF(ITT.NE.IR.AND.ITT.NE.IS)THEN
       T8=T8+AM(IR,1)*(1.0-AM(IS,1))*(AM(ITT,1)-AM(ITT,2))*
     1    B(IR,ITT,IS,ITT)
       ENDIF
301       CONTINUE

       IF(J2(IR).EQ.J2(IS))THEN
       T5=T5+AM(IR,2)*(AM(IS,1)-AM(IS,2))*A(IR,IR,IR,IS)*A(IR,IS,IS,IS)
     1     /AN(IR)
       T6=T6+AM(IR,3)*(1.-AM(IS,1))*A(IR,IR,IR,IS)**2/AN(IR)
       T7=T7+AM(IR,1)*(AM(IS,2)-AM(IS,3))*A(IR,IS,IS,IS)**2/AN(IR)

       DO 302 ITT=1,IMAX
       IF(ITT.EQ.IR.OR.ITT.EQ.IS)GO TO 302
       T9=T9+AM(IR,1)*(AM(IS,1)-AM(IS,2))*AM(ITT,1)*A(IR,IS,IS,IS)*
     1     A(IR,ITT,IS,ITT)/AN(IR)
       T10=T10+AM(IR,2)*(1.-AM(IS,1))*AM(ITT,1)*A(IR,IR,IR,IS)*
     1      A(IR,ITT,IS,ITT)/AN(IR)
       T11=T11+AM(IR,1)*(1.-AM(IS,1))*AM(ITT,2)*A(IR,ITT,IS,ITT)**2
     1      /AN(IR)
       DO 302 IUU=1,IMAX
       IF(IUU.EQ.IR.OR.IUU.EQ.IS.OR.IUU.EQ.ITT)GO TO 302
CMH       IF(IUU.EQ.IR.OR.IUU.EQ.IS)GO TO 302
       T12=T12+AM(IR,1)*(1.-AM(IS,1))*AM(ITT,1)*AM(IUU,1)/AN(IR)
     1      *A(IR,ITT,IS,ITT)*A(IR,IUU,IS,IUU)
302       CONTINUE

       ENDIF
       ENDIF

       IF(IR1.EQ.2.AND.IS1.EQ.2)THEN
       T13=T13+AM(IR,2)*(1.-2.*AM(IS,1)+AM(IS,2))*B(IR,IR,IS,IS)
       ENDIF

       IF(IR1.EQ.2.AND.IS1.EQ.1.AND.IT1.EQ.1)THEN
       T14=T14+AM(IR,2)*(1.-AM(IS,1))*(1.-AM(IT,1))*B(IR,IR,IS,IT)
       ENDIF

       IF(IR1.EQ.1.AND.IQ1.EQ.1.AND.IS1.EQ.2)THEN
       T15=T15+AM(IR,1)*AM(IQ,1)*(1.-2.*AM(IS,1)+
     1     AM(IS,2))*B(IR,IQ,IS,IS)
       ENDIF

CMH       WRITE(*,77)IR1,IQ1,IS1,IT1,IR,IQ,IS,IT
77       FORMAT(1X,4I3,4X,4I3)

       IF(IR1.EQ.1.AND.IQ1.EQ.1.AND.IS1.EQ.1.AND.IT1.EQ.1)THEN
       T16=T16+AM(IR,1)*AM(IQ,1)*(1.-AM(IS,1))*(1.-AM(IT,1))*
     1      B(IR,IQ,IS,IT)
       ENDIF

502       CONTINUE

CMH       SIG2=0.25*(T1+T13)+0.5*(T14+T15)+T16+0.5*(T2+T3+T4)+
CMH     1       T6+T7+T8+T11+T12+2.0*(T5+T9+T10)
       SIGHF=T6+T7+T11+T12+2.0*(T5+T9+T10)
       SIG2=0.25*(T1+T13)+0.5*(T14+T15)+T16+0.5*(T2+T3+T4)+
     1       T8
       SIG2=SIG2+SIGHF
       SIG=SQRT(SIG2)
cmh       WRITE(*,*)NLP,'  SIG2,SIG ',SIG2,SIG,SIGHF
       WRITE(12,*)NLP,SIG

cmh       IF(NLP.EQ.41)THEN
cmh       WRITE(*,*)T1,T2,T3,T4,78
CMH       WRITE(*,51)T5,T6,T7
CMH       WRITE(*,51)T9,T10,T11,T12
cmh       WRITE(*,*)T13,T14,T15,T16
cmh       DO 800 IK=1,IMAX
cmh       WRITE(*,*)(AM(IK,IJ),IJ=1,4)
cmh800       CONTINUE
cmh       ENDIF

500       CONTINUE
       


1000       CONTINUE
        CLOSE(UNIT=1)
        CLOSE(UNIT=2)
CMH        CLOSE(UNIT=3)
        CLOSE(UNIT=4)
        CLOSE(UNIT=12)

       write(*,888)
888       format(//,2x,'Find output in: ',/,4x,
     1   'EM.OUT  - average energies - Eq. 129 from F & R',/,4x,
     2   'SI.OUT  - total sigma  - Eq. 133 from F & R',/,4x,
     3   'SIP.OUT - partial sigma - Eqs. 135-140 from F & R')

       END





       FUNCTION PAR(N)
       M=N
       IF(N.GT.0)M=-N
       PAR=1.-2.*MOD(M,2)
       RETURN
       END
