C   SHELL MODEL PROGRAM :   THIS PROGRAM PROJECTS OUT A BASIS WITH GOOD J AND T
C   FROM THE M-SCHEME BASIS, THE RESULT IS A MATRIX <M1/PJT/M2>
C   ONLY ONE PARTITION NEEDS TO BE IN CORE AT A TIME
C   COEF0 STORES THE COEFFICIENTS OF THE PROJECTED WAVEFUNCTION AT EACH STAGE
CA  I.E. AFTER PROJECTING OUT EVERY SINGLE NOT WANTED J-VALUE
C   COEF  HOLDS RESULTS AFTER J-J+ OPERATION ON COEF0. AT THE FINAL STAGE, WHEN
CA  COMPLETE PJT-PROJECTION HAS BEEN APPLIED, THE RESULT IS RETURNED TO THE 
C   MAIN IN COEF0
C   CLEANED-UP NOV-81
CA  SEE BASCOM.FOR FOR DETAILS OF CONSTANTS IN PARAMETER STATEMENTS

      PARAMETER (MAX_ORTHOG=(MAX_PRED*(MAX_PRED+1))/2) 
C      PARAMETER (MAX_STORE=7000,MAX_TTORE=100000) 
      PARAMETER (MAX_STORE=15000,MAX_TTORE=1000000) 
CBAB      PARAMETER (MAX_STORE=5000,MAX_TTORE=100000) 
C      PARAMETER (NUNIT20=200,MAX_LININDP=200000)
C      PARAMETER (NUNIT20=200,MAX_LININDP=1000000)
C      PARAMETER (NUNIT20=200,MAX_LININDP=10000000)
      PARAMETER (NUNIT20=200)
C   MAX_LININDP MOVED TO PARAM.INC (MAY 1995)
CVAX      PARAMETER (NUNIT20=200,MAX_LININDP=500000)
CA  MAX_IPROT   = MAXIMUM NO. OF PROTON PARTITIONS FOR A GIVEN PARTITION
CA  MAX_MSCHEME = MAXIMUM M-SCHEME BASIS DIMENSION FOR A GIVEN PARTITION
CA  MAX_STORE   = MAXIMUM NO. OF PROJECTION COEFFIENTES ALLOWED IN JMJP. 
CA  MAX_LININDP = MAX NO. OF PREVIOUS GOOD |JT> VECTORS STORE IN MEMORY FOR
CA                 LINEAR INDEPENDENCE CHECK
CA  EACH PARTITION IS PROJECTED ONLY ONCE AND RESULTS STORED IN ARRAYS.
CA  MAX_TTORE AND MAX_LININDP CAN BE REDUCED ARBITRARILY AND THE 
CA  COEFFICIENTS THAT CAN NOT BE STORED ON MEMORY WILL BE WRITTEN ONTO DISK.

CA  DOUBLE PRECISION TO PREVENT ROUNDING ERRORS WHILE PROJECTING
CBAB MOVED TO REAL.INC IN FEB 1988
CBAB      DOUBLE PRECISION COEF0,COEF,COEF_JP,SING,DEN,TEM,TEMP,TEMP2, 
CBAB     1SQDJ,SQDT,FACP,COEFK,COEFJ,COEFI,COEF0_LIN2,COEF0_LIN1,ORTHOG 
CBAB      REAL*8 ORTHOG 
      DOUBLE PRECISION ORTHOG 
      CHARACTER*4 BAS2,PRJ2,RED2 
      CHARACTER*9 BASFIL,PRJFIL,SHELL,BASFILP 
      CHARACTER*13 BASF,PRJF,SPSF,REDF 
      CHARACTER*9 CHAR_VAR(30)
      COMMON/INTV/ INT_VAR(30),REAL_VAR(30)
      LOGICAL READ_ERR,ILOG
      LOGICAL JMJP_FLAG,TMTP_FLAG
      INTEGER TPLUS,TMIN,JTWSS(MAX_NSPS),HANDLE,SPART, 
     1ZERO,RESULT,WOTPT,SUM_NPJ 
      REAL NLILIM,NRMLIM,LIMIT,JSING 
      LOGICAL IPROT_BYTE(MAX_MSCHEME)
      LOGICAL RET_STATUS 
      COMMON/CBAS1/ IBASIS(MAX_NLWRDS,MAX_MSCHEME), 
     1IBASISP(MAX_NLWRDS,MAX_MSCHEME),NIPART,ILOG 
      COMMON/CCOP/ COEF(MAX_MSCHEME),COEF0(MAX_MSCHEME), 
     1COEF0_LIN1(MAX_LININDP),COEF_JP(MAX_MSCHEME), 
     1IPROT(N_WORDS,MAX_MSCHEME),IPROT_BYTE 
      COMMON/CMATX/PRJFIL,PRJ2,BASFIL,BAS2,SPSF,SHELL(MAX_NJL),
     1REDF,RED2,BASFILP
      COMMON/MATX/ITT,NHPART,NDIMJ,NDIMT,NJL,NPJ(MAX_NJL), 
     1IORD(MAX_NPART),NDIMA(MAX_NPART),NBLOCK(MAX_NPART), 
     1IORDP(MAX_NPART),NDIMAP(MAX_NPART),NBLOCKP(MAX_NPART), 
     1NJTP(MAX_NPART),IMZS,ITZS,NREAD,NJZP1,ILEFT,KPAR, 
     1KTPAR,MATDIM,ILPT,IROU,IDEV,JAY, 
     1IMZSA,ITZSA,MAXJZ,MAXTZ,NJT 
      COMMON/INNER/ NDIMII,NDM2II,NSPS,IMAX,NSPSW,NPTCL, 
     1NWOTPT,WOTPT(N_WORDS),IPART(N_WORDS,MAX_NPART) 
      COMMON/TPTM/ TPLUS(MAX_NSPS),TMIN(MAX_NSPS) 
      COMMON/JPJM/JPLUS(MAX_NSPS),FACP(2*MAX_NSPS),NDIMP,NDM2P 
      COMMON/PRJ/ NPRJM,PJLIM,IBP,JMJP_FLAG,TMTP_FLAG,LONGP, 
     1ITZTW(MAX_NSPS) 
      COMMON/BASCOM/NLWRDS,ZERO(MAX_NLWRDS),RESULT(MAX_NLWRDS), 
     1MASK(MAX_NLWRDS) 
      COMMON/DENS/JAYSQ4,ITTSQ4,ITZSQ4,IMZSQ4,SUM_NPJ(0:MAX_NJL) 
      COMMON/PATP/IPARTN(N_WORDS),IPATRN(MAX_NLWRDS),MREADBAS, 
     1NP_DIFF(N_WORDS,MAX_IPROT),NDIFFM,MXFIL(MAX_NJL) 
      COMMON/TIME/JMJP0_TIME,JMJP1_TIME,JMJP2_TIME,HANDLE,
     1ORTHOG(MAX_ORTHOG) 
      COMMON/CMAC/IMAC 
      COMMON/LIN2/ COEF0_LIN2(MAX_MSCHEME) 
C      EQUIVALENCE (COEF0_LIN2(1),COEF0(1)) 
