C  SHELL MODEL PROGRAM 
C  THIS PROGRAM CALCULATES OVERLAPS BETWEEN SHELL MODEL WAVEFUNCTIONS
C  THESE CAN BE FOR DIRECT OVERLAPS, FOR WEAK COUPLING BETWEEN A CORE AND 
C  CLUSTER, FOR 1- OR 2-PARTICLE PARENTAGE AMPLITUDES,
C  OR ONE OR TWO-BODY TRANSITION DENSITIES
C
C  FOR DEFINITIONS AND PHASE CONVENTIONS SEE BOHR & MOTTELSON P.86 & P.422,423
C  EXCEPT J1 -> J2, J2 -> J1 IN 1A-85 & 1A-86
C
C  CODE :    NUCLEAR STATE  =  1
C          CLUSTER STATE  =  2 
C          CORE    STATE  =  3 
C
C            EXCEPT FOR 1-, 2-PARTICLE PARENT.AMPL., WHERE CORE = 2
C          AND TRANSITION DENSITIES, WHERE FINAL STATE=1, INITIAL STATE=2 
C            AND OPERATOR IS 3.
C
C  DEVICES:
C       1  TRD FILE  OR  TBD FILE  (OUTPUT) 
C       21  BASF1 
C       22  BASF2 
C       23  BASF3 
C       24  "TEMP" 
C       25  EFIL1    OR  VECF1 
C       26  VECF2 
C       27  VECF3          OR  OP2FIL 
C       28  EFIL2 
C
C
C
CWAR MAX_STORE CHANGED FOR FPV CALC A=48 NOV 15,1987
CBABCWEO      PARAMETER (MAX_STORE=1000000,MAX_ENTRY=50000)
CWEO      PARAMETER (MAX_STORE=1000000,MAX_ENTRY=500000)
CWEO MAX_STORE INCRESED FOR FPBP CALC OF A=46 OVERLAPS NOV. 6, 1991
      PARAMETER (MAX_NPART3=5000)
cSK	max_entry increased to 500000, 26/11/97. May not be enough....
      PARAMETER (MAX_STORE=0,MAX_ENTRY=500000)
CBAB      PARAMETER (MAX_EIG_IN_MVEC=500,MAX_OLAP=2000) 
CBAB CHANGED MAX_OLAP FROM 2000 TO 6000 FOR SDPF SPACE
CBAB      PARAMETER (MAX_EIG_IN_MVEC=500,MAX_OLAP=6000) 
CBAB CHANGES MAX_OLAP FROM 6000 TO 8000 FOR HFPI SPACE
CBAB      PARAMETER (MAX_EIG_IN_MVEC=1500,MAX_OLAP=40000) 
      PARAMETER (MAX_EIG_IN_MVEC=1500,MAX_OLAP=120000) 
      PARAMETER (MAX_OPERATOR=2200,MAX_NW=500)
CA  MAX_BASIS = MAX_MSCHEME in PROJ and BASIS.
      PARAMETER (MAX_BASIS=MAX_MSCHEME)
      CHARACTER*13 BASF1,BASF2,BASF3,SPSF,SPSF1,TRMPF,BASF,PRJF,VECF, 
     1REDF,EIGF,OP2F 
      CHARACTER*9 TRMPFL,LPTFIL,BASFIL,INTFIL,SPSFIL 
      CHARACTER*9 GNDFIL,EIGFIL,VECFIL,OP2FIL,EFIL1,EFIL2,EFIL3,SHELL 
      CHARACTER*9  EFIL,BASFL1,MATFIL,ORTFIL 
      CHARACTER*4 BAS2,GND2,EIG2,VEC2,TRMP2,OP22,TRMP2Z
      CHARACTER*9 CHAR_VAR(30)
      COMMON/INTV/ INT_VAR(30),REAL_VAR(30)
      LOGICAL READ_ERR,ILOG
      DOUBLE PRECISION CLEB,FN 
      INTEGER IADR1,IADR2,IADR3 
      LOGICAL USE_STORE 
      COMMON/STORE/USE_STORE,IENTRY,KSTORE,IADR1(0:MAX_STORE), 
     1      IADR2(0:MAX_STORE),IADR3(0:MAX_STORE), 
     1      ISTART(MAX_ENTRY),IFIN(MAX_ENTRY) 
      INTEGER ZERO,ZEROP 
      COMMON/SPC/ IDIAG,
     1 ISPEC,ICALL,IP3,JAY1,JAY2,JAY3,ITT1,ITT2,ITT3, 
     1     IMZS1,IMZS2,IMZS3,ITZS1,ITZS2,ITZS3,KPAR1,KPAR2,KPAR3, 
     1     NLAP,NPART3,NJL1,NSPS2, 
     2     IPART3(N_WORDS,MAX_NPART3),NDIMA3(MAX_NPART3), 
     3     NPJ1(MAX_NJL),NQU(MAX_NJL),LQU(MAX_NJL),JTW(MAX_NJL), 
     4     MZTW(MAX_NSPS),ITZTW(MAX_NSPS),JLST(MAX_NJL) 
      COMMON/NV/ NV1,NV2,NV1MIN,NV2MIN,ELEV1(MAX_EIG_IN_MVEC), 
     1     ELEV2(MAX_EIG_IN_MVEC),GNDE1,GNDE2,NPTCL1,NPTCL2
      COMMON/CRSS/ NDIM2,NDIM3,NBIT1,NSHIFT,ILAP,IOBTD 
      COMMON/IBS/IBAS1(MAX_NLWRDS,MAX_BASIS),IBAS2(MAX_NLWRDS,MAX_BASIS)
     1, 
     1     IBAS3(MAX_NLWRDS,MAX_BASIS),IBAS4(MAX_NLWRDS,MAX_BASIS) 
      COMMON/CF/COEF1(MAX_BASIS),COEF2(MAX_BASIS),COEF3(MAX_BASIS), 
     1     COEF4(MAX_BASIS) 
      COMMON/OL/OLAP(MAX_OLAP),OLAS(MAX_OLAP) 
      DIMENSION OLA(MAX_OLAP)
      COMMON/CHEAD/LPTFIL,BASFIL,INTFIL 
      COMMON/HEAD /ICNTL,ICASE,ICNTL2,NPTCL,JAY,IMZS,ITT,ITZS,KPAR, 
     1     MNFIL(MAX_NJL),MXFIL(MAX_NJL),MXOSC(MAX_NOSC), 
     1     MNOSC(MAX_NOSC),NOSC,NOSCJL(MAX_NOSC),GNDE 
      COMMON/CRAC/ IA,IB,IC,ID,IE,IF,CLEB 
      COMMON/SPE/ISHELL,NJL,ENL(MAX_NJL),ANSSPE 
      COMMON/NAMES/EIGFIL,EIG2,TRMPFL,TRMP2,GNDFIL,GND2, 
     1     SHELL(MAX_NJL),EFIL1,EFIL2,SPSFIL,OP2FIL,OP22 
      COMMON/MAN2/ ISIZE4,ILPT,NSTORE,ISTORE,IPV1,IPV2, 
     1     MDIM1,MDIM2,NDEPTH,MATDIM 
      COMMON/MAN/ ISIZE1,ISIZE2,ISIZE3,NJTP1(MAX_NPART),NJTP2(MAX_NPART)
     1, 
     1     NJTP3(MAX_NPART3) 
      COMMON/DISK/ NREC,IDISK(3,MAX_NPART3),NRECS(3),IDEV(4),NVMIN(3) 
      COMMON/PFIND/ NPART1,NPT12,II1,IPART(N_WORDS), 
     1     NDIM1,NDIM12,IB1,ILOOK,IPART1(N_WORDS,MAX_NPART) 
      COMMON/IREV/ IREV2,IREV3,IBSIS,ICPL,IMOVE(MAX_NSPS),NSPS1,IGO 
      COMMON/TB/REDFAC,NWMAX,ISWOP,IT12,IT34 
      COMMON/EQUIV/WFN(MAX_OPERATOR),IPOSL(MAX_OLAP),TMASK,ZEROP(N_WORDS
     1) 
      COMMON/BASCOM/NLWRDS,ZERO(MAX_NLWRDS),IPART2(N_WORDS,MAX_NPART) 
CBAB CNVEC ADDED AUG 1987 SO THAT SPEC KNOWS WHEN TO WRITE OUT SUMS
      COMMON/CNVEC/NVEC1,NVEC2,NVEC3
      EQUIVALENCE (VECFIL,EIGFIL),(EIG2,VEC2) 
      EQUIVALENCE (OLA(1),OLAP(1)) 
