C   EVALUATION OF TALMI INTEGRALS FOR A GERNERL FORCE
CBAB see T.A.Brody, G.Jacob and M.Moshinsky, Nucl. Phys. 17, 16 (1960)
CBAB and T.A.Brody and M.Moshinshy, Tables of Transformation Brackets
CBAB and R.D.Lawson, Theory of the Nuclear Shell Model
CBAB based on original program by D.J.Millener
      FUNCTION TALMI(N,TH,DELR,RMAX,ATYPE)
      DOUBLE PRECISION X1
      CHARACTER*3 ATYPE
CBAB ATYPE = YU0 FOR CENTRAL OBEP
CBAB ATYPE = YU1 FOR SPIN-ORBIT OBEP
CBAB ATYPE = YU2 FOR TENSOR OBEP
CBAB ATYPE = R2Y FOR R**2 YUKAWA 
CBAB ATYPE = GAU FOR GAUSSIAN
CBAB ATYPE = CON FOR CONSTANT
CBAB ATYPE = COU FOR 1/R
      DIMENSION SUM(1000)
      NBMAX = RMAX/DELR
      IF(NBMAX.GT.1000) TYPE 100
      IF(NBMAX.GT.1000) STOP
100   FORMAT(1X,'INCREASE DIMENSION OF "SUM" IN FUNCTION TALMI')
      DIF=DELR
      SUM(1)=0.
      IP=N
      XIP = IP
      KP=2*IP+1
      RX=0.
      DO 15 NB=2,NBMAX
      RX=RX+DIF
CBAB      X1 = RX**(2*IP+2)*EXP(-RX*RX)  ! CHANGED TO PREVENT OVERFLOWS
      X1 = RX**(0.25+XIP/4.)*EXP(-RX*RX/8.)
      X1 = X1**8.
      XX = RX*TH
      X2 = 0.
      IF(ATYPE.EQ.'YU0') X2 = EXP(-XX)/XX
CBAB CHANGE MADE JAN 23 1987
CBAB      IF(ATYPE.EQ.'YU1') X2 = (1.+1./XX)*EXP(-XX)/XX
      IF(ATYPE.EQ.'YU1') X2 = (1.+1./XX)*EXP(-XX)/(XX*XX)
      IF(ATYPE.EQ.'YU2') X2 = (1.+(3./XX)+(3./(XX*XX)))*EXP(-XX)/XX 
      IF(ATYPE.EQ.'R2Y') X2 = XX*XX*EXP(-XX)/XX 
      IF(ATYPE.EQ.'GAU') X2 = EXP(-XX*XX)
      IF(ATYPE.EQ.'CON') X2 = 1.
      IF(ATYPE.EQ.'COU') X2 = 1./XX
      SUM(NB)=X1*X2
 15   CONTINUE
      TALMI=SUMM6(1,NBMAX,SUM,DIF)
      PI = 3.14159
      TB=(2.)**(IP+2)/(SQRT(PI)*DFAC(2.*XIP+1.))
      TALMI=TB*TALMI
      RETURN
      END

      FUNCTION SUMM6(MIN,MAX,SUM,DIF)
      DIMENSION SUM(*)
      S1=0.
      S2=0.
      S3=0.
      S4=0.
      MAX1=MAX-6
      DO 30 J=MIN,MAX1,6
      S1=S1+SUM(J)+SUM(J+6)
      S2=S2+SUM(J+1)+SUM(J+5)
      S3=S3+SUM(J+2)+SUM(J+4)
 30   S4=S4+SUM(J+3)
      SUMM6=0.29285714*(S1+5.268293*S2+0.6585366*S3+6.634146*S4)*DIF
      RETURN
      END

CBAB see T.A.Brody, G.Jacob and M.Moshinsky, Nucl. Phys. 17, 16 (1960)
CBAB and T.A.Brody and M.Moshinshy, Tables of Transformation Brackets
CBAB and R.D.Lawson, Theory of the Nuclear Shell Model
CBAB based on original program by D.J.Millener
      FUNCTION BREL(N1,L1,N2,L2,I)
      B = 0.
      BREL = 0.
      LTOTAL = L1 + L2
      IF( 2*I .LT. LTOTAL) RETURN
      IF( LTOTAL + 2*( N1 + N2 - I) .LT. 0) RETURN
      IPM = I - LTOTAL/2 - N2
      IPX = I - LTOTAL/2
      IALPHA = MAX0(0,IPM) + 1
      IBETA = MIN0(N1,IPX) + 1

      I1 = 2*N1 + 2*L1 + 1
      I2 = N1 + L1
      I3 = 2*N2 + 2*L2 + 1
      I4 = N2 + L2
      I5 = 2*I + 1
      FBAB1 = SQRT(FACI(I2)*FACI(I4))
      FBAB1 = SQRT(FACI(N1)*FACI(N2))/FBAB1
CBAB FACIS IS THE SQRT OF FACI
CBAB      FBAB1 = FBAB1*FACIS(I1)*FACIS(I3)
      FBI1S = FACIS(I1)
      FBI3S = FACIS(I3)
      FBI5 = FACIS(I5)
      FBI = FACI(I)

      SUM = 0.
      DO 100 IK = IALPHA,IBETA
      K = IK - 1
      I1 = L1 + K
      I2 = 2*K + 2*L1 + 1
      I3 = I - (L1 - L2)/2 - K
      I4 = I - LTOTAL/2 - K
      I5 = K
      I6 = N1 - K
      I7 = 2*I - L1 + L2 - 2*K + 1
      I8 = N2 - I + LTOTAL/2 + K
CBAB REARRANGED TO PREVENT OVERFLOW UP TO INPUT OF 13,0,13,0,26
CBAB      F12 = FACI(I2)*FACI(I4)*FACI(I5)*FACI(I6)*FACI(I7)*FACI(I8)
      F12C = FBAB1/FACI(I2)
      F12C = F12C*FACI(I1)/FACI(I4)
      F12C = F12C*FACI(I3)/FACI(I5)
      F12C = F12C*FBI1S/FACI(I6)
      F12C = F12C*FBI3S/FACI(I7)
      F12C = F12C*FBI5/FACI(I8)
      F12C = F12C/FBI
      F12C = F12C*FBI5
CBAB100   SUM = SUM + FACI(I1)*FACI(I3)/F12
100   SUM = SUM + F12C

CBAB      I1 = 2*N1 + 2*L1 + 1
CBAB      I2 = N1 + L1
CBAB      I3 = 2*N2 + 2*L2 + 1
CBAB      I4 = N2 + L2
CBAB      I5 = 2*I + 1
CBAB      F12 = FACI(I2)*FACI(I4)
CBAB      SUM = SUM*SQRT(FACI(N1)*FACI(N2)*FACI(I1)*FACI(I3)/F12)
CBAB      SUM = SUM*FACI(I5)/FACI(I)

      SUM = SUM*(-1.)**(I - LTOTAL/2)
      B = SUM/(2.**(N1 + N2) )
      BREL = B
      IF( ABS(BREL) .LT. 0.00001) BREL = 0.
      RETURN
      END

