      FUNCTION V(I,J)
*
*  Created by Dimitri               10-MAY-1995
*  Compute the matrix elements of a gaussian random matrix V(i,j)
*
      Real v, gasdev
      Integer i,j,iseed
      if(i.eq.j)
        v = 1.414213562373095*GASDEV(Iseed)
      else
        v = gasdev(iseed)
      Endif
      RETURN
      END
c
c-------------------------------------------------------------------------------
c
      FUNCTION  G A S D E V (ISEED)
c
c   Purpose :
c     Generates a normal  distribuited  deviate with zero mean and
c     unit variance, using RAN(ISEED) as source of uniform deviates
c
c   Method :
c     Box - Muller method -  Numerical Recipes (pg.202ff)
c
c-------------------------------------------------------------------------------
c
      PARAMETER (ONE = 1.0, TWO = 2.0)
      DATA ISET /0/
      IF (ISET .EQ. 0) THEN
    1   V1 = TWO*RAN(ISEED) - ONE
        V2 = TWO*RAN(ISEED) - ONE
        R = V1**2 + V2**2
        IF (R .GE. ONE) GO TO 1
        FAC = SQRT( - TWO*LOG(R)/R)    ! Box-Muller transformation
        GSET = V1*FAC
        GASDEV = V2*FAC
        ISET = 1
      ELSE
        GASDEV = GSET
        ISET = 0
      END IF
c
      RETURN
      END
