C   LANCZOS EIGENVALUE PROGRAM
C Origins: 1970  Glasgow
C          1975  MSU - modified by W. Chung for Rochester-Oak Ridge Code
C          1978  Oxford - modified for OXBASH
C          1988  MSU - cleaned up for "stand alone" by B. A. Brown
C Note that subroutines ONES and HILBERT generate the matrix internally.

CBAB MAXDIM = maximum dimension of matrix
CBAB MAXVEC = maximum number of eigenvectors needed for convergence
      PARAMETER (MAXDIM=10000)
      PARAMETER (MAXVEC=5000)
      CHARACTER*13 FILE
      COMMON/CIRAN/IRAN
      COMMON/NAME/FILE,IFORM,ITYPE
      COMMON/IN/MAXB,NEIG
      COMMON/CRIT/CRIT,MAXNST
      DIMENSION EVEC(MAXDIM)

      TYPE 500
500   FORMAT(1X,'FILENAME for FILENAME.MAT input'
     1/,1X,'special options: HILBERT,ONES,RAN')
      ACCEPT 501,FILE
501   FORMAT(A)
      IF(FILE.EQ.'HILBERT') CALL HILBERT
      IF(FILE.EQ.'HILBERT') GO TO 520
      IF(FILE.EQ.'ONES') CALL ONES
      IF(FILE.EQ.'ONES') GO TO 520
      IF(FILE.EQ.'RAN') CALL RANM
      IF(FILE.EQ.'RAN') GO TO 520

CBAB DEFALT VALUES (SEE FORMAT 510 BELOW)
      IFORM = 1
      ITYPE = 1
      MATDIM = 0
      NEIG = 10
      CRIT = 0.005

      TYPE 510,IFORM,ITYPE,MATDIM,NEIG,CRIT
510   FORMAT(
     1/,1X,'IFORM  = 1 for formatted input',
     1/,1X,'IFORM  = 2 for unformatted input',
     1/,1X,'IFORM  = 3 for unformatted double precision input',
     1/,1X,'ITYPE  = 1 to read in all elements of the lower
     1 diagonal',
     1/,1X,'           one row at a time, i.e.,'
     1/,1X,'                DO L=1,DIM '
     1/,1X,'                READ (MAT(I),I=1,L)'
     1/,1X,'ITYPE  = 2 to read in only nonzero elements, i.e.',
     1/,1X,'                READ K,(IDEX(I),I=1,K),(MAT(I),I=1,K)',
     1/,1X,'ITYPE  = 3 to read in diagonal, diagonal+1
     1 and diagaonal+2',
     1/,1X,'MATDIM = dimension of matrix',
     1/,1X,'NEIG   = number of eigenvectors required',
     1/,1X,'CRIT   = criteria for convergence',
     1//,1X,'IFORM,ITYPE,MATDIM,NEIG,CRIT (4I,F)
     1 (defaults = ',I1,',
     1',I1,',
     1',I1,',
     1',I2,',',F10.7')')
      ACCEPT 511,I1,I2,I3,I4,X1
511   FORMAT(4I,F)
      IF(I1.NE.0) IFORM = I1
      IF(I2.NE.0) ITYPE = I2
      IF(I3.NE.0) MAXB = I3
      IF(I4.NE.0) NEIG = I4
      IF(X1.NE.0) CRIT = X1
      CALL OPENFILE
     
520   CONTINUE
      CALL CONVERT
      IRAN = 0
      CALL LANC
      WRITE(6,115) MAXNST
115   FORMAT(/,1X,'Number of iterations = ',I5)
      IF(MAXNST.GT.0) GO TO 800
      WRITE(6,116)
116   FORMAT(1X,'Integer numbers sometimes to not work in Lanzcos',
     1/,1X,'We will now try adding a small random number to the 
     1matrix')
      IRAN = 1
      CALL LANC
      WRITE(6,115) MAXNST
800   CONTINUE

      IF(MAXB.GT.20) WRITE(6,111)
111   FORMAT(/,1X,'Only the lowest 20 components of the eigenvector
     1 are printed below',/)
      OPEN(UNIT=24,FILE=FILE//'.EIG',STATUS='OLD',FORM='UNFORMATTED')
      DO 200 I = 1,NEIG
      READ(24) EIGENVAL,(EVEC(J),J=1,MAXB)
      IF(MAXB.LE.20) WRITE(6,110) I,EIGENVAL,(EVEC(J),J=1,MAXB)
      IF(MAXB.GT.20) WRITE(6,110) I,EIGENVAL,(EVEC(J),J=1,20)
110   FORMAT(1X,'Eigenvalue ',I3,' = ',F11.6,3X,'Eigenvector = ',
     1200(/,17X,5(1X,F11.7)))
200   CONTINUE
      STOP
      END

      SUBROUTINE OPENFILE
      CHARACTER*13 FILE
      COMMON/NAME/FILE,IFORM,ITYPE
      IF(IFORM.EQ.3)
     1OPEN(UNIT=9,FILE=FILE//'.MAT',STATUS='OLD',FORM='UNFORMATTED')
      IF(IFORM.EQ.2)
     1OPEN(UNIT=9,FILE=FILE//'.MAT',STATUS='OLD',FORM='UNFORMATTED')
      IF(IFORM.EQ.1)
     1OPEN(UNIT=9,FILE=FILE//'.MAT',STATUS='OLD')
      RETURN
      END

      SUBROUTINE CONVERT
      PARAMETER (MAXDIM=10000)
      PARAMETER (KEEPMAT=0.0001)
      CHARACTER*13 FILE
      COMMON/NAME/FILE,IFORM,ITYPE
      COMMON/IN/MAXB,NEIG
      COMMON/CDET/DET1(MAXDIM),DET2(MAXDIM),DET3(MAXDIM)
      DIMENSION DET(MAXDIM)
      DOUBLE PRECISION DDET1(MAXDIM),DDET2(MAXDIM),DDET3(MAXDIM),
     1DDET(MAXDIM)
      INTEGER*4 IDEX(MAXDIM)

      IF(ITYPE.EQ.3) GO TO 700

      OPEN(UNIT=10,FILE=FILE//'.TM1',STATUS='NEW',FORM='UNFORMATTED'
     1,DISPOSE='DELETE')

      IF(ITYPE.EQ.2) GO TO 600

      L = 0      
501   CONTINUE
      L = L + 1
      IF(IFORM.EQ.3) READ(9,ERR=500)(DDET(I),I=1,L)
      IF(IFORM.EQ.2) READ(9,ERR=500)(DET(I),I=1,L)
      IF(IFORM.EQ.1) READ(9,*,ERR=500)(DET(I),I=1,L)
      IF(IFORM.EQ.3) GO TO 705
      GO TO 701
705   DO 702 I = 1,L
702   DET(I) = DDET(I)
701   CONTINUE
CBAB      TYPE 7777,(DET(I),I=1,L)
CBAB7777  FORMAT(1X,10F8.4)
      K=0
      DO 5000 I=1,L
      IF(ABS(DET(I)).GT.KEEPMAT)THEN
      K=K+1
      IDEX(K)=I
      END IF
5000  CONTINUE
      WRITE(10) K,(IDEX(I),I=1,K),(DET(IDEX(I)),I=1,K)
      GO TO 501
500   CONTINUE
      GO TO 620

600   CONTINUE
      L = 0      
511   CONTINUE
      L = L + 1
      IF(IFORM.EQ.3) READ(9,ERR=510) 
     1K,(IDEX(I),I=1,K),(DDET(IDEX(I)),I=1,K)
      IF(IFORM.EQ.2) READ(9,ERR=510) 
     1K,(IDEX(I),I=1,K),(DET(IDEX(I)),I=1,K)
      IF(IFORM.EQ.1) READ(9,*,ERR=510) 
     1K,(IDEX(I),I=1,K),(DET(IDEX(I)),I=1,K)
      IF(IFORM.EQ.3) GO TO 715
      GO TO 711
715   DO 712 I = 1,L
712   DET(I) = DDET(I)
711   CONTINUE

      WRITE(10) K,(IDEX(I),I=1,K),(DET(IDEX(I)),I=1,K)
      GO TO 511
510   CONTINUE
      GO TO 620

700   CONTINUE
      IF(IFORM.EQ.1) READ(9,*) (DET1(I),I=1,MAXB)
      IF(IFORM.EQ.1) READ(9,*) (DET2(I),I=1,MAXB-1)
      IF(IFORM.EQ.1) READ(9,*) (DET3(I),I=1,MAXB-2)
      IF(IFORM.EQ.2) READ(9) (DET1(I),I=1,MAXB)
      IF(IFORM.EQ.2) READ(9) (DET2(I),I=1,MAXB-1)
      IF(IFORM.EQ.2) READ(9) (DET3(I),I=1,MAXB-2)
      IF(IFORM.EQ.3) READ(9) (DDET1(I),I=1,MAXB)
      IF(IFORM.EQ.3) READ(9) (DDET2(I),I=1,MAXB-1)
      IF(IFORM.EQ.3) READ(9) (DDET3(I),I=1,MAXB-2)

      IF(IFORM.EQ.3) GO TO 725
      GO TO 721
725   DO 722 I = 1,MAXB
722   DET1(I) = DDET1(I)
      DO 723 I = 1,MAXB-1
723   DET2(I) = DDET2(I)
      DO 724 I = 1,MAXB-2
724   DET3(I) = DDET3(I)
721   CONTINUE
      CLOSE(UNIT=9)
      RETURN

620   CONTINUE
      MAXB = L-1
      WRITE(6,100) MAXB
100   FORMAT(1X,'Matrix dimension from input = ',I5)
      CLOSE(UNIT=9)
      RETURN
      END 

      SUBROUTINE HILBERT
      PARAMETER (MAXMAT=10000)
      DIMENSION XMAT(MAXMAT)
      CHARACTER*13 FILE
      COMMON/NAME/FILE,IFORM,ITYPE
      COMMON/CRIT/CRIT,MAXNST
      COMMON/IN/MAXB,NEIG
      OPEN(UNIT=9,FILE='HILBERT.MAB',STATUS='NEW',FORM='UNFORMATTED'
     1,DISPOSE='DELETE')
      IFORM = 2
      ITYPE = 1
      IORDER = 10
      NEIG = 10
      CRIT = .001
      TYPE 310,IORDER,NEIG,CRIT
310   FORMAT(
     1/,1X,'IORDER = total dimension of matrix',
     1/,1X,'NEIG   = number of eigenvectors required',
     1/,1X,'CRIT   = criteria for convergence',
     1/,1X,'IORDER,NEIG,CRIT (defaults = ',I3,',',I3,',',F10.7,')')
      ACCEPT 311,I1,I2,X1
311   FORMAT(2I,F)
      IF(I1.NE.0) IORDER = I1
      IF(I2.NE.0) NEIG = I2
      IF(X1.NE.0) CRIT = X1
      DO 320 I = 1,IORDER
      DO 321 J = 1,I
      XI = I
      XJ = J
      XMAT(J) = -1./(XI+XJ-1.)
321   CONTINUE
      WRITE(9) (XMAT(J),J=1,I)
320   CONTINUE
      REWIND 9
      RETURN
      END

      SUBROUTINE ONES
      PARAMETER (MAXMAT=10000)
      DIMENSION XMAT(MAXMAT)
      CHARACTER*13 FILE
      COMMON/NAME/FILE,IFORM,ITYPE
      COMMON/CRIT/CRIT,MAXNST
      COMMON/IN/MAXB,NEIG
      OPEN(UNIT=9,FILE='ONES.MAB',STATUS='NEW',FORM='UNFORMATTED'
     1,DISPOSE='DELETE')
      IFORM = 2
      ITYPE = 1
      IORDER = 10
      NEIG = 10
      CRIT = .001
      TYPE 310,IORDER,NEIG,CRIT
310   FORMAT(
     1/,1X,'IORDER = total dimension of matrix',
     1/,1X,'NEIG   = number of eigenvectors required',
     1/,1X,'CRIT   = criteria for convergence',
     1/,1X,'IORDER,NEIG,CRIT (defaults = ',I3,',',I3,',',F10.7,')')
      ACCEPT 311,I1,I2,X1
311   FORMAT(2I,F)
      IF(I1.NE.0) IORDER = I1
      IF(I2.NE.0) NEIG = I2
      IF(X1.NE.0) CRIT = X1
      DO 320 I = 1,IORDER
      DO 321 J = 1,I
      XI = I
      XJ = J
      IF(I.EQ.J) XMAT(J) = I
      IF(I.NE.J) XMAT(J) = 0.
321   CONTINUE
      WRITE(9) (XMAT(J),J=1,I)
320   CONTINUE
      REWIND 9
      RETURN
      END

      SUBROUTINE RANM
      PARAMETER (MAXMAT=10000)
CBAB      DOUBLE PRECISION XMAT(MAXMAT)
      DIMENSION XMAT(MAXMAT)
      CHARACTER*13 FILE
      COMMON/NAME/FILE,IFORM,ITYPE
      COMMON/CRIT/CRIT,MAXNST
      COMMON/IN/MAXB,NEIG
      OPEN(UNIT=9,FILE='ONES.MAB',STATUS='NEW',FORM='UNFORMATTED'
     1,DISPOSE='DELETE')
CBAB      OPEN(UNIT=9,FILE='ONES.MAB',STATUS='NEW',FORM='UNFORMATTED')
CBAB      IFORM = 3
      IFORM = 2
      ITYPE = 1
      IORDER = 10
      NEIG = 10
      CRIT = .001
      TYPE 310,IORDER,NEIG,CRIT
310   FORMAT(
     1/,1X,'IORDER = total dimension of matrix',
     1/,1X,'NEIG   = number of eigenvectors required',
     1/,1X,'CRIT   = criteria for convergence',
     1/,1X,'IORDER,NEIG,CRIT (defaults = ',I3,',',I3,',',F10.7,')')
      ACCEPT 311,I1,I2,X1
311   FORMAT(2I,F)
      IF(I1.NE.0) IORDER = I1
      IF(I2.NE.0) NEIG = I2
      IF(X1.NE.0) CRIT = X1
      ISEED = -8573419
      DO 320 I = 1,IORDER
      DO 321 J = 1,I
      XMAT(J) = RAN(ISEED)
321   CONTINUE
      WRITE(9) (XMAT(J),J=1,I)
320   CONTINUE
      REWIND 9
      RETURN
      END

      SUBROUTINE LANC
C
C     SUBROUTINE FOR DIAGONALIZATION BY LANCZOS ALGORITHM
C
Cmh
      parameter (nrecmax=2000)
      PARAMETER (MAXVEC=5000)
      PARAMETER (MAXDIM=10000)
      CHARACTER*13 FILE
      COMMON/NAME/FILE
      REAL*16 EVEC
      COMMON /VECTORS/VMP1(MAXDIM),VMP2(MAXDIM),VMPFILL(MAXDIM) 
      COMMON /EIGENC/F(MAXVEC),G(MAXVEC),P(MAXVEC),E(MAXVEC) 
     1,XT(4*MAXVEC),EVEC(MAXVEC+2)
      COMMON/IN/MAXB,NEIG 
      COMMON/CRIT/CRIT,MAXNST
      COMMON/OUT/EIGVAL(MAXVEC+2) 
      COMMON/OUTO/EIGVALO(MAXVEC+2) 
      DIMENSION AMP1(MAXDIM),AMP2(MAXDIM) 

cmh

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13

      EQUIVALENCE (AMP1(1),VMP1(1)),(AMP2(1),VMP2(1)) 

CBAB THIS WAS NEEDED WITH OLDER VERSIONS OF VMS FOR REAL*16
CBAB      CALL LIB$ESTABLISH(LIB$EMULATE)

      OPEN(UNIT=13,FILE=FILE//'.TM2',STATUS='NEW',FORM='UNFORMATTED'
     1,DISPOSE='DELETE')

cmh
      nrec13=0

      OPEN(UNIT=24,FILE=FILE//'.EIG',STATUS='NEW',FORM='UNFORMATTED')

C NUMBER OF PREITERATIONS
      NPRE = 3

      DO 765 I=1,MAXB 
765   VMP1(I) =1.0 
C-----------------------------------------------------------------------
      IX = 1 
      IF(NPRE.EQ.0) GOTO 85 
C
C--- PERFORM PRE-ITERATIONS
      DO 80 I=1,NPRE 
      IX = MOD(IX,2) + 1 
      GOTO (78,79) IX 
78    CALL HMULT(VMP1,VMP2,MAXB) 
      IF(MAXB.EQ.1) RETURN
      GOTO 80 
79    CALL HMULT(VMP2,VMP1,MAXB) 
      IF(MAXB.EQ.1) RETURN
80    CONTINUE 
C
C
85    CONTINUE 
      GOTO(86,87) IX 
86    CALL NORM(RNORM,MAXB,MAXDIM,VMP1,VMP1,2) 
cmh      CALL WRITOUT(13,VMP1,MAXB) 
      CALL WRITOUTm(132,VMP1,MAXB)
      GOTO 110 
87    CALL NORM(RNORM,MAXB,MAXDIM,VMP2,VMP2,2) 
cmh      CALL WRITOUT(13,VMP2,MAXB) 
      CALL WRITOUTm(133,VMP2,MAXB)
110   CONTINUE 
C
C
C-----     --- CALL LANCZOS ROUTINE ---

      NST =0 
115   CALL LANCZOS(VMP1,VMP2,MAXB,MAXDIM,NST,IX,NEIG,ITMAX) 
      RETURN 
      END 

C         LANCZOS SUBROUTINE 
C-----------------------------------------------------------------------
C
      SUBROUTINE LANCZOS(VMP1,VMP2,MAXB,MAXDIM,NST,IX,NEIG,ITMAX)
cmh
      parameter (nrecmax=2000)
      REAL*16 EVEC
      PARAMETER (MAXVEC=5000)
      COMMON /EIGENC/F(MAXVEC),G(MAXVEC),P(MAXVEC),E(MAXVEC) 
     1,XT(4*MAXVEC),EVEC(MAXVEC+2)
      COMMON /OUT/EIGVAL(MAXVEC+2) 
      COMMON /OUTO/EIGVALO(MAXVEC+2) 
      COMMON/CRIT/CRIT,MAXNST
      DIMENSION VMP1(MAXB),VMP2(MAXB) 
cmh

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13

      CHECK=1.
      NUMIN=0
C
C
C--- START OF ITERATION LOOP
115   LTEST = 0 
      IX = MOD(IX,2) + 1 
120   CONTINUE 
32    CONTINUE 
      GOTO (121,122) IX 
121   CALL HMULT(VMP1,VMP2,MAXB) 
      GOTO 123 
122   CALL HMULT(VMP2,VMP1,MAXB) 
123   IF(NST.LT.1) GOTO 125 

cmh      BACKSPACE 13 
cmh      BACKSPACE 13 

      call mbacks(2,maxb)

C-----  ORTHOGONALISE AND OBTAIN MATRIX ELEMENTS
125   CONTINUE 
      GOTO (126,127) IX 
126   CALL NORM(SCLRP,MAXB,MAXDIM,VMP1,VMP2,1) 
      GOTO 128 
127   CALL NORM(SCLRP,MAXB,MAXDIM,VMP2,VMP1,1) 
128   F(NST+1) = SCLRP 
      IF(NST.LT.1) GOTO 165 
      GOTO(131,132) IX 
cmh131   READ(13) VMP2 

131   call READinm(134,VMP2,maxb)


      CALL NORM(SCLRP,MAXB,MAXDIM,VMP1,VMP2,1) 
      GOTO 133 
cmh 132   READ(13) VMP1 

132   call READinm(135,VMP1,maxb)

      CALL NORM(SCLRP,MAXB,MAXDIM,VMP2,VMP1,1) 
133   G(NST) = SCLRP 
C-----  RE-ORTHOGONALISE AND NORMALISE

cmh 145   REWIND 13 

145      continue

cmh
      nrec13=0
        REWIND 13

      NSTP = NST + 1 
      DO 160 I=1,NSTP 
      GOTO(158,159) IX 
cmh 158   READ(13) VMP2 

158   call READinm(136,VMP2,maxb)

      CALL NORM(SCLRP,MAXB,MAXDIM,VMP1,VMP2,1) 
      GOTO 160 
cmh 159   READ(13) VMP1 

159   call READinm(137,VMP1,maxb)

      CALL NORM(SCLRP,MAXB,MAXDIM,VMP2,VMP1,1) 
160   CONTINUE 
165   CONTINUE 
      GOTO(156,157) IX 
156   CALL NORM(RNORM,MAXB,MAXDIM,VMP1,VMP1,2) 
      GOTO 166 
157   CALL NORM(RNORM,MAXB,MAXDIM,VMP2,VMP2,2) 
C
C-----  PREMATURE TERMINATION RECOVERY
166   CONTINUE 
      IF(RNORM.GT.1.0E-4) GO TO 170 
      IF(NST.GE.(MAXB-1)) GO TO 190 
      LTEST=LTEST+1 
      IF(LTEST.GT.2) RETURN
      GO TO 145 
C-----  WRITE NEW VECTOR ON DISC
170   GOTO(171,172) IX 
cmh 171   WRITE(13) VMP1 

171   call WRIToutm(138,VMP1,maxb)

      GOTO 190 
cmh 172   WRITE(13) VMP2 

172   call WRIToutm(139,VMP2,maxb)

190   NST=NST+1 
210   G(NST)=0.0 
      CALL EIGENH(NST) 
      DO 226 I=1,NST 
      J=NST+1-I 
      EIGVAL(I)=E(J) 
226   CONTINUE 
      IF(NST.EQ.MAXB) GO TO 220

CBAB CONVERGENCE CHECK ------------------------------------
CBAB WHEN NST GOES BEYOND THE VALUE OF ITMAX IT WILL START CHECKING
CBAB FOR CONVERGENCE
CBAB GUESTIMATE FOR ITMAX
      ITMAX = 5*NEIG
CBAB START CHECKING WHEN WE ARE TWO FROM THE END OF MAXVEC
      IF(ITMAX.GT.MAXVEC-2) ITMAX=MAXVEC-2
      IF(ITMAX.GT.MAXB) ITMAX=MAXB
      IF(NST.LT.ITMAX) GO TO 115

      CHECK=0.
      NX = NEIG
      DO 2255 KK=1,NX
      IF(ABS(EIGVALO(KK)-EIGVAL(KK)).GT.CHECK)CHECK
     1=ABS(EIGVALO(KK)-EIGVAL(KK))
2255  CONTINUE
      DO 225 I=1,NST 
225   EIGVALO(I) = EIGVAL(I) 
      WRITE(6,8000)NST,CHECK,EIGVAL(1),EIGVAL(2)
8000  FORMAT(1X,'ITERATION, MAX DEVIATION, E0,E1 = '
     1,I3,1X,3F9.4)
      IF(NST.EQ.(MAXVEC-1)) GO TO 1500
      GO TO 1501
1500  CONTINUE
      WRITE(6,5505)
5505  FORMAT(1X,'***** WARNING #ITERATIONS EQ. (MAXVEC-1) *****')
      IF(CHECK.LE.CRIT) WRITE(6,5506) NST,MAXB,NX
      IF(CHECK.GT.CRIT) WRITE(6,5507) NST,MAXB,NX
5506  FORMAT(1X,'CONVERGENCE TEST PASSED, NST,MAXB,NX = ',3I3)
5507  FORMAT(1X,'CONVERGENCE TEST FAILED, NST,MAXB,NX = ',3I3)
      GO TO 220
1501  CONTINUE
      IF(CHECK.LE.CRIT) GO TO 220 
      GO TO 115
CBAB CONVERGENCE CHECK ------------------------------------

220   CONTINUE 
C-----------------------------------------------------------------------
C     CALCULATE REQUIRED EIGENVECTORS 
C-----------------------------------------------------------------------
      NEIG = MIN0(NEIG,MAXB) 
      MAXNST=NST
      IF(NEIG.LT.1) GOTO 260 
2450  FORMAT(//' TRANSFORMATION (LANCZOS) MATRIX') 
      DO 2110 IJ=1,NEIG 

cmh
      nrec13=0
      REWIND 13 
      I=NST+1-IJ 
      DO 230 J=1,MAXB 
230   VMP1(J)=0.0 
      CALL EIGENV(I,NST) 
C-----  TRANSFORM WITH LANCZOS MATRIX
      DO 240 J=1,NST 
cmh      CALL READIN(13,VMP2,MAXB) 

      CALL READINm(1390,VMP2,MAXB)

      EV = EVEC(J) 
      DO 240 L=1,MAXB 
240   VMP1(L) = VMP1(L) + VMP2(L)*EV 
250   FORMAT(/100(12F10.3/))
CBAB      TYPE 7777,MAXB
CBAB7777  FORMAT(1X,'MAXB = ',I5) 
      WRITE(24) EIGVAL(IJ),(VMP1(J),J=1,MAXB) 
      DO 255 L=1,MAXB 
255   VMP1(L)=VMP1(L)*VMP1(L) 
2110  CONTINUE 
260   CONTINUE 
      CLOSE(UNIT=24) 
900   FORMAT(/1H )                  
1100  FORMAT(1H0,'TERMINATION TEST') 
1200  FORMAT(1H ,'PREMATURE TERMINATION - RECOVERY FAILED') 
1300  FORMAT(8(' ',I3,F11.6)) 
1600  FORMAT(/(1X,12F10.6)) 
      RETURN
      END 

      SUBROUTINE READIN(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      READ(I) ARRAY 
      RETURN 
      END 

      SUBROUTINE WRITOUT(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      WRITE(I) ARRAY 
      RETURN 
      END 


      SUBROUTINE READINm(I,ARRAY,N)
cmh
cmh
      parameter (nrecmax=2000)

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13
cmh      common /nrecold/nrold,nwold

      DIMENSION ARRAY(N)

cmh      write(*,*)'r',i,n,nrec13

cmh      nrecmax=nrecmax
      if(nrec13+n.gt.nrecmax)then
cmh      write(*,*)'r overpassed nrecmax',nrec13
      call readin(13,array,n)
      nrec13=nrec13+n
      return
      endif


      do 1 j=1,n
      array(j)=vltg(nrec13+j)
cmh      write(*,*)j,array(j),nrec13+j
1      continue
      nrec13=nrec13+n

cmh      nrold=nrec13
      RETURN
      END



      SUBROUTINE WRITOUTm(I,ARRAY,N)
cmh
cmh
      parameter (nrecmax=2000)

      common/vltgf/vltg(nrecmax)
      common/nrec13/nrec13

      DIMENSION ARRAY(N)
cmh      write(*,*)'w',i,n,nrec13

cmh      nrecmax=nrecmax
      if(nrec13+n.gt.nrecmax)then
cmh      write(*,*)'w overpassed nrecmax',nrec13
      call writout(13,array,n)
      nrec13=nrec13+n
      return
      endif

      do 1 j=1,n
cmh      write(*,*)nrec13+j,array(j)
1      vltg(nrec13+j)=array(j)
      nrec13=nrec13+n


      RETURN
      END


cmh
      subroutine mbacks(m,length)
cmh
      parameter (nrecmax=2000)

cmh     replace "backspace 13" m times

      common/nrec13/nrec13

      m1=(nrec13-1-nrecmax)/length+1

cmh      write(*,*)'backs',nrec13,nrecmax,m1,m

      if(nrec13.le.nrecmax)then
      nrec13=nrec13-m*length
      return
      endif


      if(m.le.m1)then
      do i=1,m
      backspace 13
      enddo
      nrec13=nrec13-m*length
      return

      else
cmh      m2=m-m1
      rewind 13
      nrec13=nrec13-m*length

      endif

      return
      end



      SUBROUTINE WRITOUTN(I,ARRAY,N) 
      DIMENSION ARRAY(N) 
      WRITE(I) DUMMY,ARRAY 
      RETURN 
      END 

      SUBROUTINE HMULT(AMPN,AMPO,MAXB) 
      CHARACTER*13 FILE
      PARAMETER (MAXDIM=10000)
      COMMON/CIRAN/IRAN
      COMMON/CRIT/CRIT,MAXNST
      COMMON/CDET/DET1(MAXDIM),DET2(MAXDIM),DET3(MAXDIM)
      COMMON/NAME/FILE,IFORM,ITYPE
      DIMENSION DET(MAXDIM) 
      INTEGER*4 IDEX(MAXDIM)
      DIMENSION AMPN(1),AMPO(1) 
      IF(ITYPE.NE.3) REWIND 10 
      IF(ITYPE.NE.3) ISEED = -8573419
      DO 5009 I=1,MAXB
5009  AMPN(I)=0.0
      DO 5004 L=1,MAXB 
      APP=0.0
      IF(ITYPE.EQ.3) GO TO 6000
      READ(10)K,(IDEX(I),I=1,K),(DET(I),I=1,K)
      GO TO 6002
6000  CONTINUE
      IF(L.EQ.1) GO TO 7001
      IF(L.EQ.2) GO TO 7002
      GO TO 7003
7001  K = 1
      IDEX(1) = 1
      DET(1) = DET1(1)
      GO TO 7010
7002  K = 2
      IDEX(1) = 1
      IDEX(2) = 2
      DET(1) = DET2(1)
      DET(2) = DET1(2)
      GO TO 7010
7003  K = 3
      IDEX(1) = L-2
      IDEX(2) = L-1
      IDEX(3) = L
      DET(L-2) = DET3(L-2)
      DET(L-1) = DET2(L-1)
      DET(L) = DET1(L)
      GO TO 7010
7010  CONTINUE
  
6002  CONTINUE
      DO 5003 I=1,K
      IF(IRAN.EQ.1) DET(I) = DET(I) + CRIT*RAN(ISEED)
      APP=AMPO(IDEX(I))*DET(I)+APP
      AMPN(IDEX(I))=AMPN(IDEX(I))+AMPO(L)*DET(I)
5003  CONTINUE
      AMPN(L)=APP
5004  CONTINUE
      RETURN 
      END 

      SUBROUTINE NORM(RNRM,MAXB,MAXDIM,AMP1,AMP2,NORMT) 
      DIMENSION AMP1(1),AMP2(1) 
5002  FORMAT(' AMPN: ',10E12.3) 
      AM=0 
      DO 55 I=1,MAXB 
55    AM = AM + AMP1(I)*AMP2(I) 
70    CONTINUE 
      IF (NORMT .EQ. 1) GOTO 10 
      RNRM=SQRT(AM) 
CBAB  PUT IN FEB 6, 1984 WHEN I FOUND A CASE WHERE RNRM WAS ZERO 
      IF(RNRM.EQ.0) WRITE(6,500)
500   FORMAT(/,1X,'WARNING: RNRM SET EQUAL TO 10E-13 IN SUBROUTINE 
     1 NORM') 
      IF(RNRM.EQ.0) RNRM = 10E-13 
      AM=1.0/RNRM 
      DO 20 I=1,MAXB 
20    AMP1(I) = AMP1(I)*AM 
      RETURN 
10    CONTINUE 
      RNRM=AM 
      DO 30 I=1,MAXB 
30    AMP1(I) = AMP1(I) -AM*AMP2(I) 
      RETURN 
      END 

      SUBROUTINE EIGENH(NN) 
C  CALCULATE EIGENVALUES OF THE SYMMETRIC TRIDIAGONAL MATRIX IN F & G
      REAL*16 Y
      PARAMETER (MAXVEC=5000)
      COMMON/EIGENC/ F(MAXVEC),G(MAXVEC),P(MAXVEC),E(MAXVEC) 
     1,Q(MAXVEC),R(MAXVEC),IN(MAXVEC),
     1DM(MAXVEC),Y(MAXVEC+2) 
      LOGICAL*4 IN 
      IF(NN.GT.1) GO TO 5 
      E(1)=F(1) 
      GO TO 130 
5     RNORM=ABS(F(1))+ABS(G(1)) 
      IF(ABS(G(1)).LE.1.0E-15) G(1)=1.0E-15 
      P(1)=G(1)*G(1) 
      DO 10 I=2,NN 
      TNORM=ABS(F(I))+ABS(G(I))+ABS(G(I-1)) 
      RNORM=AMAX1(RNORM,TNORM) 
      IF(ABS(G(I)).LE.1.0E-15) G(I)=1.0E-15 
10    P(I)=G(I)*G(I) 
      K=1 
      U=RNORM 
      DO 20 I=1,NN 
20    E(I)=-RNORM 
30    RL=E(K) 
40    DL=0.5*(RL+U) 
      IF((DL.EQ.RL).OR.(DL.EQ.U)) GO TO 120 
      IAG=0 
      I=1 
50    S=F(I)-DL 
60    IF(S.GE.0.0) IAG=IAG+1 
      IF(S.EQ.0.0) GO TO 70 
      I=I+1 
      IF(I.GT.NN) GO TO 80 
      S=F(I)-DL-P(I-1)/S 
      GO TO 60 
70    I=I+2 
      IF(I.LE.NN) GO TO 50 
80    IF(IAG.GE.K) GO TO 90 
      U=DL 
      GO TO 40 
90    RL=DL 
      M=IAG 
      IF(NN.LT.IAG) M=NN 
      DO 110 I=K,M 
110   E(I)=DL 
      GO TO 40 
120   E(K)=DL 
      K=K+1 
      IF(K.LE.NN) GO TO 30 
130   RETURN 
      END 

      SUBROUTINE EIGENV(II,N) 
      REAL*16 Y,DT
      PARAMETER (MAXVEC=5000)
      COMMON/EIGENC/ F(MAXVEC),G(MAXVEC),P(MAXVEC),E(MAXVEC) 
     1,Q(MAXVEC),R(MAXVEC),IN(MAXVEC),
     1DM(MAXVEC),Y(MAXVEC+2) 
      LOGICAL IN 
C
C-----------------------------------------------------------------------
C     CALCULATE I'TH EIGENVECTOR
C-----------------------------------------------------------------------
      IF(N.GT.1) GOTO 130 
      Y(1) = 1.0 
      RETURN 
130   CONTINUE 
      IRS=N-1 
      IRE=0 
      DO 140 J=1,N 
      P(J)=0.0 
      Q(J)=G(J) 
      R(J)=F(J)-E(II) 
140   Y(J)=1.0 
      Y(N+1)=0.0 
      Y(N+2)=0.0 
C-----  TRIANGULAR REDUCTION OF LEFT HAND SIDE
      IAG=N-1 
      DO 170 J=1,IAG 
      JJ=J+1 
      IF(ABS(R(J)).LT.ABS(G(J))) GO TO 150 
      DT=G(J)/R(J) 
      IN(J)=.FALSE. 
      GO TO 160 
150   DT=R(J)/G(J) 
      IN(J)=.TRUE. 
      R(J)=G(J) 
      U=R(JJ) 
      R(JJ)=Q(J) 
      Q(J)=U 
      P(J)=Q(JJ) 
      Q(JJ)=0.0 
160   DM(J)=DT 
      Q(JJ)=Q(JJ)-DT*P(J) 
      R(JJ)=R(JJ)-DT*Q(J) 
      IF(ABS(R(J)).LT.1.0E-30) R(J)=1.0E-30 
170   CONTINUE 
      IF(ABS(R(N)).LT.1.0E-30) R(N)=1.0E-30 
C-----  BACK SUBSTITUTION
190   CONTINUE 
      DO 230 J=1,N 
      JJ=N+1-J 
      T=Y(JJ) 
210   Y(JJ)=(T-Y(JJ+1)*Q(JJ)-Y(JJ+2)*P(JJ))/R(JJ) 
      IF(ABS(Y(JJ)).LE.1.0E33) GO TO 230 
      DO 220 JJJ=1,N 
220   Y(JJJ)=Y(JJJ)*1.0E-20 
      T=T*1.0E-20 
      GO TO 210 
230   CONTINUE 
      IF(IRE.EQ.2) GO TO 260 
      IRE=IRE+1 
C-----  TRIANGULAR REDUCTION OF NEW RHS
      DO 250 J=1,IRS 
      JJ=J+1 
      IF(IN(J)) GO TO 240 
      Y(JJ)=Y(JJ)-DM(J)*Y(J) 
      GO TO 250 
240   T=Y(J) 
      Y(J)=Y(JJ) 
      Y(JJ)=T-DM(J)*Y(JJ) 
250   CONTINUE 
      GO TO 190 
C-----  NORMALISE EIGENVECTOR
260   DT=0.0 
      DO 330 J=1,N 
      Y(J)=Y(J)*1.0E-10 
      DT=DT+Y(J)**2 
330   CONTINUE 
      DT= SQRT(1.0/DT)*1.0E-10 
      DO 340 J=1,N 
340   Y(J)=Y(J)*1.0E+10*DT 
      RETURN 
      END 

