C
C   CALCULTES MOSHINSKY BRACKETS USING THE FORMULA (A6.19) 
C    IN THEORY OF THE NUCLEAR SHELL MODEL, R.D.LAWSON P.497
C
C N = 0,1,2...
C
      FUNCTION BMOSH(N1,L1,N2,L2,LB,N,L,NN,LL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      BMOSH=0.0
      IF(LB.GT.(L+LL).OR.(LB.GT.(L1+L2)))RETURN
      IF(LB.LT.IABS(L-LL).OR.(LB.LT.IABS(L1-L2)))RETURN
      IF((2*N1+L1+2*N2+L2).NE.(2*N+L+2*NN+LL))RETURN
      IF(IAND((L+LL+L1+L2),1).EQ.1)RETURN
      IF((N1.EQ.N2).AND.(L1.EQ.L2).AND.(IAND((LB+LL),1).EQ.1))RETURN
      IF((N.EQ.NN).AND.(L.EQ.LL).AND.(IAND((LB+L1),1).EQ.1))RETURN
      ANORM=A1(N1,L1)/(A1(N,L))
      ANORM=ANORM*A1(N2,L2)/(A1(NN,LL)*4.0)
      ANORM=ANORM*A2(N1,L1)/(A2(N,L))
      ANORM=ANORM*A2(N2,L2)/(A2(NN,LL))
      MAX=2*N+L
      NU1MAX=MAX/2
      DO 10 I=1,NU1MAX+1
      NU1=I-1
      NU2MAX=(MAX-2*NU1)/2
      DO 12 J=1,NU2MAX+1
      NU2=J-1
      K1MAX=MAX-2*NU1-2*NU2
      DO 13 K=1,K1MAX+1
      K1=K-1
      LEFT=K1MAX-K1
      K2=LEFT
      J1MIN=IABS(K1-L1)
      J1MAX=K1+L1
      J2MIN=IABS(K2-L2)
      J2MAX=K2+L2
      IJ1=J1MAX-J1MIN+1
      IJ2=J2MAX-J2MIN+1
      DO 14 M=1,IJ1
      J1=J1MIN+M-1
      DO 15 NP=1,IJ2
      J2=J2MIN+NP-1
      ISUM=2*NU1+2*NU2+K1+K2
      X1=FLOAT(2*N1+L1+3+J1-K1)/2.-FLOAT(NU1)
      Y1=FLOAT(2*N1+L1-K1-J1)/2.-FLOAT(NU1)+1
      X2=FLOAT(2*N2+L2+3+J2-K2)/2.-FLOAT(NU2)
      Y2=FLOAT(2*N2+L2-K2-J2)/2.-FLOAT(NU2)+1
      IF((X1.LT.-1.).OR.(X2.LT.-1.)) GOTO 15
      IF((Y1.LT.1.).OR.(Y2.LT.1.)) GOTO 15
      JTL=2*L
      JTLL=2*LL
      JTK1=2*K1
      JTK2=2*K2
      JTJ1=2*J1
      JTJ2=2*J2
      JTLB=2*LB
      JTL1=2*L1
      JTL2=2*L2
      BMOSH=BMOSH+PAR(FLOAT(K2))*((HI(K1)*HI(K2)*HI(J1)*HI(J2))**2.)*
     $COEF9J(JTK1,JTK2,JTJ1,JTJ2,JTL,JTLL,JTL1,JTL2,JTLB)*
     $FOURCLEB(K1,J1,L1,K2,J2,L2,K1,K2,L,J1,J2,LL)*
     $FMOSH(NU1,N1,L1,K1,J1)*FMOSH(NU2,N2,L2,K2,J2)
  15  CONTINUE
  14  CONTINUE
  13  CONTINUE
  12  CONTINUE
  11  CONTINUE
  10  CONTINUE
      BMOSH=ANORM*BMOSH
      RETURN
      END
C
C  A(N,L)=(-1.)**N/SQRT((2*N)!!*(2*N+2*L+1)!!)
C
      FUNCTION A(N,L)
      A=PAR(FLOAT(N))/(SQRT(DOFAC(FLOAT(2*N))*DOFAC(FLOAT(2*N+2*L+1))))
      RETURN
      END
C
C  A1(N,L)=(-1.)**N/SQRT((2*N)!!*(2*N+2*L+1)!!)
C
      FUNCTION A1(N,L)
      A1=1./(SQRT(DOFAC(FLOAT(2*N+2*L+1))))
      RETURN
      END
C
C  A2(N,L)=(-1.)**N/SQRT((2*N)!!*(2*N+2*L+1)!!)
C
      FUNCTION A2(N,L)
      A2=PAR(FLOAT(N))/(SQRT(DOFAC(FLOAT(2*N))))
      RETURN
      END
C
C  GAMMA OF X, WHERE X IS EITHER INTEGER OR HALF INTEGER
C  FUNCTION RETURNS ZERO IF THE ARGUEMENT IS NOT INTEGER
C  OR HALF INTEGER
C
      FUNCTION XGAMMA(X)
      IX=INT(2.0*X)
      XGAMMA=0.0
      IF(FLOAT(IX).NE.(2.*X))RETURN
      IF(X.EQ.0.5)GOTO 11
      IF(IAND(IX,1).EQ.1)GOTO 10
      XGAMMA=FAC(X-1.)
      RETURN
   10 XGAMMA=DOFAC(2.0*(X-0.5)-1.0)/(2.0**(X-0.5))*SQRT(3.14159265)
      RETURN
   11 XGAMMA=SQRT(3.14159265)
      RETURN
      END
C
C  CALCULATES THE PRODUCT OF 4 CLEBSCH GORDON COEFFICIENTS
C    WHERE EACH IS OF THE FORM
C
C        (K,J,0,0|L,0)
C
      FUNCTION FOURCLEB(K1,J1,L1,K2,J2,L2,KK1,KK2,L,JJ1,JJ2,LL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      FOURCLEB=CLEBI(K1,0,J1,0,L1,0)*CLEBI(K2,0,J2,0,L2,0)*
     $CLEBI(KK1,0,KK2,0,L,0)*CLEBI(JJ1,0,JJ2,0,LL,0)
      RETURN
      END
C
C
C
      FUNCTION FMOSH(NU,N,L,K,J)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      UP=SQRT(3.14159265)*FAC(FLOAT(N))*XGAMMA(FLOAT(N+L)+1.5)
      DOWN=FAC(FLOAT(NU))*(SQRT(2.)**(FLOAT(2*N+L)))*
     $XGAMMA(FLOAT(2*N+L-K-J)/2.-FLOAT(NU)+1.0)*
     $XGAMMA(FLOAT(2*N+L+3+J-K)/2.-FLOAT(NU))*
     $(XGAMMA(FLOAT(K+NU)+1.5))
      FMOSH=UP/DOWN
      RETURN
      END
C
C   RETURNS THE VALUE H=SQRT(2*X+1)
C
      FUNCTION H(X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      H=SQRT(2.*X+1.)
      RETURN
      END
C
C   RETURNS THE VALUE HI=SQRT(2*I+1), WHERE I IS AN INTEGER
      FUNCTION HI(I)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      X=FLOAT(I)
      HI=SQRT(2.0*X+1.)
      RETURN
      END
C
C  RETURNS DOUBLE FACTORIAL
C
      FUNCTION DOFAC(X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOFAC=0.0
      IF(X.LT.-1.) RETURN
      DOFAC=1.0
      IF(X.LT.2.0)RETURN
      N=INT(X)
      IF(IAND(N,1).EQ.1) GOTO 10
      DO 9 I=2,N,2
      AI=FLOAT(I)
   9  DOFAC=AI*DOFAC
      RETURN
  10  DO 8 I=1,N,2
      AI=FLOAT(I)
   8  DOFAC=AI*DOFAC
      RETURN
      END
C
C  CALCULATES THE KRONEKER DELTA
C
      FUNCTION DELTAK(I,J)
      DELTAK=0.
      IF(I.EQ.J) DELTAK=1.
      RETURN
      END
C
C  SUBROUTINE CALCULATES ALL THE JJ STATES
C
      SUBROUTINE JJQN(NN,JJ,LL,K,IT,N1,L1,J1,N2,L2,J2,JT,NUMB2)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION JJ(10),NN(10),J1(200),J2(100),JT(200)
      DIMENSION N1(200),N2(200),LL(10),L1(200),L2(200)
      NUMBER=0
C      WRITE(11,1502)K
C      DO I=1,K
C      WRITE(11,1501)NN(I),LL(I),JJ(I)
C      END DO
1502  FORMAT(' ',I2)
1501  FORMAT(' ',3I5)
      DO 10 I=1,K
      DO 11 J=1,K
      IF(I.EQ.J)NUMBER=NUMBER+JJ(I)+1
      IF(I.NE.J)NUMBER=NUMBER+(JJ(I)+JJ(J)-ABS(JJ(I)-JJ(J)))/2+1
  11  CONTINUE
  10  CONTINUE
      NUMB2=NUMBER/2
C      WRITE(11,1503)NUMB2
1503  FORMAT(' ',I5)
      L=1
      IF(IT.EQ.1)GOTO 50
      DO 50 I=1,K
      DO 41 J=I,K
      JMIN=MIN0(JJ(I),JJ(J))
      JMAX=MAX0(JJ(I),JJ(J))
      IF(I.EQ.J)GOTO 40
      N=(JMIN+1)
      JLESS=JMAX-JMIN
      GOTO 49
  40  N=(JMAX+1)/2
      LJ=1
      DO 42 M=L,L+N
      N1(M)=NN(I)
      L1(M)=LL(I)
      J1(M)=JJ(I)
      N2(M)=NN(J)
      L2(M)=LL(J)
      J2(M)=JJ(J)
      JT(M)=2*LJ
  42  LJ=LJ+2
      GOTO 44
  49  DO 43 M=L,L+N
      N1(M)=NN(I)
      L1(M)=LL(I)
      J1(M)=JJ(I)
      J2(M)=JJ(J)
      N2(M)=NN(J)
      L2(M)=LL(J)
      JT(M)=JLESS
  43  JLESS=JLESS+2
  44  L=L+N
      LJ=1
  41  CONTINUE
  50  CONTINUE
      DO 60 I=1,K
      DO 61 J=I,K
      JMIN=MIN0(JJ(I),JJ(J))
      JMAX=MAX0(JJ(I),JJ(J))
      IF(I.EQ.J)GOTO 70
      N=(JMIN+1)
      JLESS=JMAX-JMIN
      GOTO 69
  70  N=(JMAX+1)/2
      LJ=0
      DO 62 M=L,L+N
      N1(M)=NN(I)
      L1(M)=LL(I)
      J1(M)=JJ(I)
      N2(M)=NN(J)
      L2(M)=LL(J)
      J2(M)=JJ(J)
      JT(M)=2*LJ
  62  LJ=LJ+2
      GOTO 64
  69  DO 63 M=L,L+N
      N1(M)=NN(I)
      L1(M)=LL(I)
      J1(M)=JJ(I)
      N2(M)=NN(J)
      L2(M)=LL(J)
      J2(M)=JJ(J)
      JT(M)=JLESS
  63  JLESS=JLESS+2
  64  L=L+N
      LJ=0
  61  CONTINUE
  60  CONTINUE
 200  RETURN
      END
C
C  CALCULATES THE LS STATES
C
      SUBROUTINE LSQN(NN,LLJ,K1,IT,N1,L1,N2,L2,LS,LT,JLT,NUMB2)
      DIMENSION LLJ(10),L1(250),L2(250),LT(250),LS(250)
      DIMENSION JLT(250),N1(250),N2(250),NN(10),LL(10)
      DO 10 I=1,K1
  10  LL(I)=2*LLJ(I)
      NUMB1=0
      DO 73 I=1,K1
  73  NUMB1=NUMB1+4*LL(I)+2
      DO 72 I=1,K1-1
  72  NUMB1=NUMB1+(K1-I)*8*(LL(I)+1)
      NUMB2=NUMB1/2
      IF(IT.EQ.1) GOTO 15
      L=1
      DO 103 I=1,K1
      DO 104 J=I,K1
      LMIN=LL(I)
      LMAX=LL(J)
      IF(LMIN.EQ.LMAX)GOTO 109
      N=(LMIN+1)
      LLESS=LMAX-LMIN
      GOTO 110
  109 NL=(LMIN+1)
      ML=0
      DO 111 IL=1,NL
      LJ=(IL-1)*2
      IF(ML.NE.0)GOTO 112
      N1(L)=NN(I)
      L1(L)=LMIN/2
      N2(L)=NN(J)
      L2(L)=LMAX/2
      LT(L)=LJ/2
      IF(LJ.NE.0)GOTO 105
      LS(L)=1
      JLT(L)=1
      GOTO 106
  105 LS(L)=0
      JLT(L)=LJ/2
  106 ML=1
      IF(LJ.EQ.0) ML=0
      L=L+1
      GOTO 111
  112 DO 113 M=1,3
      N1(L)=NN(I)
      L1(L)=LMIN/2
      N2(L)=NN(J)
      L2(L)=LMAX/2
      LT(L)=LJ/2
      LS(L)=1
      JLT(L)=(LJ-4+2*M)/2
      ML=0
      L=L+1
  113 CONTINUE
  111 CONTINUE
      GOTO 104
  110 DO 124 M=1,N
      N1(L)=NN(I)
      L1(L)=LMIN/2
      N2(L)=NN(J)
      L2(L)=LMAX/2
      LT(L)=LLESS/2
      LS(L)=0
      JLT(L)=LT(L)
      L=L+1
      DO 123 MN=1,3
      N1(L)=NN(I)
      L1(L)=LMIN/2
      N2(L)=NN(J)
      L2(L)=LMAX/2
      LT(L)=LLESS/2
      LS(L)=1
      JLT(L)=(2*LT(L)-4+MN*2)/2
  123 L=L+1
  124 LLESS=LLESS+2
  104 CONTINUE
  103 CONTINUE
      GOTO 1000
   15 L=1
      DO 93 I=1,K1
      DO 94 J=I,K1
      LMIN=LL(I)
      LMAX=LL(J)
      IF(LMIN.EQ.LMAX)GOTO 79
      N=(LMIN+1)
      LLESS=LMAX-LMIN
      GOTO 90
  79  NL=LMIN+1
      ML=0
      DO 80 IL=1,NL
      LJ=(IL-1)*2
      IF(ML.NE.0)GOTO 82
      N1(L)=NN(I)
      L1(L)=LMIN/2
      N2(L)=NN(J)
      L2(L)=LMAX/2
      LT(L)=LJ/2
      LS(L)=0
      JLT(L)=LJ/2
      ML=1
      L=L+1
      GOTO 80
  82  DO 83 M=1,3
      N1(L)=NN(I)
      L1(L)=LMIN/2
      N2(L)=NN(J)
      L2(L)=LMAX/2
      LT(L)=LJ/2
      LS(L)=1
      JLT(L)=(LJ-4+2*M)/2
      ML=0
      L=L+1
  83  CONTINUE
  80  CONTINUE
      GOTO 94
  90  DO 97 M=1,N
      N1(L)=NN(I)
      N2(L)=NN(J)
      L1(L)=LMIN/2
      L2(L)=LMAX/2
      LT(L)=LLESS/2
      LS(L)=0
      JLT(L)=LT(L)
      L=L+1
      DO 96 MN=1,3
      N1(L)=NN(I)
      N2(L)=NN(J)
      L1(L)=LMIN/2
      L2(L)=LMAX/2
      LT(L)=LLESS/2
      LS(L)=1
      JLT(L)=(2*LT(L)-4+2*MN)/2
  96  L=L+1
  97  LLESS=LLESS+2
  94  CONTINUE
  93  CONTINUE
 1000 RETURN
      END
C
C  CALCULATES THE POSSIBLE QUANTUM NUMBERS FOR THE 
C  TRANSFORMATION TO C-O-M AND RELATIVE COORIDINATES
C
      SUBROUTINE MOSHQN(N1,L1,N2,L2,LB,N,L,NN,LL,NUM)
CBAB      DIMENSION N(100),L(100),NN(100),LL(100)
      DIMENSION N(*),L(*),NN(*),LL(*)
      JJ=1
      MAX=2*N1+2*N2+L1+L2
      DO 10 I=1,MAX+1
      LJ=I-1
      LEFT=MAX-LJ
      DO 11 K=1,LEFT+1
      LLJ=K-1
      IF(LB.GT.(LJ+LLJ).OR.(LB.GT.(L1+L2)))GOTO 11
      IF(LB.LT.IABS(LJ-LLJ).OR.(LB.LT.IABS(L1-L2)))GOTO 11
      IF(IAND((LJ+LLJ+L1+L2),1).EQ.1)GOTO 11
      MAXN2=(MAX-LJ-LLJ)/2
      DO 12 M=1,MAXN2+1
      NNLEFT=(MAX-LJ-LLJ-2*(M-1))/2
      NM=M-1
      IF((2*(M-1)+2*NNLEFT+LJ+LLJ).NE.MAX) GOTO 12
      IF((2*N1+L1+2*N2+L2).NE.(2*NM+LJ+2*NNLEFT+LLJ))GOTO 12
      IF((N1.EQ.N2).AND.(L1.EQ.L2).AND.(IAND((LB+LLJ),1)
     $.EQ.1))GOTO 12
      IF((NM.EQ.NNLEFT).AND.(LJ.EQ.LLJ).AND.(IAND((LB+L1),1)
     $.EQ.1))GOTO 12
      IF(NNLEFT.LT.0) GOTO 12
      N(JJ)=M-1
      NN(JJ)=NNLEFT
      L(JJ)=LJ
      LL(JJ)=LLJ
      JJ=JJ+1
   12 CONTINUE
   11 CONTINUE
   10 CONTINUE
      NUM=JJ-1
      RETURN
      END
C
C   GIVES ALL THE QN FOR THE TWO PARTICLE WAVEFUNCTIONS
C   FOR A SET OF ORBITS DENOTED BY N,L AND A GIVEN ISOSPIN,
C   N STARTS WITH ZERO.
C
      SUBROUTINE REQN(NN,LLJ,K1,IT,NS,LS,NB,LB,LTOT,NUM)
      DIMENSION NN(10),LLJ(10),NA(100),LA(100),NB(250),LB(250)
      DIMENSION LAB(100),ISAB(100),NS(250),LS(250)
      DIMENSION JAB(100),NNB(100),LLB(100)
      DIMENSION NSAB(150),LSAB(150),NBAB(150),LBAB(150),LTOT(250)
      CALL LSQN(NN,LLJ,K1,IT,NA,LA,NNB,LLB,ISAB,LAB,JAB,NUMBAB)
      JJ=1
      DO 10 J=1,NUMBAB
      CALL MOSHQN(NA(J),LA(J),NNB(J),LLB(J),LAB(J),NSAB,LSAB,NBAB,
     $LBAB,NUMAB)
      IF(JJ.NE.1)GOTO 15
      DO 11 JL=1,NUMAB
      NS(JJ)=NSAB(JL)
      LS(JJ)=LSAB(JL)
      NB(JJ)=NBAB(JL)
      LB(JJ)=LBAB(JL)
      LTOT(JJ)=LAB(J)
  11  JJ=JJ+1
      GOTO 10
  15  DO 20 JL=1,NUMAB
      NJ=JJ-1
      XJ=0.0
      DO 16 KJ=1,NJ
  16  IF((NSAB(JL).EQ.NS(KJ)).AND.(LSAB(JL).EQ.LS(KJ)).AND.
     $(NBAB(JL).EQ.NB(KJ)).AND.(LBAB(JL).EQ.LB(KJ)).AND.
     $(LAB(J).EQ.LTOT(KJ)))XJ=1.0
      IF(XJ.EQ.1.)GOTO 20
      NS(JJ)=NSAB(JL)
      LS(JJ)=LSAB(JL)
      NB(JJ)=NBAB(JL)
      LB(JJ)=LBAB(JL)
      LTOT(JJ)=LAB(J)
      JJ=JJ+1
  20  CONTINUE
  10  CONTINUE
      NUM=JJ-1
1000  END
C
C
C
      SUBROUTINE QN(I,N,L,XJ,LABEL)
      CHARACTER*9 LABEL
      GOTO(1,2,3,4,5,6,7,8,9,10,11,12,
     113,14,15,16,17,18,19,20,21,22,23)I
      TYPE *,'ERROR IN SUBROUTINE QN 1<I<23'
      RETURN
 1     N=0
      L=0
      XJ=.5
      LABEL='0s1/2'
      RETURN
 2      N=0
      L=1
      XJ=1.5
      LABEL='0p3/2'
      RETURN
 3      N=0
      L=1
      XJ=.5
      LABEL='0p1/2'
      RETURN
 4      N=0
      L=2
      XJ=2.5
      LABEL='0d5/2'
      RETURN
 5      N=0
      L=2
      XJ=1.5
      LABEL='0d3/2'
      RETURN
 6      N=1
      L=0
      XJ=.5
      LABEL='1S1/2'
      RETURN
 7      N=0
      L=3
      XJ=3.5
      LABEL='0f7/2'
      RETURN
 8     N=0
      L=3
      XJ=2.5
      LABEL='0f5/2'
      RETURN
 9      N=1
      L=1
      XJ=1.5
      LABEL='1p3/2'
      RETURN
 10      N=1
      L=1
      XJ=.5
      LABEL='1p1/2'
      RETURN
 11      N=0
      L=4
      XJ=4.5
      LABEL='0g9/2'
      RETURN
 12      N=0
      L=4
      XJ=3.5
      LABEL='0g7/2'
      RETURN
 13      N=1
      L=2
      XJ=2.5
      LABEL='1d5/2'
      RETURN
 14      N=1
      L=2
      XJ=1.5
      LABEL='1d3/2'
      RETURN
 15      N=0
      L=5
      XJ=5.5
      LABEL='0h11/2'
      RETURN
 16      N=0
      L=5
      XJ=4.5
      LABEL='0h9/2'
      RETURN
 17      N=2
      L=0
      XJ=.5
      LABEL='2s1/2'
      RETURN
 18      N=1
      L=3
      XJ=3.5
      LABEL='1f7/2'
      RETURN
 19      N=1
      L=3
      XJ=2.5
      LABEL='1f5/2'
      RETURN
 20      N=2
      L=1
      XJ=1.5
      LABEL='2p3/2'
      RETURN
 21      N=2
      L=1
      XJ=.5
      LABEL='2p1/2'
      RETURN
 22      N=0
      L=6
      XJ=6.5
      LABEL='0i13/2'
      RETURN
 23      N=0
      L=6
      XJ=5.5
      LABEL='0i11/2'
      RETURN
      END
C
C
C
C
C
      FUNCTION ICODE(N1,LIN,XJJ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      ICODE=0
      DO 200 JJ=1,23
      GOTO(1,2,3,4,5,6,7,8,9,10,11,12,
     113,14,15,16,17,18,19,20,21,22,23)JJ
29    CONTINUE
200    CONTINUE
      STOP 'ERROR IN ICODE, ORBIT NOT FOUND'
1     N=0
      L=0
      XJ=.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
2     N=0
      L=1
      XJ=1.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
 3      N=0
      L=1
      XJ=.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 4      N=0
      L=2
      XJ=2.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 5      N=0
      L=2
      XJ=1.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 6      N=1
      L=0
      XJ=.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 7      N=0
      L=3
      XJ=3.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 8      N=0
      L=3
      XJ=2.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 9      N=1
      L=1
      XJ=1.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 10      N=1
      L=1
      XJ=.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 11      N=0
      L=4
      XJ=4.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 12      N=0
      L=4
      XJ=3.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 13      N=1
      L=2
      XJ=2.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 14      N=1
      L=2
      XJ=1.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 15      N=0
      L=5
      XJ=5.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 16      N=0
      L=5
      XJ=4.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 17      N=2
      L=0
      XJ=.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 18      N=1
      L=3
      XJ=3.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 19      N=1
      L=3
      XJ=2.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 20      N=2
      L=1
      XJ=1.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 21      N=2
      L=1
      XJ=.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 22      N=0
      L=6
      XJ=6.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
 23      N=0
      L=6
      XJ=5.5
      IF(N1.EQ.N.AND.LIN.EQ.L.AND.XJJ.EQ.XJ)ICODE=JJ
      IF(ICODE.EQ.0)GOTO 29
      RETURN
      END


C
C
      SUBROUTINE MERELQN(JJ,II,IT,KK,NSC,NSD,LS,R,NUMM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION II(4),N(4),L(4),XJ(4),NSA(20),LSA(20),NBA(20)
      DIMENSION LBA(20),NSB(20),LSB(20),NBB(20),LBB(20)
      DIMENSION LTA(20),LTB(20),LS(20),NSC(20),R(20),NSD(20)
      CHARACTER*9 LABEL
      CALL INDEX
      JL=1
      DO I=1,4
      CALL QN(II(I),N(I),L(I),XJ(I),LABEL)
      END DO
      IS=0
      MJ=0 
      JI=2*JJ
      LLT=JI/2
  23  IF(II(1).EQ.II(2).OR.II(3).EQ.II(4))GOTO 25
      GOTO 24
  25  IF(IAND(IS+LLT+IT,1).NE.1)GOTO 14
  24  IF(ITR(L(1),L(2),LLT).EQ.-1)GOTO 14
      IF(ITR(L(3),L(4),LLT).EQ.-1)GOTO 14
      CALL MOSHQN(N(1),L(1),N(2),L(2),LLT,NSA,LSA,NBA,LBA,NUMA)
      CALL MOSHQN(N(3),L(3),N(4),L(4),LLT,NSB,LSB,NBB,LBB,NUMB)
  44  DO 50 I=1,NUMA
      DO 51 J=1,NUMB
      IF(LBA(I).NE.LBB(J))GOTO 51
      IF(NBA(I).NE.NBB(J))GOTO 51
      IF(LSA(I).NE.LSB(J))GOTO 51
      I1=FINDEX(FLOAT(NSA(I)+1),FLOAT(LSA(I)),FLOAT(LSA(I))+.5)
      I2=FINDEX(FLOAT(NSB(J)+1),FLOAT(LSB(J)),FLOAT(LSB(J))+.5)
      IF(JL.NE.1)GOTO 60
      NSC(JL)=NSA(I)
      NSD(JL)=NSB(J)
      LS(JL)=LSA(I)
      R(JL)=RL(I1,I2,KK)*(2.0)**(FLOAT(KK)/2.)
      JL=JL+1
      GOTO 51
  60  XJJ=0.
      DO LJ=1,JL-1
      IF(NSA(I).EQ.NSC(LJ).AND.NSB(J).EQ.NSD(LJ).AND.
     $LSA(I).EQ.LS(LJ))XJJ=1.
      END DO
      IF(XJJ.EQ.1.)GOTO 51
      NSC(JL)=NSA(I)
      NSD(JL)=NSB(J)
      LS(JL)=LSA(I)
      R(JL)=RL(I1,I2,KK)*(2.0)**(FLOAT(KK)/2.)
      JL=JL+1
  51  CONTINUE
  50  CONTINUE
  14  IF(IS.EQ.0)IS=1
      LLT=JI/2-IS+MJ
      MJ=MJ+1
      IF(ITR(IS,LLT,(JI/2)).EQ.1) GOTO 23
      IF(LLT.GT.((JI/2)+1)) GOTO 1000
      GOTO 14
 1000 NUMM=JL-1
      RETURN
      END
C
C
C
      SUBROUTINE SPRELQN(JO1,IT,KK,N1,NORBIT,NSE,NSF,LS,R,NUMBER)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION N(22),L(22),XJ(22)
      DIMENSION II(22),NSC(20),NSD(20)
      DIMENSION NSE(20),NSF(20),LSS(20),LS(20),RR(20),R(20)
      CHARACTER*9 LABEL
      IJ=1
      CALL QN(JO1,NO,LO,XJO,LABEL)
      DO 11 J=1,NORBIT
      CALL QN(J,N(J),L(J),XJ(J),LABEL)
      JMIN=ABS(XJO-XJ(J))
      JMAX=XJO+XJ(J)  
      MJ=0
  9   JJT=JMIN+MJ
      IF(JJT.GT.JMAX) GOTO 12
      II(2)=JO1
      II(1)=J
      II(4)=JO1
      II(3)=J
      CALL MERELQN(JJT,II,IT,KK,NSC,NSD,LSS,RR,NUMB)
      IF(IJ.NE.1)GOTO 60
      DO JI=1,NUMB
      NSE(IJ)=NSC(JI)
      NSF(IJ)=NSD(JI)
      LS(IJ)=LSS(JI)
      R(IJ)=RR(JI)
      IJ=IJ+1
      END DO
      GOTO 10
  60  DO JI=1,NUMB
      XJJ=0.
      DO JJJL=1,IJ-1
      IF(NSC(JI).EQ.NSE(JJJL).AND.NSD(JI).EQ.NSF(JJJL).AND.
     $LSS(JI).EQ.LS(JJJL))XJJ=1.
      END DO
      IF(XJJ.EQ.1.)GOTO 61
      NSE(IJ)=NSC(JI)
      NSF(IJ)=NSD(JI)
      LS(IJ)=LSS(JI)
      R(IJ)=RR(JI)
      IJ=IJ+1
  61  CONTINUE
      END DO
  10  MJ=MJ+1
      GOTO 9
  12  CONTINUE
  11  CONTINUE
      NUMBER=IJ-1
      END
C
C **************   C O E F 9 J    ***********************************
C
      FUNCTION COEF9J(J1,J2,J3,J4,J5,J6,J7,J8,J9)
C
CCCC  TAMURAS NUMBERING CONVENTION IS USED HERE.
CCCCC THE ARGUMENTS OF COEF9J, WHEN NUMBERED SEQUENTIALLY 1 THROUGH 9,
CCCC    CORRESPOND TO THE ARRAY
CCCC                               1  2  5
CCCC                               3  4  6
CCCC                               7  8  9
C
      DIMENSION LT(9)
CCCCCC
CCCCCC      ALL L9 MUST BE TWICE AS LARGE AS TRUE ARGUMENTS
CCCCCC
C
C               CHANGED FOR THEORY LIBRARY 4/8/82   HK
C
      U9=0.0
      LT(1)=J1
      LT(2)=J2
      LT(3)=J3
      LT(4)=J4
      LT(5)=J5
      LT(6)=J6
      LT(7)=J7
      LT(8)=J8
      LT(9)=J9
      LMIN=LT(1)
      IMIN=1
      DO 20 I=2,9
      IF(LT(I)-LMIN) 15,20,20
   15 LMIN=LT(I)
      IMIN=I
   20 CONTINUE
      KEX=0
      GO TO (110,110,110,110,150,150,170,170,190),IMIN
  110 MM=(IMIN-1)/2+1
      M1=MM+MM-1
      M2=M1+1
      M3=MM+4
      L1=LT(7)
      LT(7)=LT(M1)
      LT(M1)=L1
      L1=LT(8)
      LT(8)=LT(M2)
      LT(M2)=L1
      L1=LT(9)
      LT(9)=LT(M3)
      LT(M3)=L1
      IMIN=IMIN+(7-M1)
      GO TO 175
  150 KEX=1
      M1=7
      M2=8
      M3=IMIN+IMIN-9
      M4=M3+1
      GO TO 180
  170 KEX=1
  175 M1=5
      M2=6
      M3=IMIN-6
      M4=M3+2
  180 L1=LT(M1)
      L1=LT(M1)
      LT(M1)=LT(M3)
      LT(M3)=L1
      L1=LT(M2)
      LT(M2)=LT(M4)
      LT(M4)=L1
      L1=LT(9)
      LT(9)=LT(IMIN)
      LT(IMIN)=L1
  190 IF(LT(9)) 200,200,300
  200 IF(LT(5)-LT(6)) 1000,210,1000
  210 IF(LT(7)-LT(8)) 1000,220,1000
  220 RT=(LT(5)+1)*(LT(7)+1)
      K=(LT(5)+LT(7)-LT(1)-LT(4))/2
      RAC= RACAH(LT(1),LT(2),LT(3),LT(4),LT(5),LT(7))
      PH=1.
      IF (2*(K/2) .NE. K) PH=-1.
      U9=(RAC/SQRT(RT))*PH
      GO TO 370
  300 K1=IABS(LT(2)-LT(7))
      K2=IABS(LT(3)-LT(5))
      K3=IABS(LT(4)-LT(9))
      NMIN=MAX0(K1,K2,K3)
      K1=LT(2)+LT(7)
      K2=LT(3)+LT(5)
      K3=LT(4)+LT(9)
      NMAX=MIN0(K1,K2,K3)
      IF (NMIN-NMAX) 320, 320, 1000
  320 DO 350 N=NMIN,NMAX,2
      W1=N+1
      RAC= RACAH(LT(2),LT(5),LT(7),LT(3),LT(1),N)
      IF (RAC) 321, 350, 321
  321 W1=W1*RAC
      RAC= RACAH(LT(2),LT(4),LT(7),LT(9),LT(8),N)
      IF (RAC) 322, 350, 322
  322 W1=W1*RAC
      RAC= RACAH(LT(3),LT(4),LT(5),LT(9),LT(6),N)
      IF (RAC) 323, 350, 323
  323 U9=U9+W1*RAC
  350 CONTINUE
  370 IF(KEX) 400,1000,400
  400 KP=0
      DO 410 I=1,9
  410 KP=KP+LT(I)
      K=KP/2
      PH=1.
      IF (2*(K/2) .NE. K) PH=-1.
      U9=U9*PH
 1000 COEF9J=U9
      RETURN
      END
