CEKW      OPER.FOR --- CHANGES TO GIVE D(J),D(M) = 24,192
CA  THIS PROGRAM CALCULATES HAMILTONIAN OPERATORS
CA  OR ANY OTHER OPERATORS WITH  ARBITRARY
CA  TWO BODY MATRIX ELEMENTS
CA  NOMENCLATURE:
CA  <NiLiJi,NjLjJj|V|NkLkJk,NlLlJl>coupled to J T. Each orbital has
CA  a given order 1,2,3,.... so the set of quantum numbers
CA  |NnLnJn> is represented by only one number: its order. These numbers
CA  are wrapped in  CMA1(N), where N labels which matrix element. J and T
CA  are not wrapped in CMA1's. At a latter stage as there
CA  might be in general several CMA1'S for different J T combinations:
CA  J T will be wrapped in CMAT's. Number of CMA1's
CA  is shrunk  so as to keep only those different from each other.
CA  Program will reorder if .INT file has matrix elements uncorrected
CA  ordered in either vertical or horizontal directions.
CA  If uncorrected ordered in horizontal
CA  axis it will try the reverse code (i.e. exchange I,J-->K,L) and if
Ca  it fails again it will produced an error message and exit
CA  (' VMAT not found ').
CA  The proper order is: numerically increasing downwards and I.GE.J and
CA  K.GE.L. Only requirement is that the first line (comment line, shell
CA  names) of .INT file has to have the same order as the SPS file .
CA  If the two body matrix elements were not in proper order program will order
CA  them and output them (if line printer file is required) to the
CA  line printer file (.LPO).
     
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHGR:PARAM.INC'
      INCLUDE 'OPRCOM.INC'
CBAB INCREASED FOR FPG SPACE
CBAB      PARAMETER (MAX_IBAB=125000,MAX_ELEM_PART=10000)
      PARAMETER (MAX_IBAB=300000,MAX_ELEM_PART=30000) 
CEKW      PARAMETER (MAX_IBAB=1600000,MAX_ELEM_PART=60000)
      COMMON/PFIND/NJLM,NNEG_HPART,NPART2,IP,SPAR,
     1  NNEG_HPARTV(N_WORDSO,MAX_NPARTO),IJKL(MAX_NPARTO),
     1  NNEG_IJKLH(MAX_NPARTO)
      COMMON/CRAC/IA,IB,IC,ID,IE,IF,CLEB
      COMMON/SPS/NQU(MAX_NSPS),LQU(MAX_NSPS),JTW(MAX_NSPS),
     1MZTW(MAX_NSPS),ITZTW(MAX_NSPS),NPJ(MAX_NJL),KPARJ(MAX_NJL)
      COMMON/JSCHEME/VMAT(MAX_TBME),CMA1(MAX_TBME),CMAT(MAX_TBME),
     1IJKLV(MAX_IBAB),IJKLP(MAX_IBAB),IJKLVO(MAX_ELEM_PART)
      LOGICAL EXIST,HPART_LOGIC(MAX_NPARTO),ISOSPIN
      INTEGER HPART(N_WORDSO,MAX_NPARTO),LARGE(N_WORDSO),ITEMP(N_WORDSO)
     1,ZERO(N_WORDSO),SPARP(N_WORDSO),SPAR(N_WORDSO)
      REAL HIJKL(MAX_IBAB),HIJKLO(MAX_ELEM_PART)
      REAL *8 CMAT,CMA1,TEMP1,TEMP2,COD1,COD3,COD4,
     1FN,CLEB
      COMMON/NEUTPROT/NOSC,NJL,NMAT,ENL(MAX_NJL),NOSCJL(MAX_NOSC),
     1ISPS_ORDER(MAX_NSPS),NPOS(MAX_TBME)
      DIMENSION ISPS_N(MAX_NSPS),ISPS_L(MAX_NSPS),ISPS_J(MAX_NSPS)
     1,ISPS_TZ(MAX_NSPS),IONE(N_WORDSO)
      CHARACTER *9 SHELL(MAX_NJL),INTFIL,OPFIL,SPSFIL,LPTFIL,RESP1*1
      CHARACTER *13 SPSF,OPF,INTF
      CHARACTER*1 MODE
      INTEGER*4 IJKLV,IJKLVO,I,J,K,L
      LOGICAL I1,J1,K1,L1,IH
      INCLUDE 'SHGR:DATA.INC'
     
C                                           CPU TIME CLOCK START
      IF(IFPS.EQ.2) THEN
      OPEN(UNIT=5,FILE='odat',STATUS='OLD')
      OPEN(UNIT=6,FILE='owrt',STATUS='NEW')
      ELSE
      END IF
      CALL TIMER('START')
      NJLM=MAX_NJL
CA SET UP FACTORIAL TABLE FOR CLEBSCH SUBROUTINE
      DO 10001  I=1,N_WORDSO
      ZERO(I)=0
C      END DO
10001 CONTINUE
CBAB MOVED TO CLEBG, APRIL 1988
CBAB      FACLOG(1)=0.0
CBAB      FACLOG(2)=0.0
CBAB      FN=1.0
CBAB      DO 41 N=3,100
CBAB      FN=FN+1.0
CBAB41    FACLOG(N)=FACLOG(N-1)+DLOG(FN)
     
C  GET INPUT INFORMATION
     
      WRITE(6,1000)
1000  FORMAT(' Line printer output (0=None,1=JT Mat.elems, 2=
     1JzTz Mat.elems.) : ')
      CALL FREE_INT(5,1,INT_VAR,READ_ERR)
      INP=INT_VAR(1)
CWEO      READ(5,1001) INP
CWEO1001  FORMAT(I)
CBAB      IF (INP.NE.0)THEN
CBAB      WRITE(6,1005)
CBAB1005  FORMAT(' Name for LPT output : ')
CBAB      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
CBAB      LPTFIL=CHAR_VAR(1)
CWEO      READ(5,2) LPTFIL
      IF(INP.GT.0) LPTFIL = 'OPER'
      IF(INP.GT.0) CALL OPEN_FILE(3,LPTFIL,'.LPO','NEW','FORM')
CBAB      END IF
      WRITE(6,1)
1     FORMAT(' Single-particle state file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      SPSFIL=CHAR_VAR(1)
CWEO      READ(5,2) SPSFIL
      IF (INP.GT.0)THEN
      WRITE(3,8110)
8110  FORMAT(1X,'OUTPUT OF OPER')
      CALL TITLE(3)
      WRITE(3,1002)SPSFIL
1002  FORMAT(' SINGLE-PARTICLE STATE FILE : ',A9,/)
CWEO2     FORMAT(A)
      END IF
      IPOSI=INDEX(SPSFIL,' ')
      IF(IPOSI.EQ.0)IPOSI=10
      IPOSI=IPOSI-1
CZ
      IF(IFPS.EQ.2) THEN
      SPSF=SPSFIL(1:IPOSI)//'.s'
      ELSE
      SPSF=SPSFIL(1:IPOSI)//'.SPS'
      END IF
CZ
      CALL OPENSPS(1,SPSF,0)
C
C
C  READ NO OF SP STATES ,NO OF J LEVELS, MAX NO OF
C  PARTICLES IN EACH LEVEL.
C
      CALL FREE_INT(1,30,INT_VAR,READ_ERR)
      NSPS=INT_VAR(1)
      IPP = NSPS+1
      NJL=INT_VAR(2)
      DO 14001 I=1,NJL
14001 NPJ(I)=INT_VAR(I+2)
CBAB      NOSC=INT_VAR(NJL+2)
      NOSC=INT_VAR(NJL+3)
      DO 14002 I=1,NOSC
CBAB14002 NOSCJL(I)=INT_VAR(I+NJL+3)
14002 NOSCJL(I)=INT_VAR(I+NJL+4)
CWEO      READ(1,*) NSPS,NJL,(NPJ(I),I=1,NJL),NOSC,(NOSCJL(I),I=1,NOSC)
CA  NSPS<0 USED ONLY IN MAXMIN, SUBROUTINE OF BASIS
      IF(NSPS.LT.0)NSPS=-NSPS
      IF (INP.GT.0) WRITE(3,1003) NSPS,NJL,(NPJ(I),I=1,NJL)
1003  FORMAT(' NO. OF SINGLE PARTICLE STATES : ',I4
     1/' NO.OF J LEVELS, NO. OF PARTICLES PER LEVEL : ',/,1X,
     1I4,';',15(I3,','))
3     FORMAT(15I4)
      IF (NSPS.GT.MAX_NSPS)STOP ' ERROR IN MAIN: NSPS too large'
      CALL FREE_REAL_A(1,NJL,CHAR_VAR,0,REAL_VAR,READ_ERR)
      DO 14003 I=1,NJL
14003 SHELL(I)=CHAR_VAR(I)
CWEO      READ(1,5) (SHELL(I),I=1,NJL)
CBAB5 FORMAT(10A)
5     FORMAT(12A9)
      IF (INP.GT.0) WRITE(3,1006) (SHELL(I),I=1,NJL)
CBAB1006 FORMAT(/' J-LEVELS USED : ',10(A,3X))
1006  FORMAT(/' J-LEVELS USED : ',/,1X,12(A9,1X))
C  READ IN QUANTUM NOS OF STATES
C  ORDERING: -VE M VALUES FIRST IN DECREASING ORDER OF MAGNITUDE
C  THEN +VE M VALUES  IN DECREASING ORDER OF MAGNITUDE
C  TZ=0.5 MUST IMMEDIATELY FOLLOW TZ=-0.5
      IF (INP.GT.0) WRITE(3,1009)
1009  FORMAT(1X,/,'NUMBER   N    L   2J  2M   2TZ'/)
C  NON IS A DUMMY VARIABLE JUST TO LABEL THE STATES ON THE FILE
C  IT IS NOT USED INTERNALLY
C  NQU IS THE PRINCIPLE QUANTUM NO
C  LQU IS THE L VALUE
C  JTW IS TWICE THE J VALUE
C  MZTW IS TWICE THE VALUE OF JZ
C  ITZTW IS TWICE THE VALUE OF THE ISOSPIN PROJECTION
CA  ISPS_ORDER USE TO ORDER NUMERICALLY IN INCREASING ORDER THE J-ORBITS
CA  FOR THE FIND SUBROUTINE
      IARG=0
      ITZTOT = 0
      DO 10002  JL=1,NJL
      DO 10003  NS=1,NPJ(JL)
      IARG=IARG+1
      CALL FREE_INT(1,6,INT_VAR,READ_ERR)
      NQU(IARG)=INT_VAR(2)
      LQU(IARG)=INT_VAR(3)
      JTW(IARG)=INT_VAR(4)
      MZTW(IARG)=INT_VAR(5)
      ITZTW(IARG)=INT_VAR(6)
     
CWEO      READ(1,*) NON,NQU(IARG),LQU(IARG),JTW(IARG),
CWEO     1MZTW(IARG),ITZTW(IARG)
C  ISOSPIN true for isospin formalism and false for p/n formalism.
      ISOSPIN=.TRUE.
      IF(ITZTW(1).EQ.ITZTW(2))ISOSPIN=.FALSE.
      ITZTOT = ITZTOT+ITZTW(IARG)
      IF (INP.GT.0) WRITE(3,1010) IARG,NQU(IARG),LQU(IARG),
     1JTW(IARG),MZTW(IARG),ITZTW(IARG)
1010  FORMAT(6I5)
      ISPS_ORDER(IARG)=JL
      ISPS_N(IARG)=NQU(IARG)
      ISPS_L(IARG)=LQU(IARG)
      ISPS_J(IARG)=JTW(IARG)
      ISPS_TZ(IARG)=ITZTW(IARG)
      IF(NS.EQ.1)KPARJ(JL)=LQU(IARG)
C      END DO
10003 CONTINUE
C      END DO
10002 CONTINUE
      MODE = ' '
      IF(ITZTOT.EQ.NSPS) MODE = 'N'
      IF(ITZTOT.EQ.-NSPS) MODE = 'P'
      CLOSE(UNIT=1)
C
C
202   WRITE(6,21)
21    FORMAT(' Interaction filename : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      INTFIL=CHAR_VAR(1)
CWEO      READ(5,2) INTFIL
      NPOSI=INDEX(INTFIL,' ')
      IF(NPOSI.EQ.0)NPOSI=10
      NPOSI=NPOSI-1
C      SPSF=SPSFIL//'.SPS'
      OPFIL=INTFIL
CZ
      IF(IFPS.EQ.2) THEN
      OPF=INTFIL(1:NPOSI)//'.o'
      INTF=INTFIL(1:NPOSI)//'.i'
      ELSE
      OPF=INTFIL(1:NPOSI)//'.OP'
      INTF=INTFIL(1:NPOSI)//'.INT'
      END IF
CZ
C
C
C
C  CALCULATE THE  OPERATOR
C
C
C
      ROOT2=SQRT(2.0D0)
C  WORK OUT ALL POSSIBLE OPERATOR PARTITIONS AND ORDER NUMERICALLY
C  PARTITIONS ARE DEFINED BY WHICH J-LEVEL STATES ARE CREATED AND DESTROYED
      II=1
      IONE(1)=1
CBAB  CALL LIB_BTSX(LARGE(1),N_WORDSO*32-1,N_WORDSO)
      DO 60 I=1,NJL
      DO 60 J=I,NJL
      DO 60 K=1,NJL
      DO 60 L=K,NJL
CA  check parity
      KPART=KPARJ(I)+KPARJ(J)+KPARJ(K)+KPARJ(L)
      IF (MOD(KPART,2).NE.0) GO TO 60
      II=II+1
      IF(II.GT.MAX_NPARTO) IERMAXN=II
CBAB  IF (II.GT.MAX_NPARTO)STOP
CBAB 1' ***** FATAL ERROR: INCREASE MAX_NPARTO IN OPRCOM.FOR *****'
      IF(IERMAXN.NE.0) GO TO 60
      CALL LIB_ASSIGNX(ZERO(1),HPART(1,II),N_WORDSO)
CWEO      HPART_BYTE(I,II)=1
CWEO      HPART_BYTE(J,II)=HPART_BYTE(J,II)+1
CWEO      HPART_BYTE(K,II)=HPART_BYTE(K,II)-1
CWEO      HPART_BYTE(L,II)=HPART_BYTE(L,II)-1
      HPART(I,II)=1
      HPART(J,II)=HPART(J,II)+1
      HPART(K,II)=HPART(K,II)-1
      HPART(L,II)=HPART(L,II)-1
C                               flags positive partition
      HPART_LOGIC(II)=.FALSE.
C                             find if a neg. hamiltonian partition
CWEO      WRITE(35,11010)(HPART(IF,II),IF=1,NJL)
CWEO11010 FORMAT(1X,<NJL>(I9,1X))
      DO 8711 IF=NJL,1,-1
CWEO      IF(HPART_BYTE(IF,II).EQ.0)GO TO 8711
CWEO      IF(HPART_BYTE(IF,II).LT.0)THEN
      IF(HPART(IF,II).EQ.0)GO TO 8711
      IF(HPART(IF,II).LT.0)THEN
C                               flags negative partition
      HPART_LOGIC(II)=.TRUE.
      GO TO 872
      ELSE
C                  positive or zero hamiltonian partition
      GO TO 872
      END IF
8711  CONTINUE
872   CONTINUE
CWEO      WRITE(35,11011)HPART_LOGIC(II)
CWEO11011 FORMAT(1X,'HPART_LOGIC ',L5)
CBAB  IF(LIB_GEX(HPART(1,II),LARGE(1),N_WORDSO))STOP
CBAB 1'***** FATAL ERROR:LARGE not large enough *****'
      IF(LIB_GEX(HPART(1,II),LARGE(1),N_WORDSO))
     1CALL LIB_ADDX(IONE(1),HPART(1,II),LARGE(1),N_WORDSO)
CBAB     1CALL LIB_ASSIGNX(HPART(1,II),LARGE(1),N_WORDSO)
60    CONTINUE
     
      IF(IERMAXN.GT.1) WRITE(6,4022)IERMAXN
4022  FORMAT(1X,'FATAL ERROR: INCREASE MAX_NPARTO IN OPRCOM.INC
     1TO ',I8)
      IF(IERMAXN.GT.1) STOP
     
     
      NPART=II-1
CA  Non negative hamiltonian partitions:
      II=1
      DO 10004  I=1,NPART
      IF(.NOT.HPART_LOGIC(I))THEN
        CALL LIB_ASSIGNX(HPART(1,I),NNEG_HPARTV(1,II),N_WORDSO)
        IJKL(II)=0
        II=II+1
      END IF
C      END DO
10004 CONTINUE
CA  Reorder the partitions numerically
      NPART=II-1
      DO 65 I=1,NPART
      LEAST=I
CWEO      WRITE(35,11012)I,(NNEG_HPARTV(KP,I),KP=1,NJL)
      DO 64 J=I+1,NPART+1
CWEO      WRITE(35,11012)J,(NNEG_HPARTV(KP,J),KP=1,NJL)
      IF (LIB_EQX(NNEG_HPARTV(1,J),NNEG_HPARTV(1,LEAST),N_WORDSO))
     1CALL LIB_ASSIGNX(LARGE(1),NNEG_HPARTV(1,J),N_WORDSO)
      IF (LIB_LTX(NNEG_HPARTV(1,J),NNEG_HPARTV(1,LEAST),N_WORDSO))
     1LEAST=J
64    CONTINUE
      IF (LIB_EQX(NNEG_HPARTV(1,LEAST),LARGE(1),N_WORDSO)) GO TO 66
      CALL LIB_ASSIGNX(NNEG_HPARTV(1,I),ITEMP(1),N_WORDSO)
      CALL LIB_ASSIGNX(NNEG_HPARTV(1,LEAST),NNEG_HPARTV(1,I),N_WORDSO)
      CALL LIB_ASSIGNX(ITEMP(1),NNEG_HPARTV(1,LEAST),N_WORDSO)
65    CONTINUE
66    NNEG_HPART=I-1
      WRITE(6,3325)NNEG_HPART
3325  FORMAT(/' NO. OF NON NEGATIVE HAMILTONIAN PARTITIONS : ',I10)
      NPART=2*NNEG_HPART-1
      NPART2=1
151   NPART2=2*NPART2
      IF(NPART2.LT.NNEG_HPART)GO TO 151
CA  NNEG_IJKLH CONTAINS WRAPPED I J K L INTEGERS OF NON NEGATIVE
CA  HAMILTONIAN PARTITIONS
     
     
     
C
C  READ IN THE TWO BODY MATRIX ELEMENTS
203   IF (INP.GT.0)THEN
      WRITE(3,1021) INTFIL(1:NPOSI)
1021  FORMAT('1'//' INPUT MATRIX ELEMENTS FILE
     1:  ',A9,'.INT')
      WRITE(3,206)OPFIL(1:NPOSI)
206   FORMAT(' OPERATOR OUTPUT FILE
     1:  ',A9,'.OP')
      END IF
CZ      CLOSE(UNIT=1)
      CALL OPENINT(1,AREA_SPS,AREA_INT,INTF,0,IERR)
      IF(IERR.EQ.1) WRITE(6,220)INTFIL
      IF(IERR.EQ.1) STOP
220   FORMAT(1X,'INTFIL = ',A9,' NOT FOUND')
C  READ IN THE NO OF MATRIX ELEMENTS
C  ORDER MUST BE AS DEFINED IN .SPS FILE
CBAB  READ(1,*)!COMMENTS OF .INT FILE - Not used internally
      CALL FREE_REAL(1,NJL+1,REAL_VAR,READ_ERR)
      NMAT=INT(REAL_VAR(1))
      DO 14004 I=1,NJL
14004 ENL(I)=REAL_VAR(I+1)
CWEO      READ(1,*) NMAT,(ENL(I),I=1,NJL)
      IF (NMAT+1.GT.MAX_TBME)STOP ' ERROR IN MAIN: increase
     1matrix dimension (VMAT)'
      WRITE(6,13001)
13001 FORMAT(1X,' ')
      WRITE(6,776)(SHELL(I),ENL(I),I=1,NJL)
776   FORMAT(' Shell =',A9,2X,'S.P.Energy =',F12.4,' MeV')
      WRITE(6,13002)
13002 FORMAT(1X,' CHECK if above correspondance between S.P.Energies and
     1 shells is correct ')
      WRITE(6,13001)
      IF (INP.GT.0) WRITE(3,208) (ENL(I),I=1,NJL)
208   FORMAT(/' SINGLE PARTICLE ENERGIES : ',5F12.4)
      IF (INP.GT.0)THEN
      WRITE(3,1022) NMAT
1022  FORMAT(' NO. OF INTERACTION MATRIX ELEMENTS : ',I7)
      END IF
      NCMA=0
      N=0
     
CBAB  IF(.NOT.ISOSPIN.AND.NOSC.GT.1)THEN
CBAB  WRITE(6,211)
CBAB211 FORMAT(' Would you like a new INT file with only
CBAB 1 the N/P formalism matrix elements : ')
CBAB  READ(5,2)RESP1
CBAB  IF(RESP1.EQ.'Y')CALL NEUTPROT(INTFIL)
CBAB  END IF
     
20    N=N+1
CA  Read in J-scheme matrix
      READ(1,*,END=30)IWF,JWF,KWF,LWF,JJTW,ITTW,VMAT(N)
C      CALL FREE_REAL(1,7,REAL_VAR,READ_ERR)
C      IF(READ_ERR)GOTO 30
C      IWF=REAL_VAR(1)
C      JWF=REAL_VAR(2)
C      KWF=REAL_VAR(3)
C      LWF=REAL_VAR(4)
C      JJTW=REAL_VAR(5)
C      ITTW=REAL_VAR(6)
C      VMAT(N)=REAL_VAR(7)
      JJTW=2*JJTW
      ITTW=2*ITTW
C  HERE THE DEFINITION OF VMAT IS (N1L1J1,N2L2J2[V]N3L3J3,N4L4J4) COUPLED TO
C  TOTAL J AND T , GIVEN BY JJTW=2J AND ITTW=2T
C  Only do I.GE.J and K.GE.L - See comments under first record of .OP file
C  Do-loops 300 and 301, 302 and 303
C                           work out JMTW1,JMTW2 if reversed
      IF(IWF.LT.JWF)THEN
       DO 10005  I=1,NSPS
       IF(ISPS_ORDER(I).EQ.IWF)GO TO 234
C       END DO
10005  CONTINUE
       STOP ' ***** FATAL ERRROR: IWF *****'
234    DO 10006  J=1,NSPS
       IF(ISPS_ORDER(J).EQ.JWF)GO TO 235
C       END DO
10006  CONTINUE
       STOP '***** FATAL ERROR: JWF *****'
235    JMTW1=JTW(I)
       JMTW2=JTW(J)
       IITEMP=IWF
       IWF=JWF
       JWF=IITEMP
CA  IF REVERSED, MULTIPLY BY CORRESPONDING PHASE
       VMAT(N)=VMAT(N)*
     1 (1.0-2.0*MOD(IABS(JMTW1+JMTW2-JJTW-ITTW)/2,2))
      END IF
     
C                          Work out JMTW3,JMTW4 if reversed
      IF(KWF.LT.LWF)THEN
       DO 10007  K=1,NSPS
       IF(ISPS_ORDER(K).EQ.KWF)GO TO 236
C       END DO
10007  CONTINUE
       STOP ' ***** FATAL ERROR: KWF *****'
236    DO 10008  L=1,NSPS
       IF(ISPS_ORDER(L).EQ.LWF)GO TO 237
C       END DO
10008  CONTINUE
       STOP ' ***** FATAL ERROR: LWF *****'
237    JMTW3=JTW(K)
       JMTW4=JTW(L)
       IITEMP=KWF
       KWF=LWF
       LWF=IITEMP
       VMAT(N)=VMAT(N)*
     1 (1.0-2.0*MOD(IABS(JMTW3+JMTW4-JJTW-ITTW)/2,2))
      END IF
     
      CMA1(N)=LWF+100*KWF+1.D4*JWF+1.D6*IWF
      CMAT(N)=CMA1(N)*1.D4+1.D2*JJTW+1.D0*ITTW
      GO TO 20
30    CLOSE(UNIT=1)
      N=N-1
      IF (N.NE.NMAT) WRITE(6,31)NMAT,N
31    FORMAT(' ***** INFORMATION from MAIN *****'/' NMAT,
     1No. of matrix elements : ',2I5)
      NMAT=N
      IF (NMAT.GE.MAX_TBME) GO TO 910
CA  I and J, K and L have been ordered for any given matrix element
CA  now let's order the rows
C
C  ORDER CMAT
C
      DO 33 NNN=2,NMAT
      IORDER=1
      DO 32 N=2,NMAT
      IF(CMAT(N).GE.CMAT(N-1))GO TO 32
      IORDER=0
CA  REORDER CMAT
      TEMP1=CMAT(N-1)
      CMAT(N-1)=CMAT(N)
      CMAT(N)=TEMP1
CA  REORDER CMA1
      TEMP1=CMA1(N-1)
      CMA1(N-1)=CMA1(N)
      CMA1(N)=TEMP1
CA  REORDER VMAT
      TEMP=VMAT(N-1)
      VMAT(N-1)=VMAT(N)
      VMAT(N)=TEMP
32    CONTINUE
      IF (IORDER.EQ.1) GO TO 34
33    CONTINUE
C  RESORT CMA1, AS ONLY WANT CMA'S IF DIFFERENT
C  AND STORE POSITIONS OF DIFFERENT CMA'S. IT JUMPS EQUALS CMA1'S WHEN
CA  CMAT'S ARE EQUAL.
34    NCMA=1
      NPOS(1)=1
CA  As they are numerically ordered if they are equal they must be adjacents
      DO 38 N=2,NMAT
      IF (CMA1(N).EQ.CMA1(NCMA))GO TO 36
CA  they are different, only store CMA1 when different and store position
C   where they start, i.e. different J,T values
      NCMA=NCMA+1
      CMA1(NCMA)=CMA1(N)
      NPOS(NCMA)=N
CA  Now error messages. CMAT'S are all kept as they should all be different.
CA  It will now check the order of CMAT independent whether CMA1 are different
CA  or not.
36    IF(CMAT(N).LT.CMAT(N-1))THEN
      WRITE(6,29)N
29    FORMAT(' ***** FATAL ERROR: CMAT(N).EQ.CMAT(N-1)
     1 FOR N = ',I5,' *****')
      WRITE(6,897)(CMAT(J),J=1,NMAT)
      STOP ' ***** FATAL ERROR: CMAT(N).LT.CMAT(N-1) *****'
      END IF
897   FORMAT(D19.12)
      IF (CMAT(N).EQ.CMAT(N-1)) THEN
      WRITE(6,29)N
      WRITE(6,897)(CMAT(J),J=1,NMAT)
      STOP
      END IF
38    CONTINUE
      NPOS(NCMA+1)=NMAT+1
      IF(INP.GT.0)THEN
      IF(NNN.NE.2)WRITE(3,1052)
1052  FORMAT(//,' Reordered interaction: ' )
      WRITE(3,1025)
1025  FORMAT(/'   I      J     K     L       Jt    Tt         V',/)
      DO 10009  I=1,NMAT
      IWF=CMAT(I)/1.D10
      JWF=(CMAT(I)/1.D8-IWF*100)
      KWF=(CMAT(I)/1.D6-IWF*1.D4-JWF*100)
      LWF=(CMAT(I)/1.D4-IWF*1.D6-JWF*1.D4-KWF*100)
      JJTW=(CMAT(I)/1.D2-IWF*1.D8-JWF*1D6-KWF*1.D4-LWF*100)
      ITTW=CMAT(I)-IWF*1.D10-JWF*1.D8-KWF*1.D6-LWF*1.D4-JJTW*100
      IFJ=JJTW/2.
      IT=ITTW/2.
      WRITE(3,1023)IWF,JWF,KWF,LWF,IFJ,IT,VMAT(I)
1023  FORMAT(I4,I7,2I6,5X,I4,2X,I4,E15.4)
C      END DO
10009 CONTINUE
      END IF
     
     
     
     
     
C  SET UP FOR FIND ROUTINE
     
      NCMA2=1
50    NCMA2=NCMA2*2
      IF (NCMA2.LT.NCMA) GO TO 50
     
     
     
      CALL NAME_FILE(OPF,FILE_NAME,FILE_EXT)
      CALL OPEN_FILE(1,FILE_NAME,FILE_EXT,'NEW','UFRM')
      WRITE(1) INTF,NSPS,NPART,NJL,(ENL(I),I=1,NJL),
     1(SHELL(I),I=1,NJL),SPSF
C  LOOP OVER THE SP STATES FOUR TIMES FOR EACH OPERATOR PARTITION,
C  AND CHECK WHETHER ELEMENT IS IN THAT PARTITION
C
C  WE USE THE CONVENTION THAT WE SUM OVER I,J,K,L WITH
C  I>J,K>L WITH VIJKL BEING THE DIRECT-EXCHANGE MATRIX
C  ELEMENT , I.E. IT IS CALCULATED BETWEEN COMPLETELY
C  ANTISYMMETRIC STATES
C
C  VIJKL = <IJ/V/KL> - <IJ/V/LK>
C
C  ONLY DO THE ZERO AND +VE PARTITIONS BECAUSE OF IJ-KL SYMMETRY
C  FOR THE ZERO PARTITION DO I>K,
C  I=K & J>L,  I=K & J=L & 0.5*VIJKL
C  THIS IS BECAUSE IN MATRIX, THE OPERATOR IS APPLIED AS IT IS,
C  AND THEN WITH I,J AND K,L EXCHANGED
     
     
      DO 300 I=2,NSPS
C**      TYPE 7600,NSPS,I
C**7600  FORMAT(1X,
C**     1'FOR TIMING INFORMATION: IN OUTSIDE LOOP 300, IMAX,I = ',2I3)
      DO 301 J=1,I-1
CA  P FOR POSITIVE
      CALL LIB_ASSIGNX(ZERO(1),SPARP(1),N_WORDSO)
CWEO      SPARP_BYTE(ISPS_ORDER(I))=1
      SPARP(ISPS_ORDER(I))=1
      SPARP(ISPS_ORDER(J))=1+SPARP(ISPS_ORDER(J))
C     TYPE 763,(SPARP(IW),IW=NJL,1,-1)
C763  FORMAT(' PLUS ',<NJL>I1)
      SYMA=1.0
CBAB  IF(ISPS_ORDER(I).EQ.ISPS_ORDER(J))SYMA=ROOT2
      IF(ISPS_N(I).EQ.ISPS_N(J).AND.
     1ISPS_L(I).EQ.ISPS_L(J).AND.
     1ISPS_J(I).EQ.ISPS_J(J))SYMA=ROOT2
      MZ=MZTW(I)+MZTW(J)
      ITZ=ITZTW(I)+ITZTW(J)
      LQ=LQU(I)+LQU(J)
     
      DO 302 K=2,NSPS
      IF(ISPS_ORDER(K).GT.ISPS_ORDER(I))GO TO 302
      DO 303 L=1,K-1
C  CONSERVE MZ AND ITZ AND PARITY
      MZT=MZ-MZTW(K)-MZTW(L)
      IF (MZT.NE.0) GO TO 303
      ITZT=ITZ-ITZTW(K)-ITZTW(L)
CBAB IF *.SPS FILE HAS ONLY PROTONS OR NEUTRONS RESTRICT TZ
      IF(MODE.EQ.'P'.AND.(ITZTW(K)+ITZTW(L)).NE.-2) GO TO 303
      IF(MODE.EQ.'N'.AND.(ITZTW(K)+ITZTW(L)).NE.2) GO TO 303
      IF (ITZT.NE.0) GO TO 303
CBAB  IF(ISPS_ORDER(K).GT.ISPS_ORDER(I))GO TO 302
      IF(ISPS_ORDER(K).EQ.ISPS_ORDER(I))THEN
CBAB  IF(ISPS_ORDER(L).GT.ISPS_ORDER(J))GO TO 302
      IF(ISPS_ORDER(L).GT.ISPS_ORDER(J))GO TO 303
      END IF
      LQT=LQ+LQU(K)+LQU(L)
      IF (MOD(LQT,2).NE.0) GO TO 303
      CALL LIB_ASSIGNX(ZERO(1),SPAR(1),N_WORDSO)
      CALL LIB_ASSIGNX(SPARP(1),SPAR(1),N_WORDSO)
CWEO      SPAR_BYTE(ISPS_ORDER(K))=-1+SPAR_BYTE(ISPS_ORDER(K))
CWEO      SPAR_BYTE(ISPS_ORDER(L))=-1+SPAR_BYTE(ISPS_ORDER(L))
      SPAR(ISPS_ORDER(K))=-1+SPAR(ISPS_ORDER(K))
      SPAR(ISPS_ORDER(L))=-1+SPAR(ISPS_ORDER(L))
CWEOC     TYPE 7431,(SPAR_BYTE(IW),IW=NJL,1,-1)
CWEO      WRITE(35,7431)(SPAR(IW),IW=1,NJL)
CWEO7431  FORMAT(' MINUS ',<NJL>(I9,1X))
     
CA  FINDP RETURNS THE PARTITION ORDER IN IP.
      CALL FINDP
      IF(IP.EQ.0)THEN
      WRITE(6,13003)SPAR(1)
13003 FORMAT(1X,I10)
      WRITE(6,997)ISPS_ORDER(I),ISPS_ORDER(J),ISPS_ORDER(K),
     1ISPS_ORDER(L),(SPAR(IW),IW=NJL,1,-1)
CWEO     1,(SPAR_BYTE(IW),IW=NJL,1,-1)
997   FORMAT(' I,J,K,L,  HPART = ',4I3,2X,I100)
      STOP ' ***** FATAL ERROR: Hamiltonian partition does not
     1exist *****'
      END IF
      IF((IP.EQ.1).AND.(K.GT.I)) GO TO 303
      IF((IP.EQ.1).AND.(I.EQ.K).AND.(J.LT.L)) GO TO 303
C  CALCULATE THE MIN AND MAX VALUES OF J,T
      ITMIN=MAX0(0,IABS(ITZ))
      ITMAX=2
C  REMEMBER THESE ARE TWICE THE VALUES
      JM1=IABS(JTW(I)-JTW(J))
      JM2=IABS(JTW(K)-JTW(L))
      JMIN=MAX0(JM1,JM2,IABS(MZ))
      JM1=JTW(I)+JTW(J)
      JM2=JTW(K)+JTW(L)
      JMAX=MIN0(JM1,JM2)
      IF (JMIN.GT.JMAX) GO TO 303
      SYMB=1.0
CBAB  IF(ISPS_ORDER(K).EQ.ISPS_ORDER(L))SYMB=ROOT2
      IF(ISPS_N(K).EQ.ISPS_N(L).AND.
     1ISPS_L(K).EQ.ISPS_L(L).AND.
     1ISPS_J(K).EQ.ISPS_J(L))SYMB=ROOT2
      VIJKL=0.0
      COD1=ISPS_ORDER(I)*1.D6+ISPS_ORDER(J)*1.D4+
     1     ISPS_ORDER(K)*1.D2+ISPS_ORDER(L)
C  FIND ROUTINE TO GET POSN. OF FIRST VMAT WITH CMA1(N)=COD1
      IREVERSE=0
100   N=NCMA
      IF(COD1.EQ.CMA1(N))GOTO 110
      N=NCMA2/2
      M=N
      IF(COD1-CMA1(N))101,110,104
101   M=M/2
      N=N-M
C                          VMAT NOT FOUND, try reverse code or
102   IF(M.EQ.0)GO TO 108
C                            go to error message and exit
     
      IF(COD1-CMA1(N))101,110,103
103   M=M/2
      N=N+M
      GO TO 102
104   M=M/2
      N=NCMA-M
      GO TO 102
CA  It will try the reverse code
108   IF(IREVERSE.EQ.1)THEN
      IF(ISOSPIN)THEN
      IF(IFIRST_5124.NE.999) WRITE(6,5124)COD1,I,J,K,L,NCMA
5124  FORMAT(/,1X,'***** INFORMATION from OPER: T.B.M.Elem. not found',
     1/,1X,'LOOKING FOR COD1 = I1,I2,I3,I4 = ',D20.12,
     1/,1X,'I,J,K,L,NCMA = ',5I5,
     1/,1X,'O.K?. Calculation continues at 5124 *****',
     1/,1X,'This message will now be suppressed. *****')
      IF(IFIRST_5124.EQ.0)IFIRST_5124=999
      GO TO 1500
CBAB  TYPE 521,COD1,I,J,K,L,NCMA
CBAB521 FORMAT(' ERROR: VMAT NOT FOUND, COD1,I,J,K,L,NCMA
CBAB 1   : ',/,D20.12/6I5)
CBAB  TYPE 522,(CMA1(IW),IW=1,NCMA)
CBAB522 FORMAT(' CMA1: '/<NCMA>(D15.8/))
CBAB  STOP ' ***** FATAL ERROR *****'
      ELSE
     
CBAB  Check Pauli principle
      IBABP=0
      DO 760 JJ=JMIN,JMAX,2
      ITT=2
      IF (((SYMA.EQ.ROOT2).OR.(SYMB.EQ.ROOT2)).AND.
     1  (MOD((JJ+ITT+2)/2,2).NE.0)) GO TO 760
      IBABP=1
760   CONTINUE
     
      IF((ISPS_TZ(I)+ISPS_TZ(J)).EQ.2.AND.IBABP.EQ.0) GO TO 1500
      IF((ISPS_TZ(I)+ISPS_TZ(J)).EQ.-2.AND.IBABP.EQ.0) GO TO 1500
CBAB      IF((ISPS_TZ(I)+ISPS_TZ(J)).NE.(ISPS_TZ(K)+ISPS_TZ(L))) GO TO 303
     
      IF(IFIRST_5123.NE.999) WRITE(6,5123)COD1,I,J,K,L,NCMA
5123  FORMAT(/,1X,'***** INFORMATION from OPER: T.B.M.Elem. not found',
     1/,1X,'LOOKING FOR COD1 = I1,I2,I3,I4 = ',D20.12,
     1/,1X,'I,J,K,L,NCMA = ',5I5,
     1/,1X,'O.K?. Calculation continues at 5123 *****',
     1/,1X,'This message will now be suppressed. *****')
      IF(IFIRST_5123.EQ.0)IFIRST_5123=999
      GO TO 1500
CBAB  GOTO 303
C              OR IF(ISOSPIN)
      END IF
C              OF IF(IREVERSE)
      END IF
      IREVERSE=1
      COD1=ISPS_ORDER(J)+1.D2*ISPS_ORDER(I)+1.D4*ISPS_ORDER(L)
     1    +1.D6*ISPS_ORDER(K)
      GO TO 100
     
110   NPOSN=NPOS(N)
C  LOOP OVER THE VALUES OF J,T
      DO 160 JJ=JMIN,JMAX,2
      COD3=COD1*100.+JJ*1.D0
      DO 160 ITT=ITMIN,ITMAX,2
CA  Check Pauli principle
      IF (((SYMA.EQ.ROOT2).OR.(SYMB.EQ.ROOT2)).AND.
     1  (MOD((JJ+ITT+2)/2,2).NE.0)) GO TO 160
      COD4=COD3*1.D2+ITT*1.D0
150   IF(COD4-CMAT(NPOSN))159,152,153
152   VINT=VMAT(NPOSN)*SYMA*SYMB
C  CALCULATE THE TERM (I.E. MULTIPLY BY APPROPRIATE CG'S)
CD     IGOT=1
      IA=JTW(I)
      IB=JTW(J)
      IC=JJ
      ID=MZTW(I)
      IE=MZTW(J)
      IF=ID+IE
      CALL CLEBG
      VINT=VINT*CLEB
      IA=JTW(K)
      IB=JTW(L)
      ID=MZTW(K)
      IE=MZTW(L)
      CALL CLEBG
      VINT=VINT*CLEB
      IA=1
      IB=1
      IC=ITT
      ID=ITZTW(I)
      IE=ITZTW(J)
      IF=ID+IE
      CALL CLEBG
      VINT=VINT*CLEB
      ID=ITZTW(K)
      IE=ITZTW(L)
      CALL CLEBG
      VINT=VINT*CLEB
      VIJKL=VIJKL+VINT
      GO TO 160
153   NPOSN=NPOSN+1
CBAB  IF (NPOSN.GT.NMAT) GO TO 920
      IF (NPOSN.LE.NMAT) GO TO 150
      IF(IFIRST_5125.NE.999) WRITE(6,5125)COD1,I,J,K,L,NCMA
5125  FORMAT(/,1X,'***** INFORMATION from OPER: T.B.M.Elem. not found',
     1/,1X,'LOOKING FOR COD1 = I1,I2,I3,I4 = ',D20.12,
     1/,1X,'I,J,K,L,NCMA = ',5I5,
     1/,1X,'O.K?. Calculation continues at 5125 *****',
     1/,1X,'This message will now be suppressed. *****')
      IF(IFIRST_5125.EQ.0)IFIRST_5125=999
CBAB  GO TO 150
      GO TO 1500
     
     
159   CONTINUE
      IF(IFIRST_1106.NE.999)
     1WRITE(6,1106)I,J,K,L,JM1,JM2,IABS(MZ),JMIN,JMAX,COD4,CMAT(NPOSN)
1106  FORMAT(/,1X,'***** INFORMATION from OPER: T.B.M.Elem. not found',
     1' I,J,K,L,JM1,JM2,IABS(MZ),JMIN,JMAX = ',9I3,
     1/,1X,'LOOKING FOR COD4 = I1,I2,I3,I4,J,T = ',D19.12,
     1/,1X,'FOUND       CMAT = I1,I2,I3,I4,J,T = ',D19.12,
     1/,1X,'O.K?. Calculation continues at 1106 *****',
     1/,1X,'This message will now be suppressed. *****')
     
      IF(IFIRST_1106.EQ.0)IFIRST_1106=999
     
CBAB159 TYPE 1106,I,J,K,L,JM1,JM2,IABS(MZ),JMIN,JMAX,COD4,CMAT(NPOSN)
CBAB1106 FORMAT(/' ERROR: CODE LESS THAN CMAT'/
CBAB 1' I,J,K,L,JM1,JM2,IABS(MZ),JMIN,JMAX = ',10I4,/,
CBAB 1' COD4,CMAT: ',/(D19.12,3X,D19.12,/))
CBAB  STOP ' ***** FATAL ERROR *****'
160   CONTINUE
     
1500  CONTINUE
CBAB  IF (ABS(VIJKL).LT.1.0E-12) GO TO 303
CBAB      IF(IP.EQ.IPKEEP) GO TO 6000
CBAB      CALL NEWIP(IP,IPS,NPMAX)
CBAB      IPKEEP=IP
CBAB  IF(NNEG_HPART.GT.MAX_NNEG)THEN
CBAB  IF(IPS.GT.MAX_NNEG)THEN
CBAB  TYPE 711,NNEG_HPART
CBAB711 FORMAT(' Increase MAX_NNEG to ',I6)
CBAB  STOP ' ***** FATAL ERROR in OPER *****'
CBAB  END IF
CBAB6000  CONTINUE
CBAB  IJKL(IP)=IJKL(IP)+1
      IJKL(IP)=IJKL(IP)+1
      IBAB = IBAB+1
      IF(IBAB.GT.MAX_IBAB) IERBAB=IBAB
CBAB  IF (IJKL(IP).GT.MAX_ELEM_PART) GO TO 510
      IF (IJKL(IP).GT.MAX_ELEM_PART.AND.IJKL(IP).GT.IERIJ)
     1 IERIJ=IJKL(IP)
      VIJKL=-VIJKL
CA  DIAGONAL ELEMENTS
CBAB  IF ((IP.EQ.1).AND.(I.EQ.K).AND.(J.EQ.L)) VIJKL=0.5*VIJKL
      IF ((IP.EQ.1).AND.(I.EQ.K).AND.(J.EQ.L)) VIJKL=0.5*VIJKL
CBAB  HIJKL(IJKL(IP),IP)=VIJKL
CBAB  HIJKL(IJKL(IP),IPS)=VIJKL
      IF(IERBAB.EQ.0)HIJKL(IBAB)=VIJKL
C  PACK I,J,K,L VALUES INTO ONE WORD IJKLW
CEKW ****** CHANGE IN HOW IJKLW IS PACKED ALLOWS LARGER M DIMENSIONS (NSPS).
C ****************     IPP = NSPS+1  **************
      IF(IERBAB.EQ.0)IJKLV(IBAB)=I*2**24+J*2**16+K*2**8+L
CEKW      IF(IERBAB.EQ.0)IJKLV(IBAB)=I*IPP**3+J*IPP**2+K*IPP+L
      IF(IERBAB.EQ.0)IJKLP(IBAB)=IP
303   CONTINUE
302   CONTINUE
301   CONTINUE
300   CONTINUE
      IF(IERBAB.GT.1) WRITE(6,4002)IERBAB
4002  FORMAT(1X,'FATAL ERROR: INCREASE MAX_IBAB TO ',I8)
      IF(IERIJ.GT.1) WRITE(6,4007)IERIJ
4007  FORMAT(1X,'FATAL ERROR: INCREASE MAX_ELEM_PART TO ',I8)
      IF(IERBAB.GT.1) STOP
      IF(IERIJ.GT.1) STOP
     
      IBABMAX = IBAB
CA  WRITE ONTO DISK .OP FILE - Smaller NNEG_HPARTV (i.e. = 0 ) first
      NARRAY=0
      NNEG_HPARTP=0
     
      DO 118 NP=1,NNEG_HPART
CBAB      CALL GETIP(NP,NPS,NPMAX)
       IJKLM=IJKL(NP)
CBAB      IF(NPS.EQ.0.AND.IJKLM.NE.0) WRITE(6,7740)NP,NPS,NPMAX,IJKLM
CBAB7740  FORMAT(1X,'ERROR IN OPER: NP,NPS,NPMAX,IJKLM = ',10I5)
CBAB      IF(NPS.EQ.0.AND.IJKLM.NE.0) STOP
     
C                               Skip zero dimension partitions
      IF(IJKLM.EQ.0)GO TO 118
     
      IOUT = 0
      DO 4000 IBAB = 1,IBABMAX
      IF(IJKLP(IBAB).EQ.NP) IOUT=IOUT+1
      IF(IJKLP(IBAB).EQ.NP.AND.IOUT.GT.MAX_ELEM_PART
     1.AND.IOUT.GT.IEROUT) IEROUT=IOUT
      IF(IJKLP(IBAB).EQ.NP.AND.IEROUT.EQ.0)IJKLVO(IOUT)=IJKLV(IBAB)
      IF(IJKLP(IBAB).EQ.NP.AND.IEROUT.EQ.0)HIJKLO(IOUT)=HIJKL(IBAB)
4000  CONTINUE
      IF(IEROUT.GT.1) GO TO 118
      IF(IOUT.NE.IJKLM) WRITE(6,4001)IOUT,IJKLM
4001  FORMAT(1X,'IOUT.NE.IJKLM NP,IOUT,IJKLM = ',3I5)
      IF(IOUT.NE.IJKLM) STOP
     
CBAB   WRITE(1)(NNEG_HPARTV(I,NP),I=1,N_WORDS),IJKLM,
CBAB   WRITE(1)N_WORDS,(NNEG_HPARTV(I,NP),I=1,N_WORDS),IJKLM,
CBAB 1(IJKLV(I,NP),HIJKL(I,NP),I=1,IJKLM)
       WRITE(1)N_WORDSO,(NNEG_HPARTV(I,NP),I=1,N_WORDSO),IJKLM,
CBAB 1(IJKLV(I,NPS),HIJKL(I,NPS),I=1,IJKLM)
     1(IJKLVO(I),HIJKLO(I),I=1,IJKLM)
       NARRAY=NARRAY+IJKLM
       NNEG_HPARTP=NNEG_HPARTP+1
       IF(INP.GT.1)THEN
CWEO       WRITE(3,887)(NNEG_HPARTV_BYTE(IJ,NP),IJ=NJL,1,-1),IJKLM
       WRITE(3,887)IJKLM,(NNEG_HPARTV(IJ,NP),IJ=NJL,1,-1)
887    FORMAT(//' IJKL and H.Part ',12I3/)
      ICOUNT=0
      DO 10010  IW=1,IJKLM
      ICOUNT=ICOUNT+1
      I=IJKLVO(IW)/2**24
      J=(IJKLVO(IW)-I*2**24)/2**16
      K=(IJKLVO(IW)-I*2**24-J*2**16)/2**8
      L=(IJKLVO(IW)-I*2**24-J*2**16-K*2**8)
CEKW      I=IJKLVO(IW)/IPP**3
CEKW      J=(IJKLVO(IW)-I*IPP**3)/IPP**2
CEKW      K=(IJKLVO(IW)-I*IPP**3-J*IPP**2)/IPP
CEKW      L=(IJKLVO(IW)-I*IPP**3-J*IPP**2-K*IPP)
CEKW      WRITE(3,9331)I,J,K,L,HIJKLO(IW)
9331  FORMAT('+',2X,4I2,1X,E12.5)
      IF(MOD(ICOUNT,5).EQ.0)WRITE(3,834)
834   FORMAT(' ')
C      END DO
10010 CONTINUE
C                LPT output
       END IF
      IF(ISOSPIN)THEN
      DO 10011  IW=1,IJKLM
CEKW      I=IJKLVO(IW)/IPP**3
CEKW      J=(IJKLVO(IW)-I*IPP**3)/IPP**2
CEKW      K=(IJKLVO(IW)-I*IPP**3-J*IPP**2)/IPP
CEKW      L=(IJKLVO(IW)-I*IPP**3-J*IPP**2-K*IPP)
      I=IJKLVO(IW)/2**24
      J=(IJKLVO(IW)-I*2**24)/2**16
      K=(IJKLVO(IW)-I*2**24-J*2**16)/2**8
      L=(IJKLVO(IW)-I*2**24-J*2**16-K*2**8)
        I1=.FALSE.
        J1=.FALSE.
        K1=.FALSE.
        L1=.FALSE.
        IF(I.EQ.2*(I/2))I1=.TRUE.
        IF(J.EQ.2*(J/2))J1=.TRUE.
        IF(K.EQ.2*(K/2))K1=.TRUE.
        IF(L.EQ.2*(L/2))L1=.TRUE.
        IH=.TRUE.
        IF(I+J+K+L.NE.2*(I+J+K+L)/2)STOP '  FATAL ERROR in OPER: charge
     1  not conserved *****'
        IF(I1.AND.J1.AND..NOT.K1.AND..NOT.L1)STOP ' ***** FATAL ERROR IN
     1
     1  MAIN: charge is not conserved *****'
        IF(I1.AND..NOT.J1.AND.K1.AND..NOT.L1)IH=.FALSE.
        IF(.NOT.I1.AND.J1.AND.K1.AND..NOT.L1)IH=.FALSE.
        IF(I1.AND..NOT.J1.AND..NOT.K1.AND.L1)IH=.FALSE.
        IF(.NOT.I1.AND.J1.AND..NOT.K1.AND.L1)IH=.FALSE.
        IF(.NOT.I1.AND..NOT.J1.AND.K1.AND.L1)STOP ' ***** FATAL ERROR in
     1  MAIN: charge is not conserved *****'
        IF(IH)INPR=INPR+1
        IF(.NOT.IH)INNN=INNN+1
C      END DO
CEKW      WRITE(3,9331)I,J,K,L,HIJKLO(IW)
10011 CONTINUE
      END IF
     
118   CONTINUE
        IF(ISOSPIN) WRITE(6,422)INPR,INNN
422   FORMAT(' Hprotons + Hneutrons m-scheme dim = ',I7,/
     1  ' Hneutrons-protons m-scheme dim = ',I7)
     
      IF(IEROUT.GT.1) WRITE(6,4006)IEROUT
      IF(IEROUT.GT.1) STOP
4006  FORMAT(1X,'FATAL ERROR: INCREASE MAX_ELEM_PART TO ',I8)
     
      WRITE(1)NARRAY,NNEG_HPARTP
      IF(INP.GT.0)WRITE(3,871)NARRAY,NNEG_HPARTP
871   FORMAT(' NARRAY,NNEG_HPARTP = ',2I10)
      CLOSE(UNIT=1)
      IF (INP.GT.0) WRITE(3,325) NARRAY,NNEG_HPART,NNEG_HPARTP
      CLOSE(UNIT=3)
      IFLAG=0
      WRITE(6,325)NARRAY,NNEG_HPART,NNEG_HPARTP
325   FORMAT(/' NO. OF TWO BODY M-SCHEME MATRIX ELEMENTS   : ',I10/
     2  ' NO. OF NON NEGATIVE HAMILTONIAN PARTITIONS : ',I10/
     2  ' NO. OF NON ZERO HAMILTONIAN PARTITIONS     : ',I10)
     
500   WRITE(6,13001)
C                                               SHOW ELAPSED TIME
C                                               SHOW CPU TIME
      CALL TIMER('STOP')
C                           NEATNESS IS A VIRTUE
      WRITE(6,13001)
      CALL EXIT
     
510   WRITE(6,991)MAX_ELEM_PART
991   FORMAT(' ERROR: Dimension of M-scheme operator too large.',
     1/,' Increase MAX_ELEM_PART ( =',I4,' )')
      STOP ' ***** FATAL ERROR *****'
910   WRITE(6,911)NMAT,MAX_TBME
911   FORMAT(' ERROR: NMAT, MAX_TBME : ',2I10)
      STOP ' ***** FATAL ERROR *****'
920   WRITE(6,921)NMAT,COD4,(CMAT(I),I=1,NMAT)
921   FORMAT(' ERROR:CMAT NOT FOUND',/,
     1' NMAT :',I6,
     2' COD4 : ',D20.12,
     3' CMAT(I) : ',/,50(5(D20.12,2X),/))
      STOP ' ***** FATAL ERROR *****'
      END
     
      SUBROUTINE FINDP
CA   SUBROUTINE THAT FINDS THE PARTITION NUMBER CORRESPONDING TO A
CA   GIVEN PARTITION BY DIVIDING THE INTERVAL BY TWO.
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHGR:PARAM.INC'
      INCLUDE 'OPRCOM.INC'
      COMMON/PFIND/NJLM,NPART,NPART2,IP,IPARTF(N_WORDSO),
     1IPART(N_WORDSO,MAX_NPARTO)
      INCLUDE 'SHGR:DATA.INC'
      IF(NPART.GT.MAX_NPARTO)STOP ' ***** FATAL ERROR in FINDOP:
     1NPART.GT.MAX_NPARTO *****'
      IF(NJLM.NE.MAX_NJL) STOP ' ***** FATAL ERROR in FINDOP:
     1 MAX_NJL in MAIN diff. from MAX_NJL in FINDOP *****'
     
     
      N=NPART
      IF(LIB_EQX(IPARTF(1),IPART(1,N),N_WORDSO)) GO TO 110
      N=NPART2/2
      M=N
      IF(LIB_LTX(IPARTF(1),IPART(1,N),N_WORDSO))GO TO 101
      IF(LIB_EQX(IPARTF(1),IPART(1,N),N_WORDSO))GO TO 110
      M=M/2
      N=NPART-M
      GO TO 102
101   M=M/2
      N=N-M
102   IF(M.EQ.0) GO TO 108
      IF(LIB_LTX(IPARTF(1),IPART(1,N),N_WORDSO))GO TO 101
      IF(LIB_EQX(IPARTF(1),IPART(1,N),N_WORDSO))GO TO 110
      M=M/2
      N=N+M
      GO TO 102
108   IP=0
      RETURN
110   IP=N
      RETURN
      END
