#!/bin/csh
#
#---------------------- Main OXBASH directorys -----------------------------
#
#   Version using the C-shell.
#
#   Please set the appropriate directorys in P1 and P2 before running.
#
#   The command "source .oxbashlogin" should be placed in your .tcshrc file.
#
#---------------------------------------------------------------------------

setenv P1 /disk2/users/kara		   # Home directory where OXBASH lives
setenv P2 Oxbash			   # Oxbash subdirectory

setenv SHDIR $P1/$P2	                   # OXBASH home directory
setenv SHTXT $P1/$P2/txt                   # OXBASH manual "shell.txt"
setenv RS $P1/$P2/rsh                      # Directory in which OXBASH is run
                                           # RSH is a UNIX command so
					   # RS is used instead.
					   # May be set to a different are
					   # if desired.
setenv SHGR $P1/$P2/main                   # Programs common to all others
setenv SHINC $P1/$P2/include               # All include files are here.

setenv SHEXE $P1/$P2/exe                   # executables are stored here
setenv SHGRFOR $P1/$P2/main/for		   # *.for programs
setenv SHGRMAC $P1/$P2/main/mac		   # *.mac programs VAX only
setenv SHGRLIB $P1/$P2/main	  	   # generic library directory
setenv SHSH $P1/$P2/shell		   # SHELL directory
setenv SHBA $P1/$P2/basis		   # BASIS directory
setenv SHPR $P1/$P2/proj		   # PROJ directory
setenv SHPRQ $P1/$P2/projq		   # PROJQ directory real*16
setenv SHPPR $P1/$P2/prior		   # PRIORPROJ directory
setenv SHPPRQ $P1/$P2/priorq	   	   # PRIORPROJQ directory real*16
setenv SHMA $P1/$P2/matrix		   # MATRIX, OPER directory
setenv SHLA $P1/$P2/lanczos		   # LANCZOS directory
setenv SHTR $P1/$P2/tramp		   # TRAMP, MVEC, TBTDOP directory
setenv SHTRZ $P1/$P2/tramp/z	 	   # TRAMP with MAX_STORE 0 directory
setenv SHTRA $P1/$P2/trans		   # RTRD, TRANS directory
setenv SHMI $P1/$P2/misc		   # CHANGE, PN, HCM, SU3INT directory
setenv SHLEV $P1/$P2/lev		   # LEVEL directory
setenv SHSPS $P1/$P2/sps		   # *.sps, *.int directory
setenv SHLS $P1/$P2/ls		 	   # LS-coupling files
setenv SHINT $P1/$P2/int		   # Additional *.int files

setenv SHOP $P1/$P2/opa		  	   # .op files for Alpha system
setenv SHOPA $P1/$P2/opa		   # .op files
setenv SHOP2 $P1/$P2/op2		   # .op2 files by TBTDOP
setenv SHMATFILE $P1/$P2/rsh	           # .mat files
setenv SHPROJFILE $P1/$P2/rsh	           # .prj files
#
#	Other directories:
#
setenv SHTSAV $P1/$P2/tsav                 # .sav files from .trd and .tbd
setenv SHISOH $P1/$P2/isoh		   # PRCO program and .iso files
setenv SHISOP $P1/$P2/isop		   # ISOV directory
setenv SHPNCH $P1/$P2/pnch		   # PRG and .pnc directory
setenv SHPNCP $P1/$P2/pncp		   # PNCME directory, double beta decay
setenv SHTRD $P1/$P2/trd		   # *.trd storage directory
setenv SHOBD $P1/$P2/obd		   # *.obd storage directory
setenv SHINTH $P1/$P2/inth		   # programs to create .int files
setenv SHLIBR $P1/$P2/libr		   # BAB library directory
#
#	Useful shorthand aliases
#
alias shell '$SHEXE/shell'		   # runs OXBASH and gives shell
					   # script to run the rest of it.
alias pn '$SHEXE/pn'			   # changes from isospin to pn form
alias change '$SHEXE/change'		   # combines *.int files
alias convert '$SHEXE/conv'		   # changes labels in *.int files
alias diagint '$SHEXE/diagint'		   # converts to a diagonal interaction
alias hcm '$SHEXE/hcm'			   # creates centre of mass .int
alias mpar '$SHEXE/mpar'	  	   # modifes *.par files
alias oper '$SHEXE/oper'	 	   # creates .op from .int file
alias tbtdop '$SHEXE/tbtdop'		   # creates .op2 files
alias rtrd '$SHEXE/rtrd'	  	   # converts .trd to .obd
alias level '$SHEXE/level'		   # creates level scheme from .eig
alias mvec '$SHEXE/mvec'	 	   # makes m-scheme vector file
alias trans '$SHEXE/trans'		   # calculates moments, B's from .trd
alias prdv '$SHEXE/prdv'	  	   # makes .int for delta
alias prvn '$SHEXE/vn'			   # makes .int for Schiffer-True etc.
alias prco '$SHEXE/prco'	 	   # makes .iso files for ISOV
alias isov '$SHEXE/isov'	  	   # isospin mixing from .trd and .tbx
alias prg '$SHEXE/prg'			   # makes .pnc for PNCME
alias pncme '$SHEXE/pncme'		   # parity mixing from .trd .tbx
alias isocomp '$SHEXE/isocomp'		   # creates *ivpn.int and *itpn.int
alias su3int '$SHEXE/su3int'		   # creates hcm.int
alias inter '$SHEXE/inter'		   # converts *.ino to *.int
					   # *.ino are the old format
alias mpar '$SHEXE/mpar'	  	   # modifies .par files
alias de '$SHEXE/de'			   # tbme tensor decomposition program
