C	OXFORD-BUENOS AIRES SHELL MODEL CODE
C  1975	Conception    : W.D.M.Rae and C.H.Zimmerman
C  1976	Embryo version: W.D.M.Rae and C.H.Zimmerman
C  1977 Version 1     : N.S.Godwin and W.D.M.Rae
C  1978 Version 2     : N.S.Godwin and W.D.M.Rae
C			(working PDP10 MACRO version)
C  1980 Version 3     : A.Etchegoyen, B.A.Brown, W.A.Werner, N.S.Godwin and J.S.Windfield
C                       (multiple integer precision  FORTRAN VAX version,
C                        new BASIS. LANCZOS method and tables in PROJ and MATRIX)
C  1982	Version 4     : W.D.M.Rae 
C                       (PREDICT, changes in PROJ and MATRIX. New ORTHOG and tables
C                        incorporated to TRAMP)
C  1982 Version 5     : A.Etchegoyen and W.D.M.Rae
C			(Changes in BASIS, OPER. PRIORPROJ and POSTPROJ. ORTHOG
C                        incorporated to MATRIX - Partitions as bytes - General
C                        face wash). ISOV, TRANS and DENS by B.A.Brown and 
C                        R.A.Werner
C  
C  AUTHOR list : W.D.M.Rae, A.Etchegoyen, N.S.Godwin and B.A.Brown.
C  Contributors: R.A.Werner,C.H.Zimmerman and J.S.Windfield.


C   Changes in the author list and/or in the name of the code (total or by partial
C   addition of names) are possible only with the written confirmation
C   of W.D.M.Rae, A.Etchegoyen and B.A.Brown.
C   Everybody is welcome to use this code

CA	COMMON DATA BLOCKS FOR THE BASIS PROGRAMS

C  THIS PROGRAM CALCULATES M-SCHEME BASIS STATES
	IMPLICIT INTEGER(A-Z)
	CHARACTER*4 BAS2,SPS2
	CHARACTER*9 BASFIL,SPSFIL,SHELL,LPTFIL
	CHARACTER*13 BASF,SPSF
CA  THESE PARAMETER STATEMENTS ARE THE ONLY THING TO CHANGE IN ORDER TO
CA  CHANGE THE DIMENSIONS. SEE IF THERE IS ANY OTHER IN THE SUBROUTINES
CA  MEANING:
CA  MAX_NJL        MAXIMUM NUMBER OF J-LEVELS
CA  MAX_NLWRDS     MAXIMUM NUMBER OF LONG WORDS (ONE LONG WORD IS 32 BITS)
CA  MAX_NSPS       MAXIMUN NUMBER OF SINGLE PARTICLE STATES
CA  MAX_NPART      MAXIMUM NUMBER OF PARTITIONS
CA  NLWRDS_BLOCK   NUMBER OF LONG WORDS PER EACH DISK BLOCK. IN THE VAX, THIS
CA                 NUMBER IS 126. IF A RECORD WITH LESS THAN 126 LWRDS IS
CA                 WRITTEN ONTO DISK, THE REMAING IS FILLED WITH ZER0S
CA                 THEREFORE THE DISK SPACE WOULD NOT BE CORRECTLY USED.THIS
CA		   IS A COMPROMISE WITH THE BASIS DIMENSION
CA  MAX_NOSC       MAXIMUM NUMBER OF MAJOR SHELLS. USED IN MAXMIM.FOR AND
CA                 NEWPATR
CA  MAX_MIN        MAXIMUM NUMBER OF MAXIMA (AND MIMIMA) WITH DIFFERENT NUMBER
CA                 OF PARTICLES IN MAJOR SHELLS
CA  MAX_MSCHEME    MAX_MSCHEME DIMENSION FOR A GIVEN PARTITION

	PARAMETER MAX_NJL=9,MAX_NLWRDS=2,MAX_NSPS=64,TWELVE=12
	PARAMETER NLWRDS_BLOCK=126,MAX_NOSC=3,MAX_MIN=100,MAX_IDISK=3000
	PARAMETER MAX_MSCHEME=25000,MAX_NPART=MAX_NLWRDS*NLWRDS_BLOCK
CBAB	PARAMETER N_WORDS=MAX_NJL/4+1
	PARAMETER N_WORDS=1
	REAL JZ,TZ
	BYTE IPART_BYTE(N_WORDS*4,MAX_NPART),IPARTN_BYTE(N_WORDS*4)
	COMMON  NDIM(MAX_NPART),NDIMA(MAX_NPART),
	1  ISTART_MIN(MAX_NLWRDS),ISTART_MAX(MAX_NLWRDS),
	1  NMZTZ(MAX_NPART,4,4),MAXMZ(MAX_NPART),MAXTZ(MAX_NPART),
	2  IDISK(N_WORDS,MAX_IDISK),NJTT(3,3),JLEVLMN(MAX_NOSC),
	1  JLEVLMX(MAX_NOSC),T(5),JAYA(3),JQU(MAX_NJL),NUMP(MAX_NJL),
	1  IPTMNH(MAX_NLWRDS),TWOW_ZEROONE(MAX_NLWRDS),TWOW_TEST(MAX_NLWRDS)
	COMMON/WOTP/ NPTCL,MNFIL(MAX_NJL),MXFIL(MAX_NJL)
	1,KPARQ(MAX_NJL),NOSCJL(MAX_NJL),MNOSC(MAX_NOSC),MXOSC(MAX_NOSC),
	1NOSC,IPRT
	COMMON/MINMAX/ IBAS,MIX_PARITY,
	1IPTMXH(MAX_NLWRDS),MAJSHELL_NPJ(MAX_NOSC),SUM_NPJ(0:MAX_NJL),
	1NEW_MXOSC(MAX_MIN),NEW_MIN(MAX_NLWRDS,MAX_MIN),
	1NEW_MAX(MAX_NLWRDS,MAX_MIN),NMIN,IG_MAX,
	1UPPERSHELL_MASK(MAX_NLWRDS),LOWERSHELL_MIN(MAX_NLWRDS,MAX_MIN),
	1LOWERSHELL_MASK(MAX_NLWRDS),JORBITMASK(MAX_NLWRDS,MAX_NJL),
	1DUMMY(MAX_NLWRDS)
	COMMON/BAS/ NQU(MAX_NSPS),LQU(MAX_NSPS),JTW(MAX_NSPS),
	1 MZTW(MAX_NSPS),ITZTW(MAX_NSPS),NSPS,
	1IMZS,ITZS,KPAR,KTPAR,MAXT
	COMMON/CBAS/BASFIL,BAS2,SPSFIL,SPS2,SHELL(MAX_NJL)
	COMMON/OSPS/ONEW_SPSAR(32)
	COMMON/OWZO/ONEW_ZEROONE(31)
	COMMON/NNN/ NUM(MAX_NSPS)
	COMMON/REV/ IPATRN(MAX_NLWRDS),JPATRN(MAX_NLWRDS)
	COMMON/PFIND/ NPART,NPART2,IP,IPARTF(N_WORDS)
	COMMON/MASK/ NPRV1,NPRV2,TIMRV(20)
	COMMON/JINFO/ NJL,NPJ2(10),NPJ(10)
	COMMON/NUMA/ NUMSPS,IPARTN(N_WORDS),NTRIAL
	COMMON/IPARTA/ IPART(N_WORDS,MAX_NPART)
	COMMON/BASCOM/NLWRDS,ZERO(MAX_NLWRDS),RESULT(MAX_NLWRDS)
	EQUIVALENCE (IPART_BYTE(1,1),IPART(1,1))
	EQUIVALENCE (IPARTN_BYTE(1),IPARTN(1))
