C   SHELL MODEL PROGRAM :   THIS PROGRAM PROJECTS OUT A BASIS WITH 
C   GOOD J AND T
C   FROM THE M-SCHEME BASIS, THE RESULT IS A MATRIX <M1/PJT/M2> (COEF0).
C   ONLY ONE PARTITION NEEDS TO BE IN CORE AT A TIME
C   COEF0 STORES THE COEFFICIENTS OF THE PROJECTED WAVEFUNCTION AT EACH
C   STAGE
CA  I.E. AFTER PROJECTING OUT EVERY SINGLE NOT WANTED J-VALUE
C   COEF  HOLDS RESULTS AFTER J-J+ OPERATION ON COEF0. AT THE FINAL 
C   STAGE, WHEN
CA  COMPLETE PJT-PROJECTION HAS BEEN APPLIED, THE RESULT IS RETURN TO 
CA  THE MAIN
CA  IN COEF0
C   CLEANED-UP NOV-81
CA  SEE BASCOM.FOR FOR DETAILS OF CONSTANTS IN PARAMETER STATEMENTS

C   COMMON BLOCK FOR PRIORPROJ


CBAB      INCLUDE 'SHGR:MAINCOM.INC'
CBAB      INCLUDE 'SHGRLIB:MACFOR.INC'
CBAB      INCLUDE 'SHGR:PARAM.INC'
CBAB      INCLUDE 'SHGR:DATA.INC'

      PARAMETER MAX_ORTHOG=(MAX_PRED*(MAX_PRED+1))/2
      PARAMETER MAX_STORE=10000,MAX_TTORE=100000
      PARAMETER NUNIT20=200
CA  MAX_IPROT   = MAXIMUM NO. OF PROTON PARTITIONS FOR A GIVEN PARTITION
CA  MAX_MSCHEME = MAXIMUM M-SCHEME BASIS DIMENSION FOR A GIVEN PARTITION
CA  MAX_STORE   = MAXIMUM NO. OF PROJECTION COEFFIENTES ALLOWED IN JMJP. 
CA  MAX_LININDP = MAX NO. OF PREVIOUS GOOD |JT> VECTORS STORE IN MEMORY
CA                FOR LINEAR INDEPENDENCE CHECK
CA  EACH PARTITION IS PROJECTED ONLY ONCE AND RESULTS STORED IN ARRAYS.
CA  MAX_TTORE AND MAX_LININDP CAN BE REDUCED ARBITRARILY AND THE 
CA  COEFFICIENTS THAT CAN NOT BE STORED ON MEMORY WILL BE WRITTEN 
CA  ONTO DISK.

CA  DOUBLE PRECISION TO PREVENT ROUNDING ERRORS WHILE PROJECTING
CBAB      DOUBLE PRECISION COEF0,COEF,COEF_JP,SING,DEN,TEM,TEMP,TEMP2,
CBAB     1SQDJ,SQDT,FACP,UNIT,COEFK,COEFJ,COEFI,ORTHOG,COEF0P,
CBAB     1GOODCOEF0_PREVIOUS
      BYTE NPROT_P,IPARTN_BYTE,WOTPT_BYTE,IPROT_BYTE,NP_DIFF_BYTE,
     1       IPART_BYTE(4*N_WORDS,MAX_NPART),PROT_PART
      DIMENSION NPROT_P(MAX_IPROT),IPARTN_BYTE(4*N_WORDS),
     1WOTPT_BYTE(4*N_WORDS),NP_DIFF_BYTE(4*N_WORDS,MAX_IPROT)
      CHARACTER*4 BAS2,PRJ2,RED2
      CHARACTER*9 BASFIL,PRJFIL,SHELL,BASFILP
      CHARACTER*13 BASF,PRJF,SPSF,REDF
      CHARACTER*9 CHAR_VAR(30)
      DIMENSION INT_VAR(30),REAL_VAR(30)
      INTEGER TPLUS,TMIN,JTWSS(MAX_NSPS),HANDLE,TMTP_FLAG,SPART,
     1       ZERO,RESULT,WOTPT(N_WORDS),SUM_NPJ,TMTP_TIME
      REAL NLILIM,NRMLIM,LIMIT,JSING
      LOGICAL RET_STATUS,I_PRD(MAX_PRED),FEDUP_CALL
      COMMON/CBAS1/ IBASIS(MAX_NLWRDS,MAX_MSCHEME),
     1       IBASISP(MAX_NLWRDS,MAX_MSCHEME),NIPART,ILOG
      COMMON/CCOP/ COEF(MAX_MSCHEME),COEF0(MAX_MSCHEME),
     1       COEF_JP(MAX_MSCHEME),IPROT(N_WORDS,MAX_MSCHEME)
      COMMON/CMATX/PRJFIL,PRJ2,BASFIL,BAS2,SPSF,SHELL(MAX_NJL),
     1REDF,RED2,BASFILP
      COMMON/MATX/ITT,NHPART,NDIMJ,NDIMT,NJL,NPJ(MAX_NJL),
     1 IORD(MAX_NPART),NDIMA(MAX_NPART),NBLOCK(MAX_NPART),
     1 IORDP(MAX_NPART),NDIMAP(MAX_NPART),NBLOCKP(MAX_NPART),
     1       NJTP(MAX_NPART),IMZS,ITZS,NREAD,NJZP1,ILEFT,KPAR,
     1       KTPAR,MATDIM,IOUT,IROU,IDEV,JAY,
     1 IMZSA,ITZSA,MAXJZ,MAXTZ,NJT
      COMMON/INNER/ NDIMII,NDM2II,NSPS,IMAX,NSPSW,NPTCL,
     1       NWOTPT,WOTPT
      COMMON/TPTM/ TPLUS(MAX_NSPS),TMIN(MAX_NSPS)
      COMMON/JPJM/JPLUS(MAX_NSPS),FACP(2*MAX_NSPS),NDIMP,
     1       NDM2P,DEN,UNIT
      COMMON/PRJ/ NPRJM,PJLIM,IBP,JMJP_FLAG,TMTP_FLAG,LONGP,
     1       ITZTW(MAX_NSPS)
      COMMON/BASCOM/NLWRDS,ZERO(MAX_NLWRDS),RESULT(MAX_NLWRDS),
     1             MASK(MAX_NLWRDS)
      COMMON/DENS/JAYSQ4,ITTSQ4,ITZSQ4,IMZSQ4,MREADBAS
      COMMON/PATP/IPARTN(N_WORDS),IPATRN(MAX_NLWRDS),
     1           NP_DIFF(N_WORDS,MAX_IPROT),NDIFFM,MXFIL(MAX_NJL)
      COMMON/TIME/JMJP0_TIME,JMJP1_TIME,JMJP2_TIME,ICPU11,ICPU12,
     1JKEEPOLD,
     1      HANDLE,ORTHOG(MAX_ORTHOG),NGOOD,NGOODPLUS,I_PRD,JKEEP,
     1      NPRED,NPROT_P,SUM_NPJ(0:MAX_NJL),TMTP_TIME,IDO_TIME
      COMMON/FED/I_PREDICT(MAX_PRED),IGOOD(MAX_NJT),
     1COEF0P(MAX_MSCHEME),
     1      GOODCOEF0_PREVIOUS(MAX_ORTHOG),FEDUP_CALL,IFED_TIME,
     1      IPROT_BYTE(MAX_MSCHEME),IPART(N_WORDS,MAX_NPART),
     1INVERT_TIME,
     1      PROT_PART(MAX_MSCHEME),NG(MAX_NJT),NUNIT23,NLILIM
      EQUIVALENCE (WOTPT(1),WOTPT_BYTE(1)),
     1(IPARTN_BYTE(1),IPARTN(1)),
     1      (IPART_BYTE(1,1),IPART(1,1)),
     1(NP_DIFF_BYTE(1,1),NP_DIFF(1,1))
      DATA IVERS/2/
