C  SUBROUTINES FOR J T PROJECTION
C
C
C  THIS ONE TO SET UP FOR PROJECTION
C
C
      SUBROUTINE FACSET
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      DIMENSION IFACP(MAX_NSPS)
      DIMENSION NQU(MAX_NSPS),LQU(MAX_NSPS),JTW(MAX_NSPS),
     1         MZTW(MAX_NSPS)
      INCLUDE 'SHEXE:DATA.INC'
C
C  SET UP FACTORS AND RESULTS FOR J+ AND J- SINGLE-PARTICLE OPERATORS
C
CA OPEN .SPS FILE
      DO 10001  I=1,NSPS
      JPLUS(I)=0
      TMIN(I)=0
      TPLUS(I)=0
C      END DO
10001 CONTINUE
      CALL OPENSPS(21,SPSF,0)
      CALL FREE_INT(21,30,INT_VAR,READ_ERR)
      NSPSW=INT_VAR(1)
      NJL=INT_VAR(2)
      DO 13001 I=1,NJL
13001 NPJ(I)=INT_VAR(I+2)
CWEO      READ(21,*) NSPSW,NJL,(NPJ(I),I=1,NJL)
      IF(NSPSW.LT.0)NSPSW=-NSPSW
      IF (NSPSW.EQ.NSPS) GO TO 196
      WRITE(6,197)NSPS,NSPSW
197   FORMAT(' PRJSBS WARNING: NO OF S-P STATES HAS CHANGED : ',2I5)
196      CALL FREE_INT(21,0,INT_VAR,READ_ERR)
CWEO196   READ(21,*)
      DO 1910 NS=1,NSPSW
      CALL FREE_INT(21,6,INT_VAR,READ_ERR)
      NQU(NS)=INT_VAR(2)
      LQU(NS)=INT_VAR(3)
      JTW(NS)=INT_VAR(4)
      MZTW(NS)=INT_VAR(5)
      ITZTW(NS)=INT_VAR(6)
CWEO      READ(21,*) NON,NQU(NS),LQU(NS),JTW(NS),MZTW(NS),ITZTW(NS)
      JTWSS(NS)=JTW(NS)
      JTW(NS)=IABS(JTW(NS))
1910  CONTINUE
CWR  IF SPS FILE HAS MAX ISOSPIN,I.E. ALL TZ=+0.5, THEN SET IMAX=1
CWR  MUST USE SAME SPS FILE TO GENERATE INTERACTION .OP FILE
CA   IF PROTON AND NEUTRON OCCUPY DIFFERENT ORBITS, THE .SPS FILE
CA   WILL HAVE A STRING OF ALL +.5 AND THEN ALL -.5 (OR VICEVERSA)
CA   IMAX IS USED FOR WORKING  OUT THE PHASES in JMJP0.
Ca   IMAX is therefore used for neutron - proton formalisim
        IMAX=0
        IF(ITZTW(1).EQ.ITZTW(2))IMAX=1
      CLOSE(UNIT=21)
        IF(IMAX.NE.0) GO TO 1915
      DO 1911  NS=1,NSPSW-2
      IF (JTW(NS+2).EQ.JTW(NS)
     1  .AND.LQU(NS+2).EQ.LQU(NS)
     2  .AND.NQU(NS+2).EQ.NQU(NS)) JPLUS(NS)=NS+2
1911  CONTINUE
        GO TO 1917
1915    CONTINUE
        DO 1916 NS=1,NSPSW-1
        IF(JTW(NS+1).EQ.JTW(NS)
     1  .AND.ITZTW(NS+1).EQ.ITZTW(NS)
     1  .AND.LQU(NS+1).EQ.LQU(NS)
     2  .AND.NQU(NS+1).EQ.NQU(NS)) JPLUS(NS)=NS+1
1916    CONTINUE
1917    CONTINUE
      DO 1921 NS=1,NSPSW
      IFACP(NS)=JTW(NS)*(JTW(NS)+2)-
     1  MZTW(NS)*(MZTW(NS)+2)
CBAB      FACP(NS)=DSQRT(DBLE(IFACP(NS))/4.)
      FOURBAB = 4.
      FACP(NS)=REAL(IFACP(NS))/FOURBAB
      FACP(NS)=SQRT(FACP(NS))
C*DP   FACP(NS)=SQRT(IFACP(NS)/4.)
1921  CONTINUE
      DO 1913  NS=1,NSPSW-1,2
1913  TPLUS(NS)=NS+1
      DO 1914  NS=2,NSPSW,2
1914  TMIN(NS)=NS-1
      JAYSQ4=JAY*(JAY+2)
      ITTSQ4=ITT*(ITT+2)
      ITZSQ4=ITZS*(ITZS+2)
      IMZSQ4=IMZS*(IMZS+2)
      DO 10002  I=1,NSPS
      FACP(I+NSPS)=-FACP(I)
C      END DO
10002 CONTINUE
      RETURN
      END
C
C
C
C  THESE TO APPLY J- T- PROJECTION OPERATORS
C
C
      SUBROUTINE JTPROJ(JJJ)
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHEXE:PARAM.INC'
      INCLUDE 'REAL.INC'
      INCLUDE 'PRJCOM.INC'
      INCLUDE 'SHEXE:DATA.INC'
C  APPLY J-PROJECTION OPERATOR
C  JMJP0 J-J+ TO COEF0 AND RETURN RESULT IN COEF
C  JMJP0 IS APPLIED TO ALL M-SCHEME BASIS STATES, AND IT WILL
CA INCREAMENT TO RANDOM VECTOR COEFFIENTS
C  [J**2 = J-J+ + JZ(JZ+1)]
9     IBP=0
      IZ=0
      NPRJ=0
20    IF (IMZSA.GE.MAXJZ) GO TO 30
      IF(NPRJ.GT.0)THEN
      TYPE 61,(WOTPT_BYTE(IW),IW=NJL,1,-1)
      TYPE 616,JJJ,NPRJ,TEMP
61    FORMAT(' Partition ',<NJL>I2)
616   FORMAT(' JJJ,NPRJ,Difference from J(J+1)',2I5,D)
      END IF
      JJJJ=JJJ
      DO 29 JA=IMZSA,MAXJZ,2
      IF (JA.EQ.JAY) GO TO 29 !SKIP PROJECTION OF J OF INTEREST
2000    FORMAT(1X,I4,2D9.2)

CA  JMJP_FLAG PROJECTS ONLY IN FIRST PASS(RANDOM VECTOR) AND
CA  STORES COEFFICIENTS
***      TYPE 822,JJJ,(COEF0(IW),IW=1,NDIMII)
***822   FORMAT(' JJJ,WFN entrance ',I4,2X,<NDIMII>F8.4)
      IF (JMJP_FLAG) THEN
CA  IT SHOULD BE HERE ONLY ONCE FOR EACH PARTITION
      IF(MREADBAS.GT.IMZS)THEN
      CALL READBAS(2)
      ELSE IF(MREADBAS.EQ.IMZS)THEN
      NDIMP=0
      NDM2P =0
      ELSE
      STOP ' ***** FATAL ERROR in PRJSBS: MREADBAS.LT.IMZS *****'
      END IF

*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU3,HANDLE)) STOP 'JMJP0 TIMER1'
      JMJP_FLAG=0
      CALL JMJP0
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU4,HANDLE)) STOP 'JMJP0 TIMER2'
*BT      JMJP0_TIME = JMJP0_TIME + ICPU4 - ICPU3
      ELSE IF(JJJ.EQ.0)THEN
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU5,HANDLE)) STOP 'JMJP1 TIMER1'
      CALL JMJP1
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU6,HANDLE)) STOP 'JMJP1 TIMER2'
*BT      JMJP1_TIME = JMJP1_TIME + ICPU6 - ICPU5
      ELSE

CA  GET THE TABLE
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU7,HANDLE)) STOP 'JMJP2 TIMER1'
      DO 51 IPTN=1,NDIFFM
      IF(NPROT_P(IPTN))CALL JMJP2(IPTN)
51    CONTINUE
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU8,HANDLE)) STOP 'JMJP2 TIMER2'
*BT      JMJP2_TIME = JMJP2_TIME + ICPU8 - ICPU7
      END IF
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU22,HANDLE)) STOP 'JMJP0 TIMER1'
      JJJJ=1
      JSQ4=JA*(JA+2)
      SING=(IMZSQ4-JSQ4)*.25
      DEN=(JAYSQ4-JSQ4)*.25
      UNIT=SING/DEN

CA  SETS NEW WFN TO PROJECT OUT NEXT J-VALUE
      IF(UNIT.EQ.1)THEN
      DO  JJ=1,NDIMII
      COEF0(JJ) = COEF(JJ)/DEN+COEF0(JJ)
      END DO
      ELSE
      DO JJ=1,NDIMII
      COEF0(JJ)=COEF(JJ)/DEN+UNIT*COEF0(JJ)
      END DO
      END IF

      DO JJ=1,NDIMII
      COEF(JJ)=0
      END DO
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU23,HANDLE)) STOP 'JMJP1 TIMER2'
*BT      IDO_TIME = IDO_TIME + ICPU23 - ICPU22
***      TYPE 823,JJJ,(COEF0(IW),IW=1,NDIMII)
***823   FORMAT(' WFN salida      ',I4,2X,<NDIMII>F8.4)
29    CONTINUE
C!-------END DO OVER J-VALUES
CA      WRITE(IDEV,1235)(COEF0(IJK),IJK=1,NDIMII)
1235  FORMAT('GOOD J BAD T'/<NDIMII/10+1>(10D10.2/))
CA  COEF0 ARE NOW THE COEFFCIENTS OF A GOOD J AND A BAD T WFN (HOPEFULLY)
C
C   JUMP WITHOUT CHECKING FOR GOOD PROJECTION UNLESS IROU > 0

      IF(IROU.LT.1.AND.JJJ.NE.0) GO TO 30
C
CA  J**2 = J-J+ + Jz(Jz+1)
CA  J**2(sumi COEF0(i)) = sumi COEF(i) + Jz(Jz+1) = J(J+1)(sumi COEF0(i))
      CALL JMJP1
      TEMP=0.
      TEM=(IMZSQ4-JAYSQ4)*.25
      DO 42 JJ=1,NDIMII
      TEMP=TEMP+(COEF(JJ)+TEM*COEF0(JJ))**2
42    COEF(JJ)=0
      NPRJ=NPRJ+1
      NPRJM=MAX0(NPRJ,NPRJM)
      IF(JJJ.NE.0)THEN
      IF (COEF0(JJJ).LT.1E-20) IZ=1
      END IF
      IF (NPRJ.GT.5) IBP=1
      IF (IBP+IZ.GT.0) GO TO 777
      IF(JJJ.NE.0)TEMP=TEMP/COEF0(JJJ)
44    IF (TEMP.GT.PJLIM)THEN
      IROU=1
      GO TO 20
      END IF
CA SUCESS!
      IF(IOUT.GT.2)WRITE(IDEV,10)TEMP
10    FORMAT(' After J-projection, J**2 was reapplied
     1new vector differs in modulus from previous one in',D)

CA  IF IT GOES TO 20 IT WILL PROJECT AGAIN BUT START WITH PRESENT COEF0S,
CA  RATHER THAN COEF0(JJJ)=1 AND ALL THE REST =0. WHAT IT ACTUALLY DOES
CA  IS PJT PJT|IBASIS(JJJ)>. SECOND (AND FOLLOWING) PROJECTIONS MIGHT
CA  BE NEEDED BECAUSE OF ROUDING ERRORS. IT WILL TRY THIS UP TO FIVE
CA  TIMES
C
C   APPLY T-PROJECTION OPERATOR
C   TMTP APPLIES T-T+
C
30    IF (ITZSA.GE.MAXTZ) GO TO 777
        IF(IMAX.NE.0) STOP 'ERROR in PRJSBS: IMAX.NE.0 and
     1ITZSA.NE.MAXTZ'
      NPRT=0
50    JJJJ=JJJ
CA    IF(NJT.EQ.1) JJJJ=0
      DO 39 JA=ITZSA,MAXTZ,2
      IF (JA.EQ.ITT) GO TO 39
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU13,HANDLE)) STOP 'TMTP TIMER1'
***      TYPE 824,JJJ,(COEF0(IW),IW=1,NDIMII)
***824   FORMAT(' WFN entranceT',I4,2X,<NDIMII>F8.4)
      IF(TMTP_FLAG)THEN
      TMTP_FLAG=0
      CALL TMTP0
      ELSE
      CALL TMTP1
      ENDIF
*BT      IF(.NOT.LIB$STAT_TIMER(2,ICPU14,HANDLE)) STOP 'TMTP TIMER2'
*BT      TMTP_TIME=TMTP_TIME +ICPU14-ICPU13
      JJJJ=1
      JSQ4=JA*(JA+2)
      SING=(ITZSQ4-JSQ4)*.25
      DEN=(ITTSQ4-JSQ4)*.25
      DO JJ=1,NDIMII
      COEF0(JJ)=(COEF(JJ)+SING*COEF0(JJ))/DEN
      COEF(JJ)=0
      END DO
39    CONTINUE
***      TYPE 825,JJJ,(COEF0(IW),IW=1,NDIMII)
***825   FORMAT(' WFN salida     T',I4,2X,<NDIMII>F8.4)
      IF(IROU.LT.2)GO TO 777
CA TEST OF PROJECTION ACCURACY FOR T-PROJECTION
      CALL TMTP1
      TEMP2=0
      DO JJ=1,NDIMII
      TEM=COEF(JJ)+(ITZSQ4-ITTSQ4)*.25*COEF0(JJ)
      TEMP2=TEMP2+TEM*TEM
      COEF(JJ)=0
      END DO
      NPRT=NPRT+1
      IF(NPRT.GT.5)IBP=1
      IF(JJJ.NE.0)THEN
      IF(COEF0(JJJ).LT.1.E-20)IZ=1
      END IF
      IF(IBP+IZ.GT.0)GO TO 777
      IF(JJJ.NE.0)TEMP2=TEMP2/COEF0(JJJ)
      IF(TEMP2.GT.PJLIM)GO TO 50
      IF(IOUT.GT.2)WRITE(IDEV,2005)TEMP2
2005  FORMAT(' After T-projection, T**2 was reapplied, and
     1new vector differs in modulus from previous one in',D)
777   RETURN
      END
