C------------------------------------------------------------------------------
C           BADJT 
C------------------------------------------------------------------------------
C  SHELL MODEL - FOR SHELL.FOR
C
C  N SETS OF BAD J,T VALUES
C  SET J1 = -1  TO ASK "BAD J,T VALUES ?"
C        = -2  TO WRITE OUT BAD J,T VALUES (FOR ELEV-SHELL) 
C        = >0  TO TEST IF J,T BAD:  RETURNS N=-1 IF BAD 
C
C  Returning with autoshell N=-1 means bad state
C  N=1,2,3 for ELFIL1, ELFIL2 and ELFIL3

      SUBROUTINE BADJT(N,J1,IT1) 
      LOGICAL EMPTY,ISOSPIN
      character*1 blank
      COMMON/CISOBAB/ISOBAB
      COMMON/RUN/ISOSPIN,ITZNP 
      DIMENSION JTBAD(3,10),NBAD(3) 
      BLANK=' ' 
      IF (J1.GE.0) GO TO 100 
      IF (J1.EQ.-2) GO TO 200 
      IF (N.GT.3) STOP 'ERROR: N>3 IN BADJT' 
      NBAD(N)=0 
CBAB1 IF(ISOSPIN)THEN 
1     IF(ISOBAB.EQ.0)THEN 
      print 5 
      WRITE(50,5) 
CBAB5 FORMAT(' Bad J, T values (2F) (or N for no more) : ',$) 
5     FORMAT(' Bad J, T values (2F) (or <CR> for no more) : ',$) 
csk   READ(5,*,ERR=30) SPIN1,SPIN2 
      CALL FREEFM(EMPTY,SPIN1,SPIN2)
      if (empty) return
      WRITE(51,*) SPIN1,SPIN2
      IF(SPIN1.EQ.0..AND.SPIN2.EQ.0.)RETURN
      IF(SPIN1.EQ.-1.)RETURN
      ELSE 
      print 51 
      WRITE(50,51) 
CBAB51 FORMAT(' Bad J value (1F) (or N for no more) : ',$)
51    FORMAT(' Bad J value (1F) (or <CR> for no more) : ',$) 
csk   READ(5,*,ERR=30)SPIN1 
      CALL FREEFM(EMPTY,SPIN1,SPIN2)
      if (empty) return
      WRITE(51,*) SPIN1,SPIN2
      IF(SPIN1.EQ.0.)RETURN
      IF(SPIN1.EQ.-1.)RETURN
      SPIN2=ABS(ITZNP/2.) 
      END IF 
      GO TO 31 
30    RETURN 
c7     FORMAT(2F) 
31    JAY=SPIN1*2 
      ITT=SPIN2*2 
      NBAD(N)=NBAD(N)+1 
      IF (NBAD(N).GT.10) PAUSE 'ERROR: TOO MANY BAD STATES' 
      JTBAD(N,NBAD(N))=JAY*100+ITT 
      GO TO 1 
C
C   Here with autoshell - test of bad states already stored above
100   IF (NBAD(N).EQ.0) RETURN 
      DO 110 I=1,NBAD(N) 
      JT=J1*100+IT1 
      IF (JTBAD(N,I).EQ.JT) GO TO 115 
110   CONTINUE 
C  Good state
      RETURN 
C  Bad state
115   N=-1 
      RETURN 
C
C  Here for SCHEME.EXE
200   IF (NBAD(N).EQ.0) GO TO 220 
      DO 210 I=1,NBAD(N) 
      JAY=JTBAD(N,I)/100 
      ITT=JTBAD(N,I)-JAY*100 
      SPIN1=JAY/2.0 
      SPIN2=ITT/2.0 
      WRITE(21,208) SPIN1,SPIN2 
208   FORMAT(1X,2F6.1) 
210   CONTINUE 
220   WRITE(21,*) BLANK 
      RETURN 
      END 
