C  SHELL MODEL PROGRAM
C  THIS ROUTINE OPENS THE .EIG AND .PRJ FILES, AND
C  CALCULATES THE E-FUNCTIONS IN THE M-SCHEME BASIS
C  AND WRITES THESE TO DISK.
C
      INCLUDE 'SHGRLIB:MACFOR.INC'
      INCLUDE 'SHGR:PARAM.INC'
      PARAMETER (MAX_EIG=20000,MAX_PMAT=200)
      PARAMETER (MAX_NVEC=1500)
      INCLUDE 'MVECCOM.INC'
      CHARACTER*13 BASF,PRJF,EIGF,REDF,MVECF,SPSF,MVECFILA,MVECFILB
      CHARACTER*9 OPFIL
      CHARACTER*9 FILE_NAME
      CHARACTER*4 FILE_EXT
      REAL SPE_NORM,ME_NORM
      COMMON/CHEAD1/OPFIL(9)
      COMMON/CHEAD/NINT,SPE_NORM(9),ME_NORM(9),ENLI(MAX_NJL,9),
     1ENLIN(MAX_NJL,9),DENL(MAX_NJL)
      DIMENSION IORD(MAX_NPART),NDIMA(MAX_NPART),NBLCK(MAX_NPART)
      DIMENSION IPART(N_WORDS,MAX_NPART)
      CHARACTER*9 EIGFIL,MVFIL,PRJFIL,GNDFIL,MATFIL,MVFILA,MVFILB
      CHARACTER*9 LPTFIL,SPSFIL,BASFIL,INTFIL,BASFL1,ORTFIL,SHELL
      CHARACTER*4 GND2,MVEC2,PRJ2,EIG2,DUD4,MVEC2A,MVEC2B
      INTEGER ZERO(MAX_NLWRDS)
      DIMENSION EVEC(MAX_MSCHEME),EVEC0(MAX_EIG),COEF(MAX_MSCHEME),
     1  ELEV(MAX_NVEC),NJTP(MAX_NPART),IDISK(MAX_NPART),
     1  MNOSC(MAX_NOSC),MXOSC(MAX_NOSC),SHELL(MAX_NJL),
     1  ENL(MAX_NJL),MNFIL(MAX_NJL),MXFIL(MAX_NJL),NOSCJL(MAX_NOSC)
      INCLUDE 'SHGR:DATA.INC'
 
      IF(IFPS.EQ.2) THEN
      OPEN(UNIT=5,FILE='vdat',STATUS='NEW')
      OPEN(UNIT=6,FILE='vwrt',STATUS='OLD')
      ELSE
      END IF
      CALL TEST_BATCH(ILOG)
 
CBAB  ***                    START CLOCK
 
      CALL TIMER('START')
 
      WRITE(6,10)
   10 FORMAT(' Name of .EIG file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      EIGFIL=CHAR_VAR(1)
      NPOS=INDEX(EIGFIL,' ')
      IF(ILOG)WRITE(*,11)EIGFIL(1:NPOS-1)
   11 FORMAT('+',A9,'.EIG')
   13 WRITE(6,14)
   14 FORMAT(' Min and Max no. of vectors reqd. (-1 for all)  : ')
 
CBAB  *** IWRITE ADDED MAY 24 84 TO MAKE FORMATED OUTPUTS
 
      CALL FREE_INT(5,4,INT_VAR,READ_ERR)
      NVMIN=INT_VAR(1)
      NVEC=INT_VAR(2)
      IWRITE_EIG=INT_VAR(3)
      IWRITE_VEC=INT_VAR(4)
      IF (NVMIN.EQ.0.AND.NVEC.EQ.0) NVEC=5
      IF (NVMIN.EQ.0) NVMIN=1
      IF (NVMIN.GT.NVEC) NVEC=NVMIN
      IF(ILOG)WRITE(*,15)NVMIN,NVEC
   15 FORMAT('+',2I4)
      EIG2='.EIG'
      EIGF=EIGFIL//EIG2
      CALL OPEN_FILE(21,EIGFIL,EIG2,'OLD','UFRM')
 
      READ(21) IV,PRJF,MDIM,NJL,(SHELL(I),I=1,NJL),(ENL(I),I=1,NJL),
     1  BASFL1,OPFIL,MATFIL,GNDFIL,GNDE,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1NEIG,ORTFIL,REDF,(NOSCJL(I),I=1,NOSC),NPTCL,
     1NINT,(SPE_NORM(IINT),ME_NORM(IINT),IINT=1,NINT),
     1((ENLIN(I,IINT),I=1,NJL),IINT=1,NINT),(DENL(I),I=1,NJL)
      IF (NVMIN.GT.0) GO TO 16
      NVMIN=1
      NVEC=MDIM
   16 NVEC=MIN0(NVEC,MDIM)
      IF (NEIG.GT.0) NVEC=MIN0(NVEC,NEIG)
      IF(NVEC.GT.MAX_NVEC)STOP ' ***** FATAL ERROR:
     1Increase MAX_NVEC to Max. no. of vectors ***** '
      IF (MDIM.GT.MAX_EIG) GO TO 39
      IF (NVMIN.GT.NVEC) STOP ' ***** FATAL ERROR: NVMIN>NVEC *****'
      READ(21) (ELEV(I),I=1,NVEC)
CEKW      CALL OPEN_FILE(4,EIGFIL,'.LEE','NEW','FORM')
CEKW      WRITE(4,17) NVEC,(ELEV(I),I=1,NVEC)
CEKW   17 FORMAT(1X,I6,/,1000(1X,5F9.3,/))
CEKW      CLOSE(UNIT=4)
      READ(21)
   18 CONTINUE
      CALL NAME_FILE(PRJF,FILE_NAME,FILE_EXT)
      IFORM = 1
      CALL OPENGEN(22,AREA_PROJ,PRJF,IFORM)
      IF(IFORM.EQ.99) WRITE(6,19)
      IF(IFORM.EQ.99) STOP
   19 FORMAT(1X,'*.PRJ file does not exist',/,1X,'TRAMP will
     1 proceed if *.VEC file already exits')
      READ(22) JAY,ITT,NIPART,NSPS,SPSF,BASFIL,BASF,MATDIM,
     1(NJTP(I),I=1,NIPART)
      IF (MDIM.NE.MATDIM) GO TO 35
      IF (BASFL1.NE.BASFIL) WRITE(6,20)
   20 FORMAT(1X,'***** WARNING: DIFFERENT BASIS FILES
     1ARE USED FOR EIG AND PRJ FILES *****')
 
C
CBAB  ***              OPEN MVEC FILE
C
 
   21 CONTINUE
      MVFIL=EIGFIL
      MVEC2='.VEC'
      MVECF=MVFIL//MVEC2
C
CBAB *** ADDED MAY 24 84 TO MAKE FORMATED OUTPUTS
C
      MVFILA=EIGFIL
      MVEC2A='.EIF'
      MVECFILA=MVFILA//MVEC2A
      MVFILB=EIGFIL
      MVEC2B='.VEF'
      MVECFILB=MVFILB//MVEC2B
 
      CALL OPEN_BASIS(1,MVFIL,MVEC2,'NEW',1)
 
      CALL OPEN_FILE(3,MVFIL,'.VEH','NEW','UFRM')
C
CBAB *** ADDED MAY 24 84 TO MAKE FORMATED OUTPUTS
C
      IF(IWRITE_EIG.EQ.1) CALL OPEN_FILE(100,MVFILA,MVEC2A,'NEW',
     1'FORM')
      IF(IWRITE_VEC.EQ.1) CALL OPEN_FILE(101,MVFILB,MVEC2B,'NEW',
     1'FORM')
 
      CALL OPEN_FILE(2,BASFIL,'.INF','OLD','UFRM')
 
      READ(2)SPSF,NJL,(SHELL(I),I=1,NJL),NLWRDS,ZERO,IVERS,
     1(MNFIL(I),I=1,NJL),(MXFIL(I),I=1,NJL),
     1NOSC,(MNOSC(I),I=1,NOSC),(MXOSC(I),I=1,NOSC),
     1(NOSCJL(I),I=1,NOSC),NPTCL,IMZS,ITZS,KPAR,NPART,NSPS
      READ(2)(IORD(I),I=1,NPART)
      READ(2)NWORDS,((IPART(J,I),J=1,NWORDS),I=1,NPART)
      READ(2)(NDIMA(I),I=1,NPART)
      READ(2)(NBLCK(I),I=1,NPART)
 
      NREC=1
 
      WRITE(3)JAY,ITT,NPTCL,NIPART,SPSF,BASFIL,BASF,
     1PRJF,OPFIL,MATFIL,REDF,EIGFIL,IMZS,ITZS,MATDIM,NJL,
     1(ENL(I),I=1,NJL),GNDFIL,GNDE,NEIG,NVEC,NVMIN,KPAR,
     1NINT,(SPE_NORM(IINT),ME_NORM(IINT),IINT=1,NINT),
     1((ENLIN(I,IINT),I=1,NJL),IINT=1,NINT),(DENL(I),I=1,NJL)
 
      WRITE(3) (NJTP(I),I=1,NIPART)
C
CBAB  *** CALC & WRITE WAVEFUNCTIONS IN M-SCHEME BASIS TO DISK
C
      NREC0=1
      DO 33 NV=1,NVEC
      READ(21) (EVEC0(I),I=1,MDIM)
      IF(IWRITE_EIG.EQ.0) GO TO 24
      IF(NV.LT.NVMIN) GO TO 24
      IF(NV.GT.NVEC) GO TO 24
      WRITE(100,22) MDIM,NV,IDUM
   22 FORMAT(1X,10I5)
      WRITE(100,23) (EVEC0(II),II=1,MDIM)
   23 FORMAT(1X,5E12.4)
   24 CONTINUE
      IF (NV.LT.NVMIN) GO TO 33
      REWIND 22
C
CBAB  ***              General information record
C
      READ(22)
      J=0
      DO 32 III=NIPART,1,-1
      NJT=NJTP(III)
      IF (NJT.EQ.0) GO TO 32
      IF(NDIM.GT.MAX_MSCHEME)STOP ' ***** FATAL ERROR:
     1 Increase MAX_MSCHEME *****'
      DO 25 I=1,NDIM
   25 EVEC(I)=0
   26 CONTINUE
      DO 28 JJ=1,NJT
      J=J+1
   27 READ(22)NGD, NDIM,JJJ,(COEF(I),I=1,NDIM)
      DO 28 I=1,NDIM
   28 EVEC(I)=EVEC(I)+EVEC0(J)*COEF(I)
      IF (NV.EQ.NVMIN) IDISK(III)=NREC
 
      WRITE(1,REC=NREC) NV,NVEC,III,NDIM,(EVEC(I),I=1,NLWRDS_BLOCK-4)
      NREC=NREC+1
      IF (NDIM.LE.NLWRDS_BLOCK-4) GO TO 30
      K=NLWRDS_BLOCK-4
   29 WRITE(1,REC=NREC) (EVEC(I),I=K+1,K+NLWRDS_BLOCK)
      NREC=NREC+1
      K=K+NLWRDS_BLOCK
      IF (NDIM.GT.K) GO TO 29
 
   30 IF (K.GT.MAX_MSCHEME) STOP ' ***** FATAL ERROR in MVEC:
     1INCREASE MAX_MSCHEME *****'
 
      IF(IWRITE_VEC.NE.1) GO TO 31
      WRITE(101,22) NDIM,NV,III
      WRITE(101,23) (EVEC(II),II=1,NDIM)
   31 CONTINUE
 
 
   32 CONTINUE
      IF (NV.EQ.NVMIN) NRECS=NREC-NREC0
   33 CONTINUE
 
      WRITE(3)NRECS,(IDISK(I),I=1,NIPART)
      WRITE(3)(ELEV(I),I=NVMIN,NVEC)
 
      CLOSE(UNIT=2)
      CLOSE(1)
      WRITE(6,34)
      CALL TIMER('STOP')
      WRITE(6,34)
   34 FORMAT(1X,' ')
      CALL EXIT
   35 WRITE(6,36)MDIM,MATDIM
   36 FORMAT(' ***** FATAL ERROR: MDIM,MATDIM  :',2I5,' *****')
      STOP
   37 WRITE(6,38)K,ISIZE1
   38 FORMAT(' INCREASE ISIZE1 & ARRAY DIMENSIONS TO',I7,' FROM',I7)
      STOP ' ***** FATAL ERROR *****'
   39 WRITE(6,40)MDIM,ISIZE1
   40 FORMAT(' INCREASE ISIZE1 AND ARRAYS, MDIM, ISIZE1 : ',2I10)
      STOP ' ***** FATAL ERROR *****'
      END
