C  SHELL MODEL PROGRAM JANUARY 1980
C  TO MAKE UP AN OPERATOR FOR TWO-BODY TRANSITION DENSITIES
C  WHICH WILL BE USED IN TRAMP
C
C  THESE ARE DEFINED AS
C
C  [[A+(J1) X A+(J2)]J12,T12  X  [A(J3) X A(J4)]J34,T34]J1234,T1234
C  / SQRT[?
C
C       = SUM OVER  C(IJKL) A+(I) A+(J) A(K) A(L)
C
C  COEFICIENTS C(IJKL) ARE WRITTEN TO DISK FOR J1234 = 0
C  AND A GIVEN T1234, TZ1234
C
C  PARITY CHANGES ARE ALLOWED
C
C
C
C
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      INCLUDE 'tbtdopcom.inc'
      PARAMETER (NSIZE1=2500000)
c     PARAMETER (NSIZE1=300000)
      parameter (nsize3=500)
c      PARAMETER (MAX_NPARTO=5550)
      PARAMETER (MAX_NPARTO=30000)
      PARAMETER (MAX_NTC=3)
      PARAMETER (MAX_NJBAB=11)
      DOUBLE PRECISION CLEB,FN
      CHARACTER*13 SPSF,OP2F
      CHARACTER*9 SPSFIL,OP2FIL
      CHARACTER*4 SPS2,OP22
      DIMENSION COEF(NSIZE1),IBASC(NSIZE1),
     1  IPART(N_WORDS,MAX_NPARTO),JLPA(MAX_NPARTO),
     1  IORD(MAX_NPARTO),
     1 IJLPW(MAX_NPARTO),JMINA(MAX_NTC,MAX_NJBAB),
     1JMAXA(MAX_NTC,MAX_NJBAB),ITCA(2*MAX_NTC),
     2  NPJ(MAX_NJL),NQU(MAX_NJL),LQU(MAX_NJL),JTW(MAX_NJL),
     1       MZTW(MAX_NSPS),ITZTW(MAX_NSPS),JLST(MAX_NJL)
      DIMENSION IPTP1(N_WORDS),IPTP2(N_WORDS),IPTP3(N_WORDS),
     1IPTP4(N_WORDS)
      COMMON/CRAC/IA,IB,IC,ID,IE,IF,CLEB
      COMMON/FIL/ SPSFIL,SPS2,OP2FIL,OP22
      INTEGER ZERO(N_WORDS)
      INCLUDE 'data.inc'
      IPHASE(N)=1-2*IABS(N-2*(N/2))
 
      IF(IFPS.EQ.2) THEN
      OPEN(UNIT=5,FILE='tbdat',STATUS='OLD')
      OPEN(UNIT=6,FILE='tbwrt',STATUS='NEW')
      ELSE
      END IF
      CALL TIMER('START')
 
      ISIZE1=NSIZE1
      DO 10001  I=1,N_WORDS
      ZERO(I)=0
10001 CONTINUE
 
C  GET INPUT INFO
 
      WRITE(6,2)
2     FORMAT(' Single particle state file : ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      SPSFIL=CHAR_VAR(1)
5     WRITE(6,6)
6     FORMAT(' Parity (0=+VE,1=-VE) : ')
      CALL FREE_INT(5,1,INT_VAR,READ_ERR)
      KPAR=INT_VAR(1)
 
      WRITE(6,1)
1     FORMAT(' J, (JZI-JZF) : ')
      CALL FREE_INT(5,2,INT_VAR,READ_ERR)
      JAY=INT_VAR(1)
      JZ=INT_VAR(2)
      JAY = 2*JAY
      JZ = 2*JZ
      IF(JZ.GT.JAY) STOP 'ERROR: JZ>JAY'
 
      WRITE(6,7)
7     FORMAT(' IT, ITZ : ')
      CALL FREE_INT(5,2,INT_VAR,READ_ERR)
      ITT=INT_VAR(1)
      ITZ=INT_VAR(2)
      ITT=ITT*2
      ITZ=ITZ*2
      IF (ITZ.GT.ITT) STOP ' ***** FATAL ERROR: ITZ>ITT *****'
      WRITE(6,8)
8     FORMAT(' The prefered naming convention is SPSABXYP where',
     1/,1X,' SPS is the SPS file name',
     1/,1X,' AB = code for J,JZ (in this version AB = 00)',
     1/,1X,' XY = code for T,TZ',
     1/,1X,' P = parity (0 or 1). The values of A, B, X or Y are',
     1/,1X,' 0 for 0 ',
     1/,1X,' 1 for 1',
     1/,1X,' 2 for 2',
     1/,1X,' A for -1',
     1/,1X,' B for -2',
     1//,1X,' Output filename (A9): ')
      CALL FREE_REAL_A(5,1,CHAR_VAR,0,REAL_VAR,READ_ERR)
      OP2FIL=CHAR_VAR(1)
      SPS2='.sps'
      NPOS=INDEX(SPSFIL,' ')
      IF(NPOS.EQ.0)NPOS=10
      SPSF = SPSFIL(1:NPOS-1)//SPS2
      CALL OPENSPS(24,SPSF,0)
      CALL FREE_INT(24,30,INT_VAR,READ_ERR)
      NSPS=INT_VAR(1)
      NJL=INT_VAR(2)
      NJLPP = NJL + 1
      NSPSP = IABS(NSPS) + 1
C      NJLPP = 10
      DO 13001 I=1,NJL
13001 NPJ(I)=INT_VAR(I+2)
      NOSC=INT_VAR(NJL+3)
15    FORMAT(15I4)
      NSPS=IABS(NSPS)
      IF (NSPS.GT.MAX_NSPS) STOP ' ***** FATAL ERROR: NSPS>MAX_NSPS
     1*****'
      IF (NJL.GT.MAX_NJL) STOP ' ***** FATAL ERROR: NJL>MAX_NJL *****'
      CALL FREE_REAL_A(24,3,CHAR_VAR,0,REAL_VAR,READ_ERR)
      NS=0
      DO 18 I=1,NJL
      JLST(I)=NS+1
      DO 18 JL=1,NPJ(I)
      NS=NS+1
      CALL FREE_INT(24,6,INT_VAR,READ_ERR)
      NQU(I)=INT_VAR(2)
      LQU(I)=INT_VAR(3)
      JTW(I)=INT_VAR(4)
      MZTW(NS)=INT_VAR(5)
      ITZTW(NS)=INT_VAR(6)
18    CONTINUE
 
C  MAKE UP PARTITIONS
C  CAN USE SYMMETRY AND RESTRICT TO CASES WHERE J1>J3, OR J1=J3 & J2> OR =J4
 
      NPART=0
      DO 20 I=1,MAX_NTC
 
      DO 20 IBAB = 1,MAX_NJBAB
      JMINA(I,IBAB)=10000
20    JMAXA(I,IBAB)=-9999
 
      DO 30 JLP1=1,NJL
      CALL LIB_ASSIGNX(ZERO(1),IPTP1(1),N_WORDS)
      IPTP1(JLP1)=1
      JTWP1=JTW(JLP1)
 
      DO 30 JLP2=1,JLP1
      CALL LIB_ASSIGNX(ZERO(1),IPTP2(1),N_WORDS)
      IPTP2(JLP2)=1
      JTWP2=JTW(JLP2)
      JLP12=JLP1*NJLPP+JLP2
      DO 30 JLP3=1,NJL
      CALL LIB_ASSIGNX(ZERO(1),IPTP3(1),N_WORDS)
      IPTP3(JLP3)=1
      JTWP3=JTW(JLP3)
 
      DO 30 JLP4=1,JLP3
      CALL LIB_ASSIGNX(ZERO(1),IPTP4(1),N_WORDS)
      IPTP4(JLP4)=1
      JTWP4=JTW(JLP4)
 
      IF (MOD(LQU(JLP1)+LQU(JLP2)+LQU(JLP3)+LQU(JLP4),2).NE.KPAR)
     1   GO TO 30
      JMIN=0
      JMAX=MAX0(JTWP1+JTWP2,JTWP3+JTWP4)
      IF (JMAX.LT.JMIN) GO TO 30
      NPART=NPART+1
      IF (NPART.GT.MAX_NPARTO) STOP ' ***** FATAL ERROR:
     1NPART>MAX_NPARTO *****'
      JLP34=JLP3*NJLPP+JLP4
      JLPA(NPART)=JLP12*NJLPP*NJLPP+JLP34
      DO 10002  I=1,NJL
      IPART(I,NPART)=IPTP1(I)+IPTP2(I)-IPTP3(I)-IPTP4(I)
10002 CONTINUE
 
C  CALC MAX NO OF INTERMEDIATE COUPLINGS OF CREATION AND DESTRUCTION OPERATORS
 
      NJTC=0
 
      NJBAB = 0
      IJ34MIN = -JAY
      IJ34MAX = JAY
      DO 25 IJ34 = IJ34MIN,IJ34MAX,2
      NJBAB = NJBAB + 1
      IF(NJBAB.GT.MAX_NJBAB) NJBABERR = NJBAB
 
      NTC=0
      DO 25 IT12=0,2,2
      DO 25 IT34=0,2,2
      IF (IT12+IT34.LT.ITT) GO TO 25
      IF (IABS(IT12-IT34).GT.ITT) GO TO 25
      NTC=NTC+1
      IF(NTC.GT.MAX_NTC) NTCERR = 999
      IF(NTCERR.EQ.0) ITCA(2*NTC-1)=IT12/2
      IF(NTCERR.EQ.0) ITCA(2*NTC)=IT34/2
      DO 26 J12=JMIN,JMAX,2
 
      J34 = J12+IJ34
 
      IF(J34.LT.0) GO TO 26
      JTWP2=IABS(JTW(JLP2))
      JTWP1=IABS(JTW(JLP1))
      IF(JTWP1+JTWP2.LT.J12) GO TO 26
      IF(IABS(JTWP1-JTWP2).GT.J12) GO TO 26
      JTWP4=IABS(JTW(JLP4))
      JTWP3=IABS(JTW(JLP3))
      IF(JTWP3+JTWP4.LT.J34) GO TO 26
      IF(IABS(JTWP3-JTWP4).GT.J34) GO TO 26
      IF(J12+J34.LT.JAY) GO TO 26
      IF(IABS(J12-J34).GT.JAY) GO TO 26
 
      IF (JLP1.EQ.JLP2.AND.MOD(J12+IT12,4).NE.2) GO TO 26
      IF (JLP3.EQ.JLP4.AND.MOD(J34+IT34,4).NE.2) GO TO 26
      NJTC=NJTC+1
      IF (J12.LT.JMINA(NTC,NJBAB).AND.(NTCERR.EQ.0)
     1.AND.(NJBABERR.EQ.0)) JMINA(NTC,NJBAB)=J12
      IF (J12.GT.JMAXA(NTC,NJBAB).AND.(NTCERR.EQ.0)
     1.AND.(NJBABERR.EQ.0)) JMAXA(NTC,NJBAB)=J12
 26   continue
25    CONTINUE
 
      IF(NTCERR.NE.0) WRITE(6,900) NTCERR
900   FORMAT(1X,'INCREASE MAX_NTC TO ',I3)
      IF(NTCERR.NE.0) STOP
      IF(NJBABERR.NE.0) WRITE(6,901) NJBABERR
901   FORMAT(1X,'INCREASE MAX_NJBAB TO ',I3)
      IF(NJBABERR.NE.0) STOP
 
30    CONTINUE
 
      IF (NPART.EQ.0) STOP ' ***** FATAL ERROR: NPART=0 *****'
 
      NJTCMX=0
 
      DO 35 IBAB = 1,NJBAB
      DO 35 I=1,NTC
      JMINA(I,IBAB)=JMINA(I,IBAB)/2
      JMAXA(I,IBAB)=JMAXA(I,IBAB)/2
      IF (JMINA(I,IBAB).GT.JMAXA(I,IBAB))
     1 STOP 'ERROR: JMINA>JMAXA'
       NJTCMX=NJTCMX+JMAXA(I,IBAB)-JMINA(I,IBAB)+1
35    CONTINUE
 
C  AFTER NEGATING IORD TO FLAG BEGINNING OF EACH PARTITION
C  NOW ORDER IPART AND THEN ELIMINATE RECURRENCES OF SAME PARTITION
 
      NWORDS=N_WORDS
      CALL ORDER(NPART,IPART,IORD,NWORDS)
      NJLP=NPART
      IORD(1)=-IORD(1)
      NPART=1
      IF (NJLP.EQ.1) GO TO 42
      DO 40 I=2,NJLP
      IF(LIB_EQX(IPART(1,I),IPART(1,NPART),N_WORDS))GOTO 40
      NPART=NPART+1
      CALL LIB_ASSIGNX(IPART(1,I),IPART(1,NPART),N_WORDS)
      IORD(I)=-IORD(I)
40    CONTINUE
 
42    WRITE(6,45)NPART,NJLP,NJTCMX
45    FORMAT(' NO. OF PARTITIONS :',I5/
     1  ' NO. OF J CONFIGURATIONS :',I5/
     1  ' MAX NO. OF INTERMEDIATE COUPLINGS :',I5)
 
C  OPEN OUTPUT FILE
 
      IF(IFPS.EQ.2) THEN
      OP22='.o'
      ELSE
      OP22='.op2'
      END IF
      NPOS=INDEX(OP2FIL,' ')
      IF(NPOS.EQ.0)NPOS=10
      OP2F = OP2FIL(1:NPOS-1)//OP22
      CALL OPEN_FILE(1,OP2FIL,OP22,'NEW','UFRM')
 
      NW=NSIZE3
 
      WRITE(1) IVERS,SPSF,ITT,ITZ,KPAR,NPART,NJLP,NJTCMX,NW,JTW,
     1NTC,NJBAB,JAY,JZ,((JMINA(I,J),I=1,NTC),J=1,NJBAB),
     1((JMAXA(I,J),I=1,NTC),J=1,NJBAB),(ITCA(I),I=1,2*NTC),N_WORDS
      WRITE(1) ((IPART(IW,I),IW=1,N_WORDS),I=1,NPART),(JLPA(I),I=1,NJLP)
     1
C  LOOP OVER PARTITIONS
 
      NTOT=0
      II=NJLP+1
      DO 120 III=NPART,1,-1
      NDIM=0
      NJLPW=0
      IPOS=II-1
      IF (IPOS.LE.0) STOP ' ***** FATAL ERROR: IPOS.LE.0 *****'
      DO 114 II=IPOS,1,-1
      IJLP=IABS(IORD(II))
      NJLPW=NJLPW+1
      IJLPW(NJLPW)=IJLP
      JLP12=JLPA(IJLP)/(NJLPP*NJLPP)
      JLP1=JLP12/NJLPP
      JLP2=JLP12-JLP1*NJLPP
      JLP34=JLPA(IJLP)-JLP12*NJLPP*NJLPP
      JLP3=JLP34/NJLPP
      JLP4=JLP34-JLP3*NJLPP
      JTWP1=IABS(JTW(JLP1))
      JTWP2=IABS(JTW(JLP2))
      JTWP3=IABS(JTW(JLP3))
      JTWP4=IABS(JTW(JLP4))
      JMIN=0
      JMAX=MAX0(JTWP1+JTWP2,JTWP3+JTWP4)
      IF (JMAX.LT.JMIN) STOP ' ***** FATAL ERROR: JMAX<JMIN *****'
      SYMFAC=-1.0
      IF (JLP1.EQ.JLP2) SYMFAC=-SQRT(2.0)
      IF (JLP3.EQ.JLP4) SYMFAC=SQRT(2.0)*SYMFAC
 
C  LOOP OVER DIFFERENT T-COUPLING
 
      NDIMERR = 0
 
      IJ34MIN = -JAY
      IJ34MAX = JAY
      DO 110 IJ34 = IJ34MIN,IJ34MAX,2
      NJBAB = NJBAB + 1
 
      DO 110 IT12=0,2,2
      DO 110 IT34=0,2,2
      IF (IT12+IT34.LT.ITT) GO TO 110
      IF (IABS(IT12-IT34).GT.ITT) GO TO 110
 
C  LOOP OVER DIFFERENT J-COUPLING
 
      DO 100 J12=JMIN,JMAX,2
 
      J34 = J12+IJ34
      IF(J34.LT.0) GO TO 100
      JTWP2=IABS(JTW(JLP2))
      JTWP1=IABS(JTW(JLP1))
      IF(JTWP1+JTWP2.LT.J12) GO TO 100
      IF(IABS(JTWP1-JTWP2).GT.J12) GO TO 100
      JTWP4=IABS(JTW(JLP4))
      JTWP3=IABS(JTW(JLP3))
      IF(JTWP3+JTWP4.LT.J34) GO TO 100
      IF(IABS(JTWP3-JTWP4).GT.J34) GO TO 100
      IF(J12+J34.LT.JAY) GO TO 100
      IF(IABS(J12-J34).GT.JAY) GO TO 100
      IF (JLP1.EQ.JLP2.AND.MOD(J12+IT12,4).NE.2) GO TO 100
      IF (JLP3.EQ.JLP4.AND.MOD(J34+IT34,4).NE.2) GO TO 100
 
      ND1=0
      DO 88 NSP1=JLST(JLP1),NPJ(JLP1)+JLST(JLP1)-1
      M1=MZTW(NSP1)
      ITZ1=ITZTW(NSP1)
      N2MAX=MIN0(NSP1-1,NPJ(JLP2)+JLST(JLP2)-1)
      IF (N2MAX.EQ.0) GO TO 88
 
      DO 86 NSP2=JLST(JLP2),N2MAX
      M2=MZTW(NSP2)
      ITZ2=ITZTW(NSP2)
      M12=M1+M2
      IF (IABS(M12).GT.J12) GO TO 86
 
      M34 = M12-JZ
      IF(IABS(M34).GT.J34) GO TO 86
 
      ITZ12 = ITZ1+ITZ2
      IF (IABS(ITZ12).GT.IT12) GO TO 86
      ITZ34=ITZ12-ITZ
      IF (IABS(ITZ34).GT.IT34) GO TO 86
      IA=JTWP1
      IB=JTWP2
      IC=J12
      ID=M1
      IE=M2
      IF=M12
      CALL CLEBG
      IF (CLEB.EQ.0.0D0) GO TO 86
      CG=CLEB
      IA=1
      IB=1
      IC=IT12
      ID=ITZ1
      IE=ITZ2
      IF=ITZ12
      CALL CLEBG
      IF (CLEB.EQ.0.0D0) GO TO 86
      CG=CG*CLEB
      IBC12=NSP1*NSPSP+NSP2
 
      IA=J12
      IB=J34
      IC=JAY
      ID=M12
      IE=-M34
      IF=JZ
 
      CALL CLEBG
      IF (CLEB.EQ.0.0D0) GO TO 82
      CG=CG*CLEB
      IA=IT12
      IB=IT34
      IC=ITT
      ID=ITZ12
      IE=-ITZ34
      IF=ITZ
      CALL CLEBG
      IF (CLEB.EQ.0.0D0) GO TO 82
      CG12=CG*CLEB
 
      DO 84 NSP3=JLST(JLP3),NPJ(JLP3)+JLST(JLP3)-1
      M3=MZTW(NSP3)
      ITZ3=ITZTW(NSP3)
      N4MAX=MIN0(NSP3-1,NPJ(JLP4)+JLST(JLP4)-1)
      IF (N4MAX.EQ.0) GO TO 84
 
      DO 83 NSP4=JLST(JLP4),N4MAX
      M4=MZTW(NSP4)
      ITZ4=ITZTW(NSP4)
      IF (M3+M4.NE.M34) GO TO 83
      IF (ITZ3+ITZ4.NE.ITZ34) GO TO 83
 
      IA=JTWP3
      IB=JTWP4
 
      IC=J34
      ID=M3
      IE=M4
      IF=M34
      CALL CLEBG
 
      IF (CLEB.EQ.0.0D0) GO TO 83
      CG=CLEB
      IA=1
      IB=1
      IC=IT34
      ID=ITZ3
      IE=ITZ4
      IF=ITZ34
      CALL CLEBG
      IF (CLEB.EQ.0.0D0) GO TO 83
      CG=CG*CLEB
 
      ND1=ND1+1
      NDIM=NDIM+1
      IF (NDIM.GE.ISIZE1) NDIMERR = 1
      IPH=0
      IF (NSP1.LT.NSP3) IPH=IPH+1
      IF (NSP1.LT.NSP4) IPH=IPH+1
      IF (NSP2.LT.NSP3) IPH=IPH+1
      IF (NSP2.LT.NSP4) IPH=IPH+1
      IF(NDIMERR.EQ.0) COEF(NDIM)=SYMFAC*CG12*CG
     1*IPHASE(IPH+(J34-M34+IT34-ITZ34)/2)
      IF(NDIMERR.EQ.0) IBASC(NDIM)=IBC12*NSPSP*NSPSP+NSP3*NSPSP+NSP4
 83   continue
82    CONTINUE
84    CONTINUE
86    CONTINUE
88    CONTINUE
 
C  FLAG END OF EACH WAVEFUNCTION
 
      IF(NDIMERR.EQ.0)IBASC(NDIM)=-IBASC(NDIM)
      ND1MX=MAX0(ND1MX,ND1)
 
      IF (ND1.EQ.0) WRITE(6,90) JLPA(IJLP),IT12,IT34,J12,J34
90    FORMAT(' ND1=0: JLPA(IJLP), IT12, IT34, J12 J34 : ',I12,4I5)
100     CONTINUE
 
110   CONTINUE
      IF (NDIMERR.EQ.1) WRITE(6,7880) ISIZE1,NDIM
7880  FORMAT(1X,'ERROR: INCREASE NSIZE1 FROM ',I9,' TO ',I9,' IN
     1TBTDOP')
      IF (NDIMERR.EQ.1) STOP
      IF (IORD(II).LT.0) GO TO 116
 
114   CONTINUE
      STOP ' ***** FATAL ERROR: AT 114 CONTINUE *****'
 
116   NTOT=NTOT+NDIM
      NDMAX=MAX0(NDMAX,NDIM)
      WRITE(1) III,NDIM,NJLPW,(IJLPW(I),I=1,NJLPW)
      ND=NDIM
      N1=1
      NW=0
118   N1=N1+NW
      IF(ND.EQ.0)GOTO 120
      NW=MIN0(ND,NSIZE3)
      N2=N1+NW-1
      WRITE(1) (COEF(I),I=N1,N2),(IBASC(I),I=N1,N2)
      ND=ND-NW
      IF (ND.GT.0) GO TO 118
 
120   CONTINUE
 
      IF (II.NE.1) STOP ' ***** FATAL ERROR: II#1 *****'
 
      WRITE(6,122)NDMAX,ND1MX,NTOT
122   FORMAT(/' LARGEST PARTITION DIMENSION :',I7/
     1  ' LARGEST DIMENSION FOR GIVEN JJJJ,J12,T12,T34 :',I7/
     1  ' TOTAL DIMENSION :',I8)
13002 FORMAT(1X)
      WRITE(6,13002)
      CALL TIMER('STOP')
      WRITE(6,13002)
      CALL EXIT
      END
 
      SUBROUTINE ORDER(IDIM,IARRAY,IORDER,NWORDS)
      INCLUDE 'macfor.inc'
      INCLUDE 'param.inc'
      DIMENSION IORDER(*),IARRAY(N_WORDS,*),ITEMP(N_WORDS)
      INCLUDE 'data.inc'
C Set up IORDER
      IF(NWORDS.NE.N_WORDS)STOP ' FATAL ERROR in ORDER:
     1 NWORDS.NE.N_WORDS *****'
      DO 5 I=1,IDIM
5     IORDER(I)=I
C Now order numerically
      DO 20 I=1,IDIM
      ISWAP=0
      DO 10 J=1,IDIM-I
      IF(LIB_GEX(IARRAY(1,J+1),IARRAY(1,J),N_WORDS))GOTO 10
      ISWAP=1
      CALL LIB_ASSIGNX(IARRAY(1,J+1),ITEMP(1),N_WORDS)
      CALL LIB_ASSIGNX(IARRAY(1,J),IARRAY(1,J+1),N_WORDS)
      CALL LIB_ASSIGNX(ITEMP(1),IARRAY(1,J),N_WORDS)
      ITEM=IORDER(J+1)
      IORDER(J+1)=IORDER(J)
      IORDER(J)=ITEM
10    CONTINUE
      IF (ISWAP.EQ.0)RETURN
20    CONTINUE
      END
