C LIBRB.FOR
C      FUNCTION YLL(IA,IB,IK)        <L(IA)|| Y(IK)             ||L(IB)>
C      FUNCTION TLLL(IA,IB)          <L(IA)|| L                 ||L(IB)>
C      FUNCTION TYLLL(IA,IB,IK,IKT)  <L(IA)|| [Y(IK)*L]^(IKT)   ||L(IB)>

C      FUNCTION YJJ(I1,I2,L)         <J(I1)|| Y(L)              ||J(I2)>
C      FUNCTION TSIG(IA,IB)          <J(IA)|| SIG               ||J(IB)>
C      FUNCTION TORB(IA,IB)          <J(IA)|| L                 ||J(IB)>

C      FUNCTION TSIGY(IA,IB,IK,IKT)  <J(IA)|| [SIG*Y(IK)]^(IKT) ||J(IB)>
C      FUNCTION TYSIG(IA,IB,IK,IKT)  <J(IA)|| [Y(IK)*SIG]^(IKT) ||J(IB)>
C      FUNCTION TYORB(IA,IB,IK,IKT)  <J(IA)|| [Y(IK)*L]^(IKT)   ||J(IB)>
C      FUNCTION TSIGORB(IA,IB)       <J(IA)|| [SIG*L]^(1)       ||J(IB)>
C      FUNCTION TORBSIG(IA,IB)       <J(IA)|| [L*SIG]^(1)       ||J(IB)>

C                                    Q(K) = SQRT[4PI/(2K+1)] R**K Y(K)
C      FUNCTION TQ(IA,IB,K,B)        <J(IA)|| Q(K)               ||J(IB)>
C      FUNCTION TSIGQ(IA,IB,M,K,L,B) <J(IA)|| R**M [SIG*Q(K)]^(L)||J(IB)>
C      FUNCTION TORBQ(IA,IB,M,K,L,B) <J(IA)|| R**M [ORB*Q(K)]^(L)||J(IB)>
C      FUNCTION TQSIG(IA,IB,M,K,L,B) <J(IA)|| R**M [Q(K)*SIG]^(L)||J(IB)>
C      FUNCTION TQORB(IA,IB,M,K,L,B) <J(IA)|| R**M [Q(K)*ORB]^(L)||J(IB)>

C      FUNCTION RL(I1,I2,L)          <L(I1)| R**L           |L(I2)>
C      FUNCTION XKS(I1,I2)           <L(I1)| kinetic energy |L(I2)>

C      FUNCTION OSCRAD(I1,XR,B)      R(r)/r for orbit I1
C -----------------------------------------------------------------------
C  I n l j

C  1 1 s 1/2 

C  2 1 p 3/2 
C  3 1 p 1/2 

C  4 1 d 5/2 
C  5 1 d 3/2 
C  6 2 s 1/2 

C  7 1 f 7/2  
C  8 1 f 5/2 
C  9 2 p 3/2
C 10 2 p 1/2 

C 11 1 g 9/2
C 12 1 g 7/2 
C 13 2 d 5/2 
C 14 2 d 3/2  
C 15 3 s 1/2 

C 16 1 h 11/2 
C 17 1 h 9/2  
C 18 2 f 7/2 
C 19 2 f 5/2 
C 20 3 p 3/2  
C 21 3 p 1/2 

C 22 1 i 13/2
C 23 1 i 11/2 
C 24 2 g 9/2 
C 25 2 g 7/2  
C 26 3 d 5/2 
C 27 3 d 3/2  
C 28 4 s 1/2 

C 29 1 j 15/2
C -----------------------------------------------------------------------
      FUNCTION YLL(IA,IB,IK)
CBAB THIS IS THE REDUCED ME: <L(IA)|| Y(IK) ||L(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      FPI = 4.*3.14159
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      XK = IK
      X = PAR(XLA)*H(XLA)*H(XLB)*H(XK)/SQRT(FPI)
      Y = TJ(XLA,XK,XLB,0.,0.,0.)
      YLL = X*Y
      RETURN
      END

      FUNCTION TLLL(IA,IB)
CBAB THIS IS THE REDUCED ME: <L(IA)|| L ||L(IB)>
      COMMON/INDEXSK/XL(3,200)
      TLLL = 0.
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      IF(XLA.NE.XLB) RETURN
      TLLL = SQRT(XLA*(XLA+1.)*(2.*XLA+1.))
      RETURN
      END

      FUNCTION TYLLL(IA,IB,IK,IKT)
CBAB THIS IS THE REDUCED ME: <L(IA)|| [Y(IK)*L]^(IKT) ||L(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      XJA = XL(3,IA)
      XJB = XL(3,IB)
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      XKT = IKT
      XK = IK
      X = PAR(XKT+XLA+XLB)*H(XKT)
      Y = SJ(XK,1.,XKT,XLB,XLA,XLB)
      Z = YLL(IA,IB,IK)*TLLL(IA,IB)
      TYLLL = X*Y*Z
      RETURN
      END

      FUNCTION YJJ(I1,I2,L)
CBAB THIS IS THE REDUCED ME:   <J(I1)|| Y(L) ||J(I2)>
      COMMON /INDEXSK/ XL(3,200)
      A1 = XL(2,I1)
      B1 = XL(3,I1)
      A2 = XL(2,I2)
      B2 = XL(3,I2)
      A3 = L
      T = SQRT((2.0*B1+1.0)*(2.0*B2+1.0))
      T = T*SQRT(2.0*A3+1.0)
      EVEN = (1.0+PAR(A1+A2+A3))/2.0
      T = T*EVEN*TJ(B1,A3,B2,-.5,.0,.5)
      YJJ = T*PAR(B2-A1-A2-.5)*0.2820948
      RETURN
      END

      FUNCTION TSIG(IA,IB)
CBAB THIS IS THE REDUCED ME: <J(IA)|| SIG ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      TSIG = 0.
      XLA = XL(2,IA)
      XJA = XL(3,IA)
      XLB = XL(2,IB)
      XJB = XL(3,IB)
      IF(XLA.NE.XLB) RETURN
      X = PAR(XLA+XJA+1.5)*H(XJA)*H(XJB)*SQRT(6.)
      X = X*SJ(0.5,0.5,1.0,XJB,XJA,XLA)
      TSIG = X
      RETURN
      END

      FUNCTION TORB(IA,IB)
CBAB THIS IS THE REDUCED ME: <J(IA)|| L ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      TORB = 0.
      XLA = XL(2,IA)
      XJA = XL(3,IA)
      XLB = XL(2,IB)
      XJB = XL(3,IB)
      IF(XLA.NE.XLB) RETURN
      X = PAR(XLA+XJB+1.5)*H(XJA)*H(XJB)*TLLL(IA,IB)
      X = X*SJ(XLA,XLB,1.,XJB,XJA,0.5)
      TORB = X
      RETURN
      END

      FUNCTION TSIGY(IA,IB,IK,IKT)
CBAB THIS IS THE REDUCED ME: <J(IA)|| [SIG*Y(IK)]^(IKT) ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      XIK = IK
      XIKT = IKT
      TSIGY = PAR(1.+XIK-XIKT)*TYSIG(IA,IB,IK,IKT)
      RETURN
      END

      FUNCTION TYSIG(IA,IB,IK,IKT)
CBAB THIS IS THE REDUCED ME: <J(IA)|| [Y(IK)*SIG]^(IKT) ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      XJA = XL(3,IA)
      XJB = XL(3,IB)
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      XKT = IKT
      XK = IK
      X = H(XJA)*H(XJB)*H(XKT)*SQRT(6.)
      Y = QJ(XLA,.5,XJA,XLB,.5,XJB,XK,1.,XKT)
      Z = YLL(IA,IB,IK)
      TYSIG = X*Y*Z
      RETURN
      END

      FUNCTION TYORB(IA,IB,IK,IKT)
CBAB THIS IS THE REDUCED ME: <J(IA)|| [Y(IK)*L]^(IKT) ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      XJA = XL(3,IA)
      XJB = XL(3,IB)
      XLA = XL(2,IA)
      XLB = XL(2,IB)
      XKT = IKT
      XK = IK
      X = PAR(XLA+.5+XJB+XKT)*H(XJA)*H(XJB)
      Y = SJ(XLA,XLB,XKT,XJB,XJA,0.5)
      Z = TYLLL(IA,IB,IK,IKT)
      TYORB = X*Y*Z
      RETURN
      END

      FUNCTION TSIGORB(IA,IB)
CBAB THIS IS THE REDUCED ME: <J(IA)|| [SIG*L]^(1) ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      TSIGORB = - TORBSIG(IA,IB)
      RETURN
      END

      FUNCTION TORBSIG(IA,IB)
CBAB THIS IS THE REDUCED ME: <J(IA)|| [L*SIG]^(1) ||J(IB)>
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      XLA = XL(2,IA)
      XJA = XL(3,IA)
      XLB = XL(2,IB)
      XJB = XL(3,IB)
      X = H(XJA)*H(XJB)*H(1.)
      Y = QJ(XLA,.5,XJA,XLB,.5,XJB,1.,1.,1.)
      TORBSIG = X*Y*TLLL(IA,IB)*SQRT(6.)
      RETURN
      END

      FUNCTION TQ(IA,IB,K,B)
CBAB THIS IS THE REDUCED ME:   <J(IA)|| Q(K) ||J(IB)>
CBAB WHERE Q(K) = SQRT[4PI/(2K+1)] R**K Y(K)
CBAB B = OSC LENGTH
      COMMON/INDEXSK/XL(3,200)
      FPI = 4.*3.14159
      XK = K
      TQ=SQRT(FPI/(2.*XK+1.))*YJJ(IA,IB,K)*RL(IA,IB,K)*(B**(XK))
      RETURN
      END

      FUNCTION TSIGQ(IA,IB,M,K,L,B)
CBAB THIS IS THE REDUCED ME:   <J(IA)|| R**M [SIG*Q(K)]^(L) ||J(IB)>
CBAB WHERE Q(K) = SQRT[4PI/(2K+1)] R**K Y(K)
CBAB B = OSC LENGTH
      COMMON/INDEXSK/XL(3,200)
      XK = K
      XXL = L
      TSIGQ = PAR(1.+XK-XXL)*TQSIG(IA,IB,M,K,L,B)
      RETURN
      END

      FUNCTION TORBQ(IA,IB,M,K,L,B)
CBAB THIS IS THE REDUCED ME:   <J(IA)|| R**M [ORB*Q(K)]^(L) ||J(IB)>
CBAB WHERE Q(K) = SQRT[4PI/(2K+1)] R**K Y(K)
CBAB B = OSC LENGTH
      COMMON/INDEXSK/XL(3,200)
      XK = K
      XXL = L
      TORBQ = PAR(1.+XK-XXL)*TQORB(IA,IB,M,K,L,B)
      RETURN
      END

      FUNCTION TQSIG(IA,IB,M,K,L,B)
CBAB THIS IS THE REDUCED ME:   <J(IA)|| R**M [Q(K)*SIG]^(L) ||J(IB)>
CBAB WHERE Q(K) = SQRT[4PI/(2K+1)] R**K Y(K)
CBAB B = OSC LENGTH
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      SFPI = SQRT(4.*3.14159)
      XM = M
      XK = K
      TQSIG=(SFPI/H(XK))*TYSIG(IA,IB,K,L)*RL(IA,IB,K+M)*(B**(XM+XK))
      RETURN
      END

      FUNCTION TQORB(IA,IB,M,K,L,B)
CBAB THIS IS THE REDUCED ME:   <J(IA)|| R**M [Q(K)*ORB]^(L) ||J(IB)>
CBAB WHERE Q(K) = SQRT[4PI/(2K+1)] R**K Y(K)
CBAB B = OSC LENGTH
      COMMON/INDEXSK/XL(3,200)
      H(X) = SQRT(2.*X+1.)
      SFPI = SQRT(4.*3.14159)
      XM = M
      XK = K
      TQORB=(SFPI/H(XK))*TYORB(IA,IB,K,L)*RL(IA,IB,M+K)*(B**(XM+XK))
      RETURN
      END

      FUNCTION RL(I1,I2,L)
CBAB THIS IS THE RADIAL ME:   <N(I1)| R**L |N(I2)>
CBAB IN UNITS OF B**L
      COMMON /INDEXSK/ XL(3,200)
      DFACN(X) = DFAC(X)
      PI = 3.14159
      XN1 = XL(1,I1)-1.0
      XL1 = XL(2,I1)
      XN2 = XL(1,I2)-1.0
      XL2 = XL(2,I2)
      XX = L
      X2 = 2.0*XL1+2.0*XN1+1.0
      X3 = 2.0*XL2+2.0*XN2+1.0
      IM = XN1+1.0
      JM = XN2 + 1.0
      S = 0.0
      DO 13 I = 1,IM
      DO 13 J = 1,JM
      XI = I-1
      XJ = J-1
      IF(PAR(XL1+XL2+XX)) 20,20,21
20    X6P = XI+XJ+(XL1+XL2+XX+1.)/2.
21    CONTINUE
      X6 = XL1+XL2+2.0*XI+2.0*XJ+XX+1.0
      X7 = 2.0*XL1+2.0*XI+1.0
      X8 = 2.0*XL2+2.0*XJ+1.0
      T = PAR(XI+XJ)/(FAC(XI)*FAC(XJ))
      IF(PAR(XL1+XL2+XX)) 30,30,31
30    T = T*FAC(X6P)
      XMM = (X6+1.)/2.
      GO TO 32
31    T = T*DFACN(X6)
32    CONTINUE
      T = T/(DFACN(X7)*DFACN(X8)*FAC(XN1-XI)*FAC(XN2-XJ))
      IF(PAR(XL1+XL2+XX)) 40,40,13
40    T = T*(2.**XMM)/SQRT(PI)
13    S = S + T
      S = S*SQRT(DFACN(X2)*DFACN(X3))
      S = S*SQRT(FAC(XN1)*FAC(XN2))
      S = S/SQRT(2.0**(XN1+XN2+XX))
      RL = S
      RETURN
      END

      FUNCTION XKS(I1,I2)
CBAB THIS IS THE RADIAL ME:   <L(I1)| kinetic energy |L(I2)>
CBAB expectation value of the kinetic energy in the oscillator basis
CBAB the results are in units of HBW
      COMMON/INDEXSK/XL(3,200)
      S1 = 0.
      S2 = 0.
      S3 = 0.
      HBW = 10.
      HBSDM = 197.*197./938.
      H = 0.05
      XLL = XL(2,I1)

      DO 200 IR = 2,300
      R = H*IR
      X1 = R*OSCRAD(I1,R,-HBW)
      X2 = R*OSCRAD(I2,R,-HBW)
      RA = R-H
      RB = R
      RC = R+H
      X2A = RA*OSCRAD(I2,RA,-HBW)
      X2B = RB*OSCRAD(I2,RB,-HBW)
      X2C = RC*OSCRAD(I2,RC,-HBW)
      T1 = (X2A+X2C-2.*X2B)/(H*H)
      T2 = XLL*(XLL+1)*X2/(R*R)
      X = -X1*(HBSDM/2.)*(T1-T2)
      S1 = S1 + X*H
      S2 = S2 + X1*X2*H
      S3 = S3 + X1*X2*H*R*R
200   CONTINUE
      XKS = S1/HBW
      RETURN
      END

      FUNCTION PNC(I1,I2)
CBAB THIS IS THE RADIAL ME:   <J(I1)| sigma dot p |J(I2)>
CBAB IN UNITS OF 1/B = SQRT(MW/H)
      COMMON/INDEXSK/XL(3,200)
      XN1 = XL(1,I1)
      XN2 = XL(1,I2)
      XL1 = XL(2,I1)
      XL2 = XL(2,I2)
      XJ1 = XL(3,I1)
      XJ2 = XL(3,I2)
      LL = 1
      PI = 3.14159
      X = PAR(.5+XJ1+XL2)*SJ(XL1,.5,XJ1,.5,XL2,1.)
      X = X*SQRT(6.)*RL(I1,I2,LL)*YLL(I1,I2,LL)*SQRT(4.*PI/3.)
      IF((2.*XN2+XL2).GT.(2.*XN1+XL1)) PNC = X
      IF((2.*XN2+XL2).LT.(2.*XN1+XL1)) PNC = -X
C      print 7777,I1,I2,PNC
C7777  FORMAT(1X,2I3,F10.5)
      RETURN
      END

      FUNCTION OSCRAD(I1,XR,B)
CBAB the function is based on the equation at the bottom of page 40
CBAB in the book of Talmi and deShalit
CBAB OSCRAD = R(r)/r
CBAB they are normalized by Int[R(r) dr] = 1
      COMMON/INDEXSK/XL(3,200)
      F(X,Y) = SQRT(DFAC(2.*X+2.*Y+1.)/FAC(X))/DFAC(2.*Y+1.)
      G(X,Y,Z) = PAR(Z)*BINOM(X,Z)*DFAC(2.*Y+1.)/DFAC(2.*Y+2.*Z+1.)
      HBSDM = 197.*197./938.
      B2 = B*B
CBAB IF B.LT.0. TREAT B AS -HBW
CBAB IF B.LT.0. TREAT B AS B (THE OSCILLATOR LENGTH)
      IF(B.LT.0.) V = -B/HBSDM
      IF(B.GT.0.) V = 1./B2
      XN = XL(1,I1)-1.
      XLL = XL(2,I1)
      CC = V**(.75+XLL/2.)
      XX = F(XN,XLL)
      C = 1.50225*(2.**((XLL/2.)-(XN/2.)))
      IXN = XN+1.
      R = XR
      S = 0.
      DO 21 J = 1,IXN
      XK = J-1
      IF(R.EQ.0..AND.XK.EQ.0.) RRR=1.
      IF(R.EQ.0..AND.XK.NE.0.) RRR=0.
      IF(R.NE.0.) RRR=R**(2.*XK)
21    S = S + (V**XK)*G(XN,XLL,XK)*(RRR)*(2.**XK)
      YY = V*R*R/2.
      IF(R.EQ.0..AND.XLL.EQ.0.) RRR=1.
      IF(R.EQ.0..AND.XLL.NE.0.) RRR=0.
      IF(R.NE.0.) RRR=R**XLL
      SS = XX*EXP(-YY)*S*(RRR)
      SS = SS*C
      OSCRAD = SS*CC
      RETURN
      END

      FUNCTION ELL(I1,I2,K)
CBAB ANOTHER NAME FOR YLL
      ELL = YLL(I1,I2,K)
      RETURN
      END

      FUNCTION EL(I1,I2,L)
CBAB ANOTHER NAME FOR YL
      EL = YJJ(I1,I2,L)
      RETURN
      END
